Attribute VB_Name = "MInterprete"
'Mdulo con las definiciones y funciones generales de la clase Cintrprete
'
'                                            Por Tito Hinostroza 23/08/210
Option Explicit

'Caracteres vlidos como inicial para identificadores
Public Const CAR_VAL_IIDEN = "[$a-zA-Z_]"
'Caracteres vlidos para identificadores (no el inicial)
Public Const CAR_VAL_IDEN = "[$a-zA-Z_0-9]"
'Caracter es vlido para palabras   NO USADO AQU
'Public Const CAR_VAL_PAL = "[a-zA-Z_0-9.$]"

Public Const LON_COM_LIN = 2    'longitud de comenatrio de lnea
Public Const CAD_COM_LIN = "//" 'caracter de comentario de lnea

'Tipos de contenidos
Public Const TC_ARC = 0    'Contenido de tipo archivo
Public Const TC_TXT = 0    'Contenido de tipo texto

'Posicin dentro de un contenido
Type TPosCont
    arc As String       'Nombre de archivo
    fil As Long         'Fila
    col As Integer      'Columna
    linact As String    'Lnea actual
End Type

'Categora de expresiones u operandos
Public Const CAT_OP_VACIO = 0       'Operando nulo
Public Const CAT_OP_VARPUNTO = 1    'Variable Punto
Public Const CAT_OP_VARIABLE = 2
Public Const CAT_OP_FUNCION = 3
Public Const CAT_OP_CONST_NUM = 4
Public Const CAT_OP_CONST_CAD = 5
Public Const CAT_OP_EXPRESION = 6

'Tipos de datos del T
Public Const TIP_DES = 0    'tipo desconocido
Public Const TIP_NUM = 1    'tipo nmero
Public Const TIP_CAD = 2    'tipo cadena
Public Const TIP_MNUM = 11  'tipo matriz unid. nmero
Public Const TIP_MCAD = 12  'tipo matriz unid. cadena

Public Type Texpre   'Tipo expresin
    txt As String    'Texto de la expresin
    tip As Integer   'Tipo de dato que devuelve la expresin
    cat As Integer   'Categora de expresin
    uop As String    'ltimo operador que se ejecut de la expresin
    val As String    'Valor de la expresin
    'Propiedades aplicables a expresiones de tipo variable
    ind As Integer   'ndice de variable, en el arreglo "variables()"
End Type

Public Type Tvar
    nomb As String       'nombre
    tipo As Integer
    valor As String     'valor
End Type

Public Const MAX_NUM_VAR = 400       'se define valor fijo para optimizar

