Attribute VB_Name = "Principal"
'                             Tito's Telnet
'========== Versin 1.22 ==========
'Se mejor la deteccin de prompt.
'Se defini que se puedan abrir varios editores remotos.
'Se mejor la opcin "Guardar copia" del editor remoto, para que no perdiera el nombre del
'archivo remoto al guardar copoa.
'Se cambi el icono del editor remoto para que no se confundiera con el cono del terminal.
'
'
'Modificado por Tito Hinostroza 3/10/2013
'========== Versin 1.21 ==========
'
'Se corrigi una falla con la detencin en la ejecucin de macros.
'Se mejor el manejo de teclado para la ventana de macros.
'Se agreg la opcin para enviar lneas directamente de la ventana de comandos
'usando la combinacin Ctrl+Enter.
'Se agreg cdigos de coloreado para identificar los directorios en un listado ls -l
'
'Modificado por Tito Hinostroza 25/9/2013
'========== Versin 1.2 ==========
'
'Se restaur la prdida del atajo de pegado en el terminal con Shift+Insert.
'Se mejor el control de teclado para que se pueda ingresar comandos en el terminal
'mientras se tiene el cursor en otra parte del terminal.
'Se cambi el nomnbre del men "Configuracin" y se reordenaron sus tems.
'Se agreg el sub-men "Detectar Prompt" al men "Terminal" para configurar automticamente
'la lnea del prompt.
'Se agreg el sub-men "Desconectar" al men "Terminal".
'Se agreg el sub-men "Nueva ventana" en el men "Archivo".
'Se mejor la funcin del botn para detener una macro en curso.
'Se cambi el valor del combo en la ventana de conexin para que muestre la ltima IP usada.
'Se agreg la instruccin "DETECT_PROMPT" en el interprete de macros.
'Se agregaron algunos comandos ms a la sintaxis del editor de comandos.
'
'Modificado por Tito Hinostroza 14/9/2013

'========== Versin 1.12 ==========
'
'Se agreg las opciones de copiado y pegado por Ctrl-C, Ctrl-V.
'Se activ el acceso al modo columna del editor de macros y del terminal, usando Alt-C.
'Se mejor el resaltado de la palabra "error" en el terminal. Ahora se reconcoe "ERROR" y "Error".
'Se agreg cdigo para procesar la respuesta a un salto de lnea cuando el cursor se encuentra
'en la ltima posicin horizontal del terminal.
'
'Modificado por Tito Hinostroza 21/7/2013
'
'========== Versin 1.11 ==========
'
'Se desempolv el Tito's telnet.
'Se incluy el cuadro "Acerca de".
'Se corrigi una falla referente al borrado parcial de la pantalla.
'
'Modificado por Tito Hinostroza 9/6/2013
'
'========== Versin 1.1 ==========
'Basado en el trabajo de "Red Corn": http://www.Planet-Source-Code.com/vb/scripts/ShowCode.asp?txtCodeId=72506&lngWId=1
'Implementa un cliente de TELNET con coloreado de sintaxis y
'automatizacin.
'Constantes de Identificacin del programa
Option Explicit

Public arIni As String          'archivo de configuracin del
Public Const W = vbTab          'Separador general usado para archivos

'Otras propiedades
Public TerMaxLin As Integer     'Lneas a mostrar en terminal
Public Enum TraDir      'tratamiento de las direccionales
    TRA_DIR_NOR = 0     'tratamiento normal
    TRA_DIR_INT = 1     'tratamiento interceptado
End Enum
Public TerTraDir As TraDir

Public recPrompt As Boolean         'Bandera de reconoc. de prompt
Public patPromptIni As String       'Patrn Inicial de prompt para reconocimiento.
Public patPromptFin As String       'Patrn Final de prompt para reconocimiento.
Public Const MAX_NUM_CON = 5        'Mximo nmero de conexiones a guardar
Public conexiones As New Collection 'Guarda las conexiones ms comunes

#Const CopiaEvaluacion = 0          '0-Genera versin Final  1-Genera Copia de Evaluacin
Public Const NOMB_PROG = "Tito's Telnet" 'No usar caracteres raros
Public Const NUM_VERS = "1.22b"      'Versin en nmeros

'------------------------------------------------------------------------
#If CopiaEvaluacion = 0 Then
Public Const NombPrograma = NOMB_PROG & " " & NUM_VERS
#Else
Public Const NombPrograma = NOMB_PROG & " " & NUM_VERS & " - Copia de Evaluacin"
#End If

Public Const LIN_TER_DEF = 3000  'Mximo nmero de lneas del terminal por defecto

Public CarpetaTmp As String     'Carpeta temporal
Public CarpetaMac As String     'Carpeta de macros
Public CarpetaCom As String     'Carpeta de comandos

Public IPact As String          'Direccion IP actual
Public Puerto As Integer
Public archivoCom As String     'Archivo de comandos
Public archivoLog As String     'Archivo de registro
Public MostrarError As Boolean
Public SalirTerm As Boolean     'Salir al terminar procesamiento de comandos
Public Ejecutando As Boolean    'Bandera para ejecucin de macros

Public msjError  As String  'Mensaje de error
Public ultLinea As String   'ltima lnea recibida
Public nLog As Integer      'Manejador de archivo de Registro
Public PausarLog As Boolean 'Bandera para pausar el registro
Public nCaptura As Integer  'Variable donde se captura la salida

Public c As CInterprete     'Intrprete

Public Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)
Public Declare Function GetActiveWindow Lib "user32" () As Long
Public Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Public Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long

Public Function Posit(num As Single) As Single
'Devuelve siempre un nmero positivo o cero.
    If num < 0 Then Posit = 0 Else Posit = num
End Function

Public Function LeerParametros() As Boolean
'Verifica y procesa la linea de comandos. Si no hay lnea de comandos devuelve
'"FALSO".
Dim temp As String
Dim comandos As String
Dim par As String   'Nombre de parmetro
Dim valor As String
Dim i As Integer
    On Error GoTo ErrHandler
    'valores por defecto
    IPact = ""
    archivoCom = ""
    archivoLog = ""
    MostrarError = True
    SalirTerm = False
    'Analiza parmetros
    comandos = Trim(Command())
    If comandos = "" Then
        Exit Function 'sin comandos
    Else    'Hay lnea de comandos
        LeerParametros = True
    End If
    'Hace un pequeo procesamiento sintctico
    c.CreaContenido comandos  'Crea contenido
    'Lee parmetros
    While Not c.FinCont
        Call CogeParametro(par, valor)
        If par <> "" Then   'Parmetro con nombre
            Select Case par
            Case "/NOERROR": MostrarError = False
            Case "/ERROR": MostrarError = True
            Case "/SALIR": SalirTerm = True
            Case "/IP": IPact = valor
            Case "/M": archivoCom = valor
            Case "/L": archivoLog = valor
            Case Else
                MsgBox "Error. Parmetro desconocido: " & par
                End
            End Select
        Else    'Es parmetro sin especificar nombre
            If par Like "*.*.*.*" Then  'Es direccin IP
                IPact = par
            ElseIf UCase(par) Like "*.TTL" Then    'Es archivo de comando
                archivoCom = par
            ElseIf UCase(par) Like "*.LOG" Then    'Es archivo de comando
                archivoLog = par
            Else
                MsgBox "Error en lnea de comandos. No se reconoce: " & par
                MsgBox "Se requiere linea de comandos: " & vbCrLf & _
                        "ttelnet [direccinIP[:puerto]] " & _
                        "[archivo de macro.ttl] [archivo de registro.log] " & vbCrLf & _
                        "[/NOERROR] [/ERROR] [/SALIR] " & _
                        "[/IP=<direccinIP[:puerto]>] " & vbCrLf & _
                        "[M=<archivo de macros>] [L=<archivo de registro>]"
                End
            End If
        End If
    Wend
    'Se terminaron de leer los parmetros
    If archivoLog <> "" Then Call AbrirLog(archivoLog)
    If IPact <> "" Then
        i = InStr(1, IPact, ":")
        If i <> 0 Then
            Puerto = Mid$(IPact, i + 1)
            IPact = Mid$(IPact, 1, i - 1)
        Else
            Puerto = 23
        End If
        frmMain.ConnectToHost IPact, Puerto
        frmMain.Show
    End If
    If archivoCom <> "" Then
        Call EjecutarMacArc(MostrarError)
    End If
    If archivoLog <> "" Then
        archivoLog = "" 'Lipia para que los eventos no intenten escribir luego
        Close #nLog
        nLog = 0        'Marca bandera
    End If
    If SalirTerm Then End   'HAY QUE SALIR
    On Error GoTo 0
    Exit Function
ErrHandler:
    MsgBox Err.Description, vbExclamation
End Function

Public Sub CogeParametro(nombre As String, valor As String)
' Toma un parametro del contenido actual. Todo parmetro debe ser de la forma:
' <valor numrico o cadena>
' o de la forma:
' /<NOMBRE>[=<valor numrico o cadena>]
' o de la forma:
' /<NOMBRE>[:<valor numrico o cadena>]
'Devuelve el nombre del parmetro en la variable "nombre" (siempre en mayscula)
'y su valor en la variable "valor".
Dim tmp As String
    If c.VerCar = "/" Then   'forma explcita
        Call c.CogCar
        nombre = "/" & UCase(c.CogIdentificador())
        tmp = c.CogCar
        If tmp <> "=" And tmp <> ":" Then
            msjError = "Error de Sintaxis": Exit Sub
        End If
        valor = c.CogeElemento()   'Toma el valor
    Else                           'Forma simplificada
        nombre = ""     'No tiene nombre
        valor = c.CogeElemento()
    End If
End Sub

Sub AbrirLog(archivo As String)
    archivoLog = archivo    'actualiza nombre
    If nLog <> 0 Then   'Ya est abierto un "Log"
        Call CerrarLog  'Cierra primero
    End If
    nLog = FreeFile
    Open archivo For Binary Access Write As #nLog
End Sub

Sub CerrarLog()
    If nLog = 0 Then Exit Sub
    Close #nLog
    nLog = 0        'Marca bandera
End Sub
'-----------------------------------------------------------------------
