VERSION 5.00
Begin VB.UserControl ctlEdTelnet 
   ClientHeight    =   1860
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   2790
   ScaleHeight     =   1860
   ScaleWidth      =   2790
   Begin VB.HScrollBar HScroll1 
      CausesValidation=   0   'False
      Height          =   255
      Left            =   0
      TabIndex        =   5
      TabStop         =   0   'False
      Top             =   1200
      Width           =   1935
   End
   Begin VB.VScrollBar VScroll1 
      Height          =   1215
      Left            =   2160
      TabIndex        =   4
      TabStop         =   0   'False
      Top             =   0
      Width           =   255
   End
   Begin VB.PictureBox pic 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1095
      Left            =   180
      OLEDropMode     =   1  'Manual
      ScaleHeight     =   1035
      ScaleWidth      =   1275
      TabIndex        =   3
      Top             =   90
      Width           =   1335
   End
   Begin VB.Timer Timer1 
      Interval        =   100
      Left            =   1755
      Top             =   225
   End
   Begin VB.Label lblEstado3 
      BorderStyle     =   1  'Fixed Single
      BeginProperty Font 
         Name            =   "System"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   300
      Left            =   1800
      TabIndex        =   2
      Top             =   1455
      Width           =   735
   End
   Begin VB.Label lblEstado2 
      BorderStyle     =   1  'Fixed Single
      BeginProperty Font 
         Name            =   "System"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   300
      Left            =   960
      TabIndex        =   1
      Top             =   1455
      Width           =   735
   End
   Begin VB.Label lblEstado1 
      BorderStyle     =   1  'Fixed Single
      BeginProperty Font 
         Name            =   "System"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   300
      Left            =   120
      TabIndex        =   0
      Top             =   1455
      Width           =   615
   End
End
Attribute VB_Name = "ctlEdTelnet"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'Editor adaptado para visualizar la salida del flujo Telnet.
'Realmente es un visor con sintaxis coloreada. No incluye
'funciones de edicin ni "deshacer".
'Se ha optimizado para mejorar la presentacin sin parpadeo. Usa
'un bmp temporal para manejo de su pantalla.
'En pruebas de velocidad de refresco de pantalla en condiciones
'de alto trabajo se obtuvo:
' 50% de uso de CPU con el mtodo de BMP temporal.
' 46% de uso de CPU com el mtodo de envo directo.
'Es decir que solo se tiene una carga adicional de 4% por el uso de
'la memoria temporal.
'
'
'En el desarrollo del programa se han considerado dos tipos de coordenadas:
' *Coordenadas del cursor.- Refrentes a la posicin relativa del cursor con respecto
'  a la pantalla. La esquina superior izquierda es siempre la posicin (1,1). Las
'  variables que se refieren a coordenadas del cursor, son de tipo xc, yc. No se
'  suele usar este tipo de coordenadas, salvo en casos especiales.
'
' *Coordenadas del texto.- Referentes a la posicin relativa de un caracter con
'  respecto al texto completo como si estuviera impreso en una hoja suficientemente
'  grande. El texto se ve con las tabulaciones expandidas. La posicin (1,1) es
'  siempre el primer caracter del texto. Las variables que se refieren a coordenadas
'  del texto, son de tipo xt, yt.
'
'Preferentemente se busca trabajar en pixeles.
'




Option Explicit

Const MAX_ANC_LIN = 32766    'Ancho mximo de lnea en caracteres. < 32767
Const TAM_MAX_UNDO = 1000000 'Tamao mximo de bytes usados en "Deshacer"
Const NAC_MAX_UNDO = 60      'Nmero mximo de acciones "Deshacer"

'Direcciones de ajuste horizontal para posicionar el cursor
Const A_NULO = 0
Const A_IZQ_TAB = 1
Const A_DER_TAB = 2

'Caracteres de desplazamiento por palabra
Const CAR_DESP_PAL = "[a-zA-Z0-9_$'.-]"
Const CAR_IDEN_VALM = "[A-Z0-9_$]"    'caracteres vlidos para identificador (mayscula)

Private Const GMEM_MOVEABLE = 2
Private Const GMEM_DDESHARE = &H2000

Public Event ArchivoSoltado(arc As String)  'Evento para archivo soltado
Public Event MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
Public Event CambiaModo()     'Indica una solicitud de cambio de modo. El editor
                              'lo pide con la tecla ALt-C.
Public Event KeyDown(KeyCode As Integer, Shift As Integer)  'Tecla pulsada
Public Event KeyPress(KeyAscii As Integer)  'Tecla pulsada
Public Event KeyUp(KeyCode As Integer, Shift As Integer)  'Tecla soltada

Public Event LlegoPrompt(nlin1 As Long, nlin2 As Long)  'Ha llegado el prompt al terminal

Private Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, _
                                     ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
'Modos de escritura de BitBlt
Private Const SRCAND = &H8800C6 ' used to determine how a blit will turn out
Private Const SRCCOPY = &HCC0020  ' used to determine how a blit will turn out
Private Const SRCERASE = &H440328 ' used to determine how a blit will turn out
Private Const SRCINVERT = &H660046  ' used to determine how a blit will turn out
Private Const SRCPAINT = &HEE0086   ' used to determine how a blit will turn out

Private Declare Function GetCurrentThread Lib "kernel32" () As Long
Private Declare Function SetThreadPriority Lib "kernel32" (ByVal hThread As Long, ByVal nPriority As Long) As Long
'Constantes para SetThreadPriority
Const THREAD_BASE_PRIORITY_IDLE = -15
Const THREAD_BASE_PRIORITY_LOWRT = 15
Const THREAD_BASE_PRIORITY_MAX = 2
Const THREAD_BASE_PRIORITY_MIN = -2
Const THREAD_PRIORITY_LOWEST = THREAD_BASE_PRIORITY_MIN
Const THREAD_PRIORITY_HIGHEST = THREAD_BASE_PRIORITY_MAX
Const THREAD_PRIORITY_ABOVE_NORMAL = (THREAD_PRIORITY_HIGHEST - 1)
Const THREAD_PRIORITY_BELOW_NORMAL = (THREAD_PRIORITY_LOWEST + 1)
Const THREAD_PRIORITY_IDLE = THREAD_BASE_PRIORITY_IDLE
Const THREAD_PRIORITY_NORMAL = 0
Const THREAD_PRIORITY_TIME_CRITICAL = THREAD_BASE_PRIORITY_LOWRT
Private Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function CreateCompatibleBitmap Lib "gdi32" (ByVal hdc As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long
Private Declare Function GetDeviceCaps Lib "gdi32" (ByVal hdc As Long, ByVal nIndex As Long) As Long
Private Declare Function MoveToEx Lib "GDI32.dll" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, _
                                                    ByRef lpPoint As POINTAPI) As Long
Private Declare Function LineTo Lib "GDI32.dll" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long) As Long
'Private Declare Function Polygon Lib "gdi32" (ByVal hdc As Long, lpPoint As POINTAPI, ByVal nCount As Long) As Long

Private Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Private Declare Function CreatePen Lib "gdi32" (ByVal nPenStyle As Long, ByVal nWidth As Long, ByVal crColor As Long) As Long
Private Declare Function Rectangle Lib "gdi32" (ByVal hdc As Long, ByVal x1 As Long, ByVal y1 As Long, ByVal x2 As Long, ByVal y2 As Long) As Long
Private Declare Function CreateSolidBrush Lib "gdi32" (ByVal crColor As Long) As Long
Private Declare Function FillRect Lib "user32.dll" (ByVal hdc As Long, lpRect As RECT, ByVal hBrush As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long

Private Declare Function CloseClipboard Lib "user32" () As Long
Private Declare Function OpenClipboard Lib "user32" (ByVal hWnd As Long) As Long
Private Declare Function EmptyClipboard Lib "user32" () As Long
Private Declare Function SetClipboardData Lib "user32" (ByVal wFormat As Long, ByVal hMem As Long) As Long

Const CF_TEXT = 1
Const GHND = &H42

Private Declare Function TextOut Lib "gdi32" Alias "TextOutA" ( _
    ByVal hdc As Long, ByVal x As Long, ByVal y As Long, _
    ByVal lpString As String, ByVal nCount As Long) As Long
Private Declare Function SetTextColor Lib "gdi32" (ByVal hdc As Long, ByVal crColor As Long) As Long
Private Declare Function SetTextAlign Lib "gdi32" (ByVal hdc As Long, _
    ByVal wFlags As Long) As Long
  
Const TA_LEFT = 0
Const TA_RIGHT = 2
Const TA_CENTER = 6
Const TA_TOP = 0
Const TA_BOTTOM = 8
Const TA_BASELINE = 24

Private Declare Function MulDiv Lib "kernel32" (ByVal nNumber As Long, ByVal nNumerator As Long, ByVal nDenominator As Long) As Long

Private Const LOGPIXELSY = 90
'constantes para nWeight de createfont()
Private Const FW_DONTCARE = 0
Private Const FW_THIN = 100
Private Const FW_EXTRALIGHT = 200
Private Const FW_LIGHT = 300
Private Const FW_NORMAL = 400
Private Const FW_MEDIUM = 500
Private Const FW_SEMIBOLD = 600
Private Const FW_BOLD = 700
Private Const FW_EXTRABOLD = 800
Private Const FW_HEAVY = 900
Private Const FW_BLACK = FW_HEAVY
Private Const FW_DEMIBOLD = FW_SEMIBOLD
Private Const FW_REGULAR = FW_NORMAL
Private Const FW_ULTRABOLD = FW_EXTRABOLD
Private Const FW_ULTRALIGHT = FW_EXTRALIGHT
'constantes para fdwCharSet
Private Const ANSI_CHARSET = 0
Private Const DEFAULT_CHARSET = 1
Private Const SYMBOL_CHARSET = 2
Private Const SHIFTJIS_CHARSET = 128
Private Const HANGEUL_CHARSET = 129
Private Const CHINESEBIG5_CHARSET = 136
Private Const OEM_CHARSET = 255
'constantes para fdwOutputPrecision
Private Const OUT_CHARACTER_PRECIS = 2
Private Const OUT_DEFAULT_PRECIS = 0
Private Const OUT_DEVICE_PRECIS = 5
'constantes para fdwClipPrecision
Private Const CLIP_DEFAULT_PRECIS = 0
Private Const CLIP_CHARACTER_PRECIS = 1
Private Const CLIP_STROKE_PRECIS = 2
'constantes para fdwQuality
Private Const DEFAULT_QUALITY = 0
Private Const DRAFT_QUALITY = 1
Private Const PROOF_QUALITY = 2
'constantes para fdwPitchAndFamily
Private Const DEFAULT_PITCH = 0
Private Const FIXED_PITCH = 1
Private Const VARIABLE_PITCH = 2

Private Declare Function CreateFont Lib "gdi32" Alias "CreateFontA" (ByVal nHeight As Long, _
            ByVal nWidth As Long, ByVal nEscapement As Long, ByVal nOrientation As Long, _
            ByVal nWeight As Long, ByVal Italic As Long, ByVal underline As Long, _
            ByVal strikeout As Long, ByVal Charset As Long, ByVal OutPutPrecision As Long, _
            ByVal ClipPrecicion As Long, ByVal Quality As Long, ByVal PitchAndFamily As Long, ByVal Face As String) As Long
Private Declare Function SetBkMode Lib "gdi32" (ByVal hdc As Long, ByVal nBkMode As Long) As Long

Private Const TEXT_TRANSPARENT = 1
Private Const TEXT_OPAQUE = 2


'Variables generales
Public archivo As String    'archivo a cargar con el mtodo "CargarArch"
Private jdc As Long          'contexto temporal para dibujar ocultando
Private bmp As Long            'objeto bmp temporal para salida grfica

Public nEspTab As Integer   'nmero de espacios por tabulacin
Public verEstado As Boolean   'Muestra barra de estado del editor
Public verNumLin As Boolean 'Muestra nmero de lnea
Public verDesHor As Boolean 'Muestra barra de desplazamiento horizontal
Public verDesVer As Boolean 'Muestra barra de desplazamiento vertical

Public bloqText As Boolean   'bloquea el texto para modificacin
Private tipSelec As Integer  'tipo de seleccin de texto
'Public tipArch As Integer   'tipo de archivo: 0->DOS 1->UNIX
Public menuContext As Menu  'referencia al men contextual del Editor

Private ancNLinP As Integer 'ancho de la columna de nmero de lneas en pixeles
'Variables de colores de texto
Private mColFonEdi As Long  'color de fondo del control de edicin
Private mColFonSel As Long  'color del fondo de la seleccin

Private mColTxtNor As Long  'color de texto normal
Private mColTxtSel As Long  'color del texto de la seleccin
Private mColFonNli As Long  'color de fondo para nmero de lnea

Private mColTxtCom As Long  'color de comentarios
Private mColTxtCad As Long  'color de constantes cadenas
Private mColPalRes As Long  'color de palabras Reservadas
Private mColPalRes2 As Long  'color de palabras Reservadas
Private mColTxtFun As Long  'color de palabras Reservadas

Public nLin As Long         'nmero de lneas del texto

Private fil1 As Long        'nmero de fila inicial en el control
Private fil2 As Long        'nmero de fila final en el control
Private nfilFin As Long     'nmero de fila final a mostrar en el control
Private maxLinVis As Integer  'mximo nmero de lneas visibles (que caben en la ventana)

Private col1 As Integer       'nmero de columna inicial en el control
Private col2 As Integer       'nmero de columna final en el control
Private maxColVis As Integer  'mximo nmero de columnas visibles (que caben en la ventana)
Private maxTamLin As Integer  'ancho mximo de las lneas

Private pintando As Boolean   'bandera usada por el evento "Paint"
Private Redibujar As Boolean  'bandera que indica que se debe redibujar el control
Private msjError As String    'Mensaje de error

'Variables de manejo de la seleccin
Public haysel As Boolean    'Indica si hay un bloque seleccionado
Private sel1 As Tpostex     'Posicin inicial de la seleccin
Private sel2 As Tpostex     'Posicin final de la seleccin
Private sel0 As Tpostex     'Posicin donde se empieza a marcar la seleccin
Private sel1ant As Tpostex  'sel1 anterior
Private sel2ant As Tpostex  'sel2 anterior

'Variables de manejo del cursor
Private curXt As Integer    'nmero de caracter que apunta el cursor en coord. del texto
Private curYt As Long       'nmero de lnea que apunta el cursor en coord. del texto
Private curXd As Integer     'coordenada X de cursor deseada. Se usa para desplazarse por lneas
Private curXt_ant As Integer 'posicin anterior X del cursor con respecto a la ventana
Private curYt_ant As Long    'posicin anterior Y del cursor con respecto a la ventana
Private curBorrado As Boolean   'Para controlar el parpadeo del cursor

Private xt0 As Integer      'coordenada X de cursor inicial. Usado para seleccin con ratn
Private yt0 As Long         'coordenada Y de cursor inicial. Usado para seleccin con ratn
Private curtmp As Integer   'contador para temporizar el parpadeo del cursor
Private linact As String    'lnea actual completa apuntada por el cursor
Private cursorOn As Boolean 'bandera para activar o desactivar el cursor

Private anccarP As Long     'ancho de caracter en pixeles
Private altcarP As Long     'ancho de caracter en pixeles

'Variables para control de pantalla
Const MAX_LIN_EDI = 100000      'Mxima cantidad de lneas que soporta el editor
Const MAX_LIN_COL = 1000        'Mxima cantidad de lneas que se soportan con coloreado de sintaxis
Private linrea() As String      'texto cargado en el editor en lneas
Private lincol() As TdesLin     'Descripcin de colores de Lneas para grficar
Private deslin() As TDesSeg     'Para manejo de descripcin de lnea

Private pulsadoI As Boolean     'bandera de botn Izquierdo pulsado
Private ultBotPul As Integer    'tlimo botn pulsado
Private facdesV  As Single      'factor de desplazamiento

'Variables de los mtodos grficos
Private tR As RECT, tTR As RECT

Private hPen As Long            'lapz nuevo
Private hBrush As Long          'brocha para el PIC
Private hFont As Long           'fuente
Private ret_pt As POINTAPI      'punto POINTAPI para uso temporal

'Variables para manejo de tabulaciones
Private ptabexp() As Integer    'posiciones de inicio de las tabulaciones en el texto expandido
Private ptabrea() As Integer    'posiciones real de las tabulaciones en el texto

'Variable para el control de la opcin DESHACER
'No se implementa opcin deshacer
Public nUndo As Integer     'Se mantiene por compatibilidad. Aqu no es funcional.

Private ActLimBarDes As Boolean 'Bandera para refrescar

'Variables para el control de la bsqueda
Private PosBus1 As Tpostex  'Posicin inicial del texto buscado.
Private PosBus2 As Tpostex  'Posicin final del texto buscado.
Private CadBus As String    'Cadena de bsqueda
Private CajBus As Boolean   'Bandera de caja para bsqueda
Private PalCBus As Boolean  'Bandera de palabra completa para bsqueda
Private DirBus As Integer   'Direccin de bsqueda
Private PosEnc As Tpostex   'Posicin del texto encontrado. Usado para bsquedas

'Variables para manejo de terminal VT100
'Public Prompt As String     'Prompt del terminal
Public curX         As Integer  'posicin de cursor VT100
Public curY         As Long     'posicin de cursor VT100
Public y0           As Long     'coordenada yt que equivale a x=0 en en VT100
Public curXmax      As Integer  'ancho del terminal (ancho-1)
Public curYmax      As Integer  'alto del terminal (alto-1)

Public nLlegoPrompt As Long     'nmero de lnea donde se detect el ltimo "prompt"
'*************************************************************************************
'********************************FUNCIONES DE BAJO NIVEL******************************
'*************************************************************************************
Private Function Posit(num As Single) As Single
'Devuelve siempre un nmero positivo o cero. Se declara aqu por comodidad
    If num < 0 Then Posit = 0 Else Posit = num
End Function

Public Property Get TipoSelec() As Integer
    TipoSelec = tipSelec
End Property






Public Property Let TipoSelec(ByVal vNewValue As Integer)
    If tipSelec <> vNewValue Then
        
        
        
        
        
        tipSelec = vNewValue
    End If
End Property
'------------Lectura de colores--------------
Public Property Get ColFonEdi() As Long: ColFonEdi = mColFonEdi: End Property
Public Property Get ColFonSel() As Long: ColFonSel = mColFonSel: End Property

Public Property Get ColTxtNor() As Long: ColTxtNor = mColTxtNor: End Property
Public Property Get ColTxtSel() As Long: ColTxtSel = mColTxtSel: End Property
Public Property Get ColFonNli() As Long: ColFonNli = mColFonNli: End Property

Public Property Get ColTxtCom() As Long: ColTxtCom = mColTxtCom: End Property
Public Property Get ColTxtCad() As Long: ColTxtCad = mColTxtCad: End Property
Public Property Get ColPalRes() As Long: ColPalRes = mColPalRes: End Property
Public Property Get ColPalRes2() As Long: ColPalRes2 = mColPalRes2: End Property
Public Property Get ColTxtFun() As Long: ColTxtFun = mColTxtFun: End Property

'------------Escritura de colores--------------
Public Property Let ColFonEdi(ByVal vNewValue As Long)
    If mColFonEdi <> vNewValue Then
        mColFonEdi = vNewValue  'lee nuevo valor
        pic.BackColor = mColFonEdi  'Actualiza color de fondo
    End If
End Property

Public Property Let ColFonSel(ByVal vNewValue As Long): mColFonSel = vNewValue: End Property

Public Property Let ColTxtSel(ByVal vNewValue As Long): mColTxtSel = vNewValue: End Property
Public Property Let ColTxtNor(ByVal vNewValue As Long): mColTxtNor = vNewValue: End Property
Public Property Let ColFonNli(ByVal vNewValue As Long): mColFonNli = vNewValue: End Property

Public Property Let ColTxtCom(ByVal vNewValue As Long): mColTxtCom = vNewValue: End Property
Public Property Let ColTxtCad(ByVal vNewValue As Long): mColTxtCad = vNewValue: End Property
Public Property Let ColPalRes(ByVal vNewValue As Long): mColPalRes = vNewValue: End Property
Public Property Let ColPalRes2(ByVal vNewValue As Long): mColPalRes2 = vNewValue: End Property
Public Property Let ColTxtFun(ByVal vNewValue As Long): mColTxtFun = vNewValue: End Property
'------------------------------------------------
Private Function MaxCol1() As Integer
'Devuelve el mximo valor que puede tomar "col1"
    'Debera ser maxTamLin - maxColVis + 1, pero el cursor
    'se puede mover hasta len(linea)+1.
    MaxCol1 = maxTamLin - maxColVis + 2
    If MaxCol1 < 1 Then MaxCol1 = 1 'proteccin
End Function

Private Function CarXY(xt As Integer, ByVal yt As Long) As String
'Devuelve el caracter de la posicin X,Y de la ventana visible.
'Coordenadas del cursor
Dim lin As String
    'Verifica si escapa de la pantalla
    If xt < col1 Or xt > col2 Then CarXY = " ": Exit Function
    If yt < 1 Or yt > nLin Then CarXY = " ": Exit Function
    'toma lnea afectada
    lin = linexp(yt)
    'Verifica si escapa de la lnea mostrada
    If xt > Len(lin) Then CarXY = " ": Exit Function
    'Toma caracter
    CarXY = Mid$(lin, xt, 1)
End Function

Private Function CarPos(p As Tpostex) As String
'Devuelve el caracter actual de una posicin. Coordenadas de texto
Dim lin As String
Dim xt As Integer
    lin = linrea(p.yt)    'lee primera lnea
    xt = PosXTreal(p.xt, p.yt)
    CarPos = Mid$(lin, xt, 1)
End Function

Private Function CarPosAnt(p As Tpostex) As String
'Devuelve el caracter anterior a una posicin. Coordenadas de texto
'Si el caracter es el primero de una lnea, se devuelve cadena vaca
Dim lin As String
Dim xt As Integer
    lin = linrea(p.yt)    'lee primera lnea
    xt = PosXTreal(p.xt, p.yt)
    If xt <= 1 Then Exit Function    'proteccin
    CarPosAnt = Mid$(lin, xt - 1, 1)
End Function

Private Function CarPosSig(p As Tpostex) As String
'Devuelve el caracter siguiente a una posicin. Coordenadas de texto
'Si el caracter es el ltimo de una lnea, se devuelve cadena vaca
Dim lin As String
Dim xt As Integer
    lin = linrea(p.yt)    'lee primera lnea
    xt = PosXTreal(p.xt, p.yt)
    If xt >= Len(lin) + 1 Then Exit Function    'proteccin
    CarPosSig = Mid$(lin, xt + 1, 1)
End Function

Private Function ColXY(xt As Integer, yt As Long) As Long
'Devuelve el color de la posicin X,Y en la ventana visible
'Coordenadas del cursor
Dim lin() As TDesSeg
Dim i As Integer
Dim pos As Integer
Dim txt As String
    'Verifica si escapa de la pantalla
    If xt < col1 Or xt > col2 Then Exit Function
    If yt < 1 Or yt > nLin Then Exit Function
    'Lee o actualiza el vector de descripcin
    If lincol(yt).tip = TLIN_DES Then
        'Auqnue no es trabajo de ColXY() ver el color
        'Pueda que a veces tenga que hacerlo
        txt = linexp(yt)                'lee toda la lnea
        ActualDescColFil txt, lin(), yt
        lincol(yt).tip = TLIN_MIX
        lincol(yt).seg = lin    'copia descripcin de lnea
    Else    'ya tiene descripcin de segmento
        lin = lincol(yt).seg
    End If
    
    'Explora el vector de descripcin
    '-------Busca segmento de inicio "i"-------
    i = 1   'Se asume que empieza en el segmento 1
    pos = 1
    For i = 1 To UBound(lin)
        pos = pos + lin(i).tam
        If pos > xt Then
            'Este es el segmento que contiene al caracter.
            ColXY = lin(i).col  'toma color
            Exit Function
        End If
    Next
    'Est al final de la lnea, o no hay descripcin
    ColXY = vbBlack
End Function

Private Sub BorCursorXY()
'Borra el cursor de la posicin (curXt_ant, curYt_ant), redibujando
'el caracter XY (coordenadas de cursor) en la pantalla.
Dim car As String
Dim hdc As Long
Dim posX As Long, posY As Long
    'Verifica si cae fuera de la pantalla
    If curYt_ant < fil1 Or curYt_ant > fil2 Then Exit Sub
    hdc = pic.hdc
    posX = anccarP * (curXt_ant - col1)  '+ ancNLinP
    posY = altcarP * (curYt_ant - fil1)
    'primero dibuja fondo para borrar las marcas anteriores
    
    
    
    
        FijaRelleno hdc, mColFonEdi
        FijaLapiz hdc, PS_SOLID, 1, mColFonEdi

    Rectangle hdc, posX, posY, posX + anccarP, posY + altcarP
    'redibuja caracter
    car = CarXY(curXt_ant, curYt_ant)
    SetTextColor hdc, ColXY(curXt_ant, curYt_ant)
    SetTextAlign hdc, TA_LEFT
    TextOut hdc, posX, posY, car, Len(car)
    curBorrado = True   'marca bandera
End Sub

Private Sub DibCursorXY()
'Dibuja el smbolo del cursor en la posicin (curXt, curYt)
'en la pantalla. Actualiza (curXt_ant, curYt_ant)
Dim car As String
Dim hdc As Long
Dim posX As Long, posY As Long
Dim posXfin As Long, posYfin As Long
    posX = anccarP * (curXt - col1)   '+ ancNLinP
    posY = altcarP * (curYt - fil1)
    posXfin = posX + (anccarP - 1)
    posYfin = posY + (altcarP - 1)
    hdc = pic.hdc
    If tipSelec = 1 Then        'Seleccin por columnas
        FijaLapiz hdc, PS_SOLID, 1, vbRed
        Rectangle hdc, posX, posY, posX + 2, posYfin
    Else    'Seleccin normal
        FijaLapiz hdc, PS_SOLID, 1, mColTxtNor
        Rectangle hdc, posX, posY, posX + 2, posYfin
    End If
    curBorrado = False   'marca bandera
    'Actualiza posicin donde se dibuj el cursor
    curXt_ant = curXt
    curYt_ant = curYt
End Sub

'Public Sub XYCursor(X As Long, Y As Long)
''Devuelve coordenadas del cursor en Twips.
'    X = anccar * (curXt - col1 + 1)
'    Y = altcar * (curYt - fil1 + 1)
'End Sub

Private Sub ActivarCursor()
    cursorOn = True
End Sub

Private Sub DesactivarCursor()
'Desactiva el parpadeo del cursor
    'No lo borra, para no interferir con el mtodo de seleccin
    cursorOn = False
End Sub

Public Sub ApagCursor()
'Apaga el cursor en la posicin actual y lo desactiva para parpadeo.
    Call DesactivarCursor
    Call BorCursorXY
End Sub

Public Sub EncenCursor()
'Fuerza a que el cursor aparezca encendido. Activa el parpadeo si es que
'estuviera desactivado
    ActivarCursor       'activa temporizacin de cursor
    curtmp = 0  'para mantener encendico el cursor por 500mseg
    'borra el cursor de la posicin anterior
    Call BorCursorXY
    'Dibuja en la nueva posicin
    Call DibCursorXY
End Sub

Public Function ParentForm() As Form
'Devuelve el formulario padre. Se usa esta funcin para poder prevenir el acceso
'a "Parent" cuando an no est disponible y de paso dar una referencia ms especfica
'como "Form". Si no hay "Parent" definido an, se devuelve "nothing"
    On Error Resume Next
    Set ParentForm = Parent
    On Error GoTo 0
End Function

Private Sub Timer1_Timer()
    
    If ActLimBarDes Then
        Call ActLimitesBarDesp
        Call ActPosicionBarDesp
        ActLimBarDes = False
    End If
    
    'Temporiza el parpadeo del cursor
    If Not cursorOn Then Exit Sub
    curtmp = curtmp + 1     'Lleva la cuenta de 250 mseg
    If curtmp >= 4 Then
        curtmp = 0      'para iniciar otra cuenta de 2 pasos
        If curBorrado Then DibCursorXY Else BorCursorXY
    End If
End Sub

Private Function CursorFueraPantalla() As Boolean
'Verifica si el cursor se encuentra fuera de la pantalla visible
    If curYt < fil1 Or curYt > fil2 Or curXt < col1 Or curXt > col2 Then
        CursorFueraPantalla = True
    End If
End Function

Private Sub FijaCol1(valor As Integer)
'Fija un nuevo valor para "col1" y actualiza "col2". Slo debera cambiarse
'"col1" desde este procedimiento. Equivale a un desplazamiento horizontal sin
'mover el cursor. 'No redibuja
    'Verificaciones de validez
    If valor < 1 Then valor = 1
    If valor > MaxCol1() Then valor = MaxCol1()
    'Asignacin final
    col1 = valor
    col2 = col1 + maxColVis - 1
End Sub

Private Sub ActualizaNLinFin()
'Recalcula la variable "nFilFin".
'Debera llamarse despus de cualquier cambio a "fil1" o si se
'eliminan o aumentan lineas visibles en pantalla
    'valor normal de nfilFin
    nfilFin = fil2
    'valor real de nfilFin si hay menos lneas
    If nfilFin > nLin Then nfilFin = nLin
    'Proteccin por exceso. Limita hasta donde se mueve la pantalla
    If fil1 > nfilFin Then
        fil1 = nfilFin              'Ajusta pantalla
        If fil1 < 1 Then fil1 = 1   'proteccin por debajo
        'ha habido modificacin de fil1, se debe actualizar fil2
        fil2 = fil1 + maxLinVis - 1
    End If
End Sub

Private Sub FijaFil1(valor As Long)
'Fija un nuevo valor para "fil1" y actualiza "fil2". Slo debera cambiarse
'"fil1" desde este procedimiento Equivale a un desplazamiento vertical sin
'mover el cursor. No redibuja
'Desplaza slo en variables. No redibuja
    'verifica validez de desplazamiento
    If valor < 1 Then valor = 1     'limita por arriba
    If valor > nLin Then valor = nLin 'limita
    'Asignacin final
    fil1 = valor
    fil2 = fil1 + maxLinVis - 1
    Call ActualizaNLinFin    'aqu puede cambiar fil1 y fil2
End Sub

Private Sub FijarSel0()
'Fija el punto base de la seleccin, en el punto actual del cursor
    sel0 = LeePosCur()
    sel1 = sel0         'Seleccin sigue al cursor
    sel2 = sel0         'Seleccin sigue al cursor
    sel1ant = sel0      'actualiza anterior
    sel2ant = sel0      'actualiza anterior
End Sub

Private Function LineaEnSel(yt As Long) As Boolean
'Devuelve Verdadero si la linea "yt" est en el bloque de seleccin
    If haysel And sel1.yt <= yt And yt <= sel2.yt Then
        LineaEnSel = True
    Else
        LineaEnSel = False
    End If
End Function

'*****************************************************************************
'*************** FUNCIONES PARA MANEJO DE LA MATRIZ DE LNEAS ****************
'*****************************************************************************
Public Sub LimpiarLineas()
    nLin = 0
    ReDim linrea(0)
    ReDim lincol(0)
    maxTamLin = 1   'Valor inicial
End Sub

Public Property Get linea(i As Long) As String
'Propiedad para devolver el texto de una lnea
    linea = linrea(i)
End Property

Public Property Get nLinActual() As Long
    nLinActual = curYt
End Property

'Private Sub EliminarLineas(pos As Long, nelim As Long)
''Elimina lneas en la matriz de cadenas, desplazando los elementos
'Dim i As Long
'    'protecciones
'    If pos > nLin Then Exit Sub     'a eliminar desde ms alla del texto
'    If nelim > nLin Then Exit Sub   'a eliminar ms de lo que hay
'    If nelim < 1 Then Exit Sub      'a eliminar negativamente
'    'Desplaza elementos
'    For i = pos To nLin - nelim
'        linrea(i) = linrea(i + nelim)
'        lincol(i) = lincol(i + nelim)
'    Next
'    'Actualiza tamao
'    nLin = nLin - nelim
'    ReDim Preserve linrea(nLin)
'    ReDim Preserve lincol(nLin)
'End Sub

Private Sub InsertarLineas(pos As Long, nins As Long)
'Inserta lneas, desplazando los elementos. Las lneas se insertan en blanco.
Dim i As Long
    'protecciones
    If pos > nLin Then Exit Sub
    If nins < 1 Then Exit Sub
    nLin = nLin + nins
    ReDim Preserve linrea(nLin)
    ReDim Preserve lincol(nLin)
    'Desplaza elementos
    For i = nLin To pos + nins Step -1
        linrea(i) = linrea(i - nins)
        lincol(i) = lincol(i - nins)
    Next
End Sub

Public Sub AgregaLinea(lin As String)
'Agrega una lnea al final en el control de texto
Dim tamexp As Integer
    nLin = UBound(linrea) + 1   'actualiza nuevo nmero de lneas
    ReDim Preserve linrea(nLin) 'crea espacio
    ReDim Preserve lincol(nLin) 'crea espacio
    linrea(nLin) = lin      'escribe la nueva lnea
    'actualiza ancho mximo de lnea
    tamexp = Len(LineaFin(lin))
    If tamexp > maxTamLin Then maxTamLin = tamexp
    Call ActualizaNLinFin   'Para dibujar correctamente

End Sub

Public Sub ReinicColEdi()
'Reinicia todas las lneas para que se evale de nuevo el color
Dim i As Long
    For i = 1 To UBound(lincol)
        lincol(i).tip = TLIN_DES
    Next
End Sub

'*****************************************************************************
'***************** FUNCIONES PARA MANEJO DE LAS TABULACIONES *****************
'*****************************************************************************
Private Function linexp(i As Long) As String
'Devuelve la lnea expandida como es vsible, reemplazando las tabulaciones
    linexp = LineaFin(linrea(i))     'expande los tabs
End Function

Public Function LineaFin(txt As String) As String
'Reemplaza la cadena "txt" a como se debe mostrar (reemplaza tabulaciones)
Dim tmp As String
Dim lin() As String
Dim nesp As Integer
Dim i As Integer
    lin = Split(txt, vbTab)       'corta por tabulacines
    For i = 0 To UBound(lin)
        'completa con espacios
        tmp = tmp & lin(i)           'agrega lnea
        If i < UBound(lin) Then 'si no es el ltimo se agrega
            nesp = nEspTab - (Len(lin(i)) Mod nEspTab)  'de 1 a "nEspTab" espacios
            tmp = tmp & String(nesp, " ")   'completa con espacios
        End If
    Next
    LineaFin = tmp
End Function

Public Function posFinTab(x As Integer) As Integer
'Devuelve la posicin inicial (en caracteres) del siguiente caracter
'que sigue a un caracter de tabulacin ubicado en la posicin x
    posFinTab = nEspTab * ((x - 1) \ nEspTab + 1) + 1
End Function

Private Sub ExplorarTabs(yt As Long)
'Explora la lnea "yt", y actualiza las matrices:
' * ptabexp() con las posiciones de inicio de las tabulaciones en el texto expandido.
' * ptabrea() con las posiciones de las tabulaciones en el texto real
' Los ndices de ptabexp() y ptabrea() empiezan en 1
Dim texp As String      'texto expandido
Dim trea As String      'texto real
Dim lin() As String
Dim nesp As Integer
Dim i As Integer
    lin = Split(linrea(yt), vbTab)             'corta por tabulaciones
    If UBound(lin) = -1 Then
        ReDim ptabexp(0)
        ReDim ptabrea(0)
    Else
        ReDim ptabexp(UBound(lin))
        ReDim ptabrea(UBound(lin))
    End If
    For i = 0 To UBound(lin)
        'completa con espacios
        texp = texp & lin(i)                'actualiza lnea
        trea = trea & lin(i) & " "          'actualiza lnea
        If i < UBound(lin) Then             'si no es el ltimo se agrega
            nesp = nEspTab - (Len(lin(i)) Mod nEspTab)  'de 1 a "nEspTab" espacios
            ptabexp(i + 1) = Len(texp) + 1  'guarda posicin de inicio del tab
            texp = texp & String(nesp, " ") 'completa con espacios
            
            ptabrea(i + 1) = Len(trea)
        End If
    Next
End Sub

Public Function PosXTreal(xt As Integer, yt As Long) As Integer
'Devuelve la posicin horizontal real xt (en la cadena sin expandir)
'para la fila "yt" , caracter "xt" en el texto expandido
Dim i As Integer
Dim posIni As Integer
Dim posfin As Integer
Dim posSigCar As Integer
Dim distab As Integer
    '--------------Verifica si hay tabulaciones---------------
    PosXTreal = xt    'valor por defecto
    ExplorarTabs yt   'lee posiciones de tabulacin
    If UBound(ptabexp) = 0 Then 'Si no hay tabulaciones
        Exit Function   'sale con la misma posicin
    End If
    '----------------------------------------------------------
    'Hay al menos una tabulacin. Verifica en que zona
    'de la cadena cae para buscar su posicin real
    '----------------------------------------------------------
    'Verifica para la primera zona
    If xt < ptabexp(1) Then
        PosXTreal = xt    'Ocupa la misma posicin en la cadena real
        Exit Function
    End If
    'Debe estar en las otras zonas
    For i = 1 To UBound(ptabexp)
        'Toma inicio de zona
        posIni = ptabexp(i)
        'Toma fin de zona
        If i < UBound(ptabexp) Then
            posfin = ptabexp(i + 1)
        Else    'Es el tab final
            posfin = Len(linexp(yt)) + 1
        End If
        posSigCar = posFinTab(posIni)
        'Ver si cae en la zon aprohibida de un "tab" en la cadena expandida
        If xt >= posIni And xt < posSigCar Then
            'Est en la zona de la tabulacin expandida
            If xt = posIni Then
                'El cursor est bien ubicado, se inserta antes
                'de la tabulacin
                PosXTreal = ptabrea(i)
                Exit Function
            Else
                'El cursor est en una posicin prohibida
                'Puede ser que se est insertando en modo columnas
                msjError = "Error de ubicacin de cursor"
                PosXTreal = ptabrea(i)   'por ahora se ajusta a la izquierda
                Exit Function
            End If
        'Verifica si cae en el texto despus del tab
        ElseIf xt >= posSigCar And xt < posfin Then
            distab = xt - posSigCar 'distancia a la tabulacin
            PosXTreal = ptabrea(i) + distab + 1
            Exit Function
        End If
    Next
    'Slo debera debera llegar aqu si est al final
    PosXTreal = Len(linrea(yt)) + 1
End Function

Public Function PosXTexp(xt As Integer, yt As Long) As Integer
'Devuelve la posicin horizontal xt en la cadena expandida
'para la fila "yt" , caracter "xt" en el texto real
Dim a() As String
Dim lin As String
    '--------------Verifica si hay tabulaciones---------------
    PosXTexp = xt    'valor por defecto
    If xt <= 1 Then Exit Function   'No puede ser de otra forma
    lin = Left$(linrea(yt), xt - 1) 'lee parte afectada de la lnea
    'La posicin expandida equivale al largo de la cadena
    'afectada expandida.
    PosXTexp = Len(LineaFin(lin)) + 1
End Function

Public Sub TabToSpaces()
'Convierte tabulaciones a espacios en el editor.
Dim i As Long
    For i = 1 To nLin
        linrea(i) = linexp(i)
    Next

End Sub

'*****************************************************************************
'****************** FUNCIONES PARA DESPLAZAMIENTO DEL CURSOR *****************
'*****************************************************************************

Private Function curSigPal() As Long
'Devuelve la posicin del cursor "xt" (en coordenadas de texto) de la siguiente
'palabra en la lnea actual
Dim x As Long
    x = curXt
    If x < 1 Then Exit Function
    'Termina la palabra actual
    While x <= Len(linact) And Mid$(linact, x, 1) Like CAR_DESP_PAL
        x = x + 1
    Wend
    'busca siguiente
    While x <= Len(linact) And Not (Mid$(linact, x, 1) Like CAR_DESP_PAL)
        x = x + 1
    Wend
    curSigPal = x
End Function

Private Function curIniPal() As Long
'Devuelve la posicin del cursor "xt" (en coordenadas de texto) de la
'anterior palabra en la lnea actual
Dim x As Long
    If curXt <= 1 Then Exit Function
    x = curXt
    'busca fin de palabra
    While x > 1 And Not (Mid$(linact, x, 1) Like CAR_DESP_PAL)
        x = x - 1
    Wend
    If x = curXt Then   'ya estaba al inicio de palabra
        x = x - 1   'retrocede
        If x = 0 Then curIniPal = x: Exit Function
        'Busca fin de palabra anterior
        While x > 1 And Not (Mid$(linact, x, 1) Like CAR_DESP_PAL)
            x = x - 1
        Wend
    End If
    'Busca inicio de palabra actual
    While x > 1 And Mid$(linact, x, 1) Like CAR_DESP_PAL
        x = x - 1
    Wend
    If x = 1 Then curIniPal = 1 Else curIniPal = x + 1
End Function

Private Function curIniPal2() As Long
'Devuelve la posicin del cursor "xt" (en coordenadas de texto) del
'inicio de palabra en la posicin actual del cursor
Dim x As Long
    If curXt < 1 Then Exit Function
    x = curXt
    'busca fin de palabra
    If Mid$(linact, x, 1) Like CAR_DESP_PAL Then
        'ya est en medio de palabra
    Else
        'Hay que buscar el inicio
        If x = 1 Then Exit Function 'es el primero
        x = x - 1   'retrocede
        'Busca fin de palabra anterior
        While x > 1 And Not (Mid$(linact, x, 1) Like CAR_DESP_PAL)
            x = x - 1
        Wend
    End If
    'Busca inicio de palabra actual
    While x > 1 And Mid$(linact, x, 1) Like CAR_DESP_PAL
        x = x - 1
    Wend
    If x = 1 Then curIniPal2 = 1 Else curIniPal2 = x + 1
End Function

Private Function curFinPal() As Long
'Devuelve la posicin del cursor "xt" del caracter que sigue al
'fin del identificador que se encuentra bajo el cursor
Dim x As Long
    If curXt < 1 Then Exit Function
    x = curXt
    'Busca fin de palabra actual
    While x < Len(linact) + 1 And Mid$(linact, x, 1) Like CAR_DESP_PAL
        x = x + 1
    Wend
    curFinPal = x   'funciona inclusive en el caso lmite
End Function

Private Function InicioParrafo(yt As Long, xt As Integer) As Boolean
'Indica si una lnea est al inicio de un prrafo para un valor de xt
    If Len(linexp(yt)) >= xt And Len(linexp(yt - 1)) < xt Then
        InicioParrafo = True
    Else
        InicioParrafo = False
    End If
End Function

Private Function FinalParrafo(yt As Long, xt As Integer) As Boolean
'Indica si una lnea est al final de un prrafo para un valor de xt
    If yt = nLin Then   'No hay lnea siguiente
        If Len(linexp(yt)) >= xt Then
            FinalParrafo = True
        Else
            FinalParrafo = False
        End If
    Else                'Hay lnea siguiente
        If Len(linexp(yt)) >= xt And Len(linexp(yt + 1)) < xt Then
            FinalParrafo = True
        Else
            FinalParrafo = False
        End If
    End If
End Function

Private Function EntreParrafos(yt As Long, xt As Integer) As Boolean
'Indica si una lnea est entre dos prrafos para un valor de xt
    If Len(linexp(yt)) < xt Then
        EntreParrafos = True
    Else
        EntreParrafos = False
    End If
End Function

Private Function curIniPar() As Long
'Devuelve la posicin del cursor "yT" (en coordenadas del texto) del inicio
'del parrafo en la posicin actual del cursor o del fin del prrafo anterior
Dim y As Long
    If curYt = 1 Then Exit Function
    y = curYt
    'Verifica si est al inicio de un prrafo
    If InicioParrafo(y, curXt) Then
        'Buscar el fin del prrafo anterior
        y = y - 1
        'Busca fin de prrafo anterior
        While y > 1 And Len(linexp(y)) < curXt
            y = y - 1
        Wend
        curIniPar = y
        Exit Function   'sale
    End If
    'Si est entre prrafos se mueve hasta el fin del anterior
    If EntreParrafos(y, curXt) Then
        While y > 1 And Len(linexp(y)) < curXt
            y = y - 1
        Wend
        curIniPar = y
        Exit Function   'sale
    End If
    'Busca inicio de prrafo actual
    While y > 1 And Len(linexp(y)) >= curXt
        y = y - 1
    Wend
    If y = 1 Then        'lleg al inicio
        curIniPar = y
    Else    'encontr lmite
        y = y + 1
        curIniPar = y
    End If
End Function

Private Function curFinPar() As Long
'Devuelve la posicin del cursor "yt" (en coordenadas del texto) del fin
'del parrafo en la posicin actual del cursor o del inicio del prrafo siguiente
Dim y As Long
    If curYt = nLin Then curFinPar = curYt: Exit Function
    y = curYt
    'Verifica si est al final de un prrafo
    If FinalParrafo(y, curXt) Then
        'Buscar el inicio del prrafo siguiente
        y = y + 1
        'Busca fin de prrafo anterior
        While y < nLin And Len(linexp(y)) < curXt
            y = y + 1
        Wend
        curFinPar = y
        Exit Function   'sale
    End If
    'Si est entre prrafos se mueve hasta el inicio del siguiente
    If EntreParrafos(y, curXt) Then
        While y < nLin And Len(linexp(y)) < curXt
            y = y + 1
        Wend
        curFinPar = y
        Exit Function   'sale
    End If
    'Busca fin de prrafo actual
    While y < nLin And Len(linexp(y)) >= curXt
        y = y + 1
    Wend
    If Not FinalParrafo(y, curXt) Then        'al inicio
        y = y - 1
    End If
    curFinPar = y
End Function

Public Property Let Text(ByRef txt As String)
'Actualiza el contenido del CONTROL
Dim a() As String
Dim i As Integer
    'inicia contenido en 0 lneas
    Call LimpiarLineas
    If txt <> "" Then
        'asignar texto
        a = Split(txt, vbCrLf)
        For i = 0 To UBound(a)
            AgregaLinea a(i)
        Next
    End If
    Call ActualizaNLinFin   'actualiza lneas visibles
    Call ActLimitesBarDesp  'actualiza lmites de Scroll Bar's
    'posicin inicial del cursor
    tCursorA2 maxTamLin, nLin
    Call Dibujar
End Property

Public Property Get Text() As String
'Devuelve el contenido del control
'Devuelve el texto seleccionado.
Dim tip0 As Integer
    tip0 = tipSelec 'guarda tipo de seleccion
    tipSelec = 0    'pone en modo normal para copiar todo
    Text = TextBlo(MinPos, MaxPos)
    tipSelec = tip0 'Restaura tipo de seleccion
End Property

'*****************************************************************************
'******************** FUNCIONES PARA MANEJO DE BLOQUES ***********************
'*****************************************************************************
Private Function LeePosCur() As Tpostex
'Lee la posicin actual de cursor en la variable de posicin pos
    LeePosCur.xt = curXt
    LeePosCur.yt = curYt
End Function

Private Function PosNulo(p As Tpostex) As Boolean
'Indica si una posicin no ha sido iniciada
    PosNulo = (p.xt = 0)
End Function

Private Function MinPos() As Tpostex
'Devuelve la posicin menor del texto en el editor
    If nLin > 0 Then
        MinPos.xt = 1
        MinPos.yt = 1
    End If
End Function

Private Function MaxPos() As Tpostex
'Devuelve la posicin mayor del texto en el editor
    MaxPos.yt = nLin
    If nLin > 0 Then
        MaxPos.xt = Len(linexp(nLin)) + 1
    End If
End Function

Private Function TextPosIni(p1 As Tpostex) As String
'Devuelve la primera lnea del bloque que empieza en la posicin p1.
'Slo debe usarse cuando el bloque tiene ms de una lnea
'Devuelve texto sin expandir
Dim x1r As Integer, y1 As Long
    y1 = p1.yt
    x1r = PosXTreal(p1.xt, y1)
    TextPosIni = Mid$(linrea(y1), x1r)       'copia primera lnea
End Function

Private Function TextPosFin(p2 As Tpostex) As String
'Devuelve la ltima lnea del bloque que termina en la posicin p2.
'Slo debe usarse cuando el bloque tiene ms de una lnea
'Devuelve texto sin expandir
Dim x2r As Integer, y2 As Long
    y2 = p2.yt
    x2r = PosXTreal(p2.xt, y2)
    TextPosFin = Mid$(linrea(y2), 1, x2r - 1)  'copia ltima lnea
End Function

Private Function TextPosLin(p1 As Tpostex, p2 As Tpostex) As String
'Devuelve el texto seleccionado del bloque p1-p2.
'Slo debe usarse cuando el bloque est en una sola lnea.
'Devuelve texto sin expandir
Dim y1 As Long
Dim x1r As Integer, x2r As Integer
    y1 = p1.yt      'igual a p2.yt
    x1r = PosXTreal(p1.xt, y1)
    x2r = PosXTreal(p2.xt, y1)
    TextPosLin = Mid$(linrea(y1), x1r, x2r - x1r)  'copia lnea
End Function

Private Function TextPosCol(yt As Long, xt1 As Integer, xt2 As Integer) As String
'Devuelve el texto intermedio de una lnea en el modo columna
'Para extraer el texto intermedio, se expanden primero las tabulaciones
'y se completan con expacios si la lnea es muy pequea.
'xt1 DEBE SER SIEMPRE menor o igual a xt2
Dim x1 As Integer
Dim x2 As Integer
Dim txt As String
    txt = linexp(yt)    'expande las tabulaciones
    If Len(txt) < xt1 Then   'lnea muy pequea
        TextPosCol = String(xt2 - xt1, " ")  'devuelve espacios
    ElseIf Len(txt) < xt2 - 1 Then 'slo se ve parcialmente
        TextPosCol = Mid$(txt & String(xt2 - 1 - Len(txt), " "), xt1)
    Else    'La lnea es suficientemente grande
        TextPosCol = Mid$(txt, xt1, xt2 - xt1)
    End If
End Function

Private Function TamPosBlo(p1 As Tpostex, p2 As Tpostex) As Long
'Devuelve el tamao de un bloque en bytes. Es eficiente an con bloques grandes
'Toma en cuenta el tipo de seleccin actual
'Para el caso de seleccin por columnas, se considera el texto expandido.
'Para el caso de seleccin normal se da el tamao del texto sin expandir
Dim tam As Long
Dim i As Long
    If UBound(linrea) = 0 Then tam = 0: Exit Function
    If tipSelec = 1 Then        'Seleccin por columnas
        'Para el clculo, se fija un tamao uniforme de seleccin
        tam = Abs(p1.xt - p2.xt) + 2  'caracteres por lnea ms el salto de lnea
        i = (p2.yt - p1.yt + 1)   'nmero de lneas
        TamPosBlo = tam * i - 2        'quita el salto final
        Exit Function
    End If
    'Seleccin por filas
    If p1.yt = p2.yt Then   'Bloque en una sola lnea
        If p1.xt = p2.xt Then tam = 0: Exit Function
        tam = Len(TextPosLin(p1, p2))
    Else                    'Bloque en varias lneas
        tam = Len(TextPosIni(p1))            'tamao primera lnea
        For i = p1.yt + 1 To p2.yt - 1
            tam = tam + 2 + Len(linrea(i))   'considera 2 caracteres del salto
        Next
        tam = tam + 2 + Len(TextPosFin(p2))  'tamao ltima lnea
    End If
    TamPosBlo = tam   'Devuelve
End Function

Private Function BloAMem(tam As Long, p1 As Tpostex, p2 As Tpostex) As Long
'Funcion estrella del programa. Se usa para las opciones del portapapeles y
'para la funcionalidad de "deshacer".
'Hace un volcado rpido de un bloque de texto a Memoria. Puede trabajar
'ficientemente con varios miles de lneas.
'Si hubo error en asignar memoria devuelve 0, de otra forma devuelve el
'manejador del bloque de memoria.
'Actualiza la variable "tam" con el tamao del bloque reservado
Dim nbytes As Long  'Nmero de bytes escritos
Dim f As Long
Dim lpMemory As Long
Dim retval As Long
Dim hData As Long   'Manejador de memoria
Dim cad As String   'Cadena a escribir
Dim xt1 As Integer, xt2 As Integer
Dim xtmp As Integer
    '-----------Copia datos a memoria - Metodo1----------
    'Calcula el tamao total del bloque
    tam = TamPosBlo(p1, p2)
    'Asigna espacio en memoria. Es tam+1 porque se le agregar un NULL a la cadena
    hData = GlobalAlloc(GMEM_MOVEABLE Or GMEM_DDESHARE, tam + 1)
    If hData = 0 Then   'No se pudo encontrar memoria
        BloAMem = 0
        Exit Function
    End If
    'Copiamos la cadena al espacio de memoria reservada
    lpMemory = GlobalLock(hData)    'bloquea mientras copia y obtenemos direccin
    If tipSelec = 1 Then        'Seleccin por columnas
        'Lee coordenadas horizontales
        xt1 = p1.xt: xt2 = p2.xt
        If xt1 > xt2 Then   'Verifica si hay que invertir
            xtmp = xt1: xt1 = xt2: xt2 = xtmp
        End If
        cad = TextPosCol(p1.yt, xt1, xt2) 'Lee parte inicial del bloque
        nbytes = Len(cad)       'tamao sin incluir el NULL final
        retval = lstrcpy(lpMemory, cad)     'Copia incluyendo el NULL final
        lpMemory = lpMemory + nbytes        'apunta al NULL final escrito
        For f = p1.yt + 1 To p2.yt
            cad = vbCrLf & TextPosCol(f, xt1, xt2)
            nbytes = Len(cad)       'tamao sin incluir el NULL final
            retval = lstrcpy(lpMemory, cad) 'Copia incluyendo el NULL final
            lpMemory = lpMemory + nbytes    'apunta al NULL final escrito
        Next
    Else    'Seleccin normal
        If p1.yt = p2.yt Then   'Seleccin de una sola lnea
            'Copia incluyendo el NULL final
            retval = lstrcpy(lpMemory, TextPosLin(p1, p2))
        Else
            'Seleccin de varias lneas
            cad = TextPosIni(p1)        'Lee parte inicial del bloque
            nbytes = Len(cad)           'tamao sin incluir el NULL final
            retval = lstrcpy(lpMemory, cad)     'Copia incluyendo el NULL final
            lpMemory = lpMemory + nbytes        'apunta al NULL final escrito
            For f = p1.yt + 1 To p2.yt - 1
                cad = vbCrLf & linrea(f)
                nbytes = Len(cad)       'tamao sin incluir el NULL final
                retval = lstrcpy(lpMemory, cad) 'Copia incluyendo el NULL final
                lpMemory = lpMemory + nbytes    'apunta al NULL final escrito
            Next
            cad = vbCrLf & TextPosFin(p2)       'Lee parte final del bloque
            retval = lstrcpy(lpMemory, cad)     'Copia incluyendo el NULL final
        End If
    End If
    Call GlobalUnlock(hData)            'desbloquea
    BloAMem = hData     'Devuelve manejador
End Function

Private Property Get TextBlo(p1 As Tpostex, p2 As Tpostex) As String
'Devuelve el texto de un bloque, entre las posiciones p1 y p2, considerando
'el modo de edicin (normal o por columnas).
Dim hData As Long   'Manejador de memoria
Dim lpMemory As Long
Dim nbytes As Long
    'Proteccin
    If p1.xt = p2.xt And p1.yt = p2.yt Then Exit Sub
    'Copia bloque a memoria
    hData = BloAMem(nbytes, p1, p2) 'Copia seleccin a memoria
    If hData = 0 Then
        MsgBox "No se puede obtener seleccin. Error asignando memoria", vbCritical
        Exit Property
    End If
    TextBlo = Space(nbytes + 1)     'crea espacio para contener a la cadena y el NULL
    lpMemory = GlobalLock(hData)    'bloquea mientras copia y obtenemos direccin
    lstrcpy TextBlo, lpMemory        'Copia rpidamente a cadena
    Call GlobalUnlock(hData)        'desbloquea
    TextBlo = Left(TextBlo, Len(TextBlo) - 1)    'Quita NULL final
    GlobalFree hData
    Exit Property
'No se usa el mtodo:
'        For i = .yt To  .yt
'            tmp = tmp & vbCrLf & linrea(i)
'        Next
'Porque es muy lento cuando hay muchas lneas
End Property

Public Property Get TextSel() As String
'Devuelve el texto seleccionado.
    If Not haysel Then Exit Property
    TextSel = TextBlo(sel1, sel2)
End Property

Public Function TextLineas(y1 As Long, y2 As Long) As String
'Devuelve el texto entre dos lneas indicadas
Dim p1 As Tpostex, p2 As Tpostex
    If y1 < 1 Then y1 = 1   'protecin
    If y2 < y1 Then Exit Function
    p1.xt = 1: p1.yt = y1
    p2.xt = Len(linexp(y2)) + 1: p2.yt = y2
    TextLineas = TextBlo(p1, p2)
'No se usa el mtodo:
'        For i = .yt To  .yt
'            tmp = tmp & vbCrLf & linrea(i)
'        Next
'Porque es un poco lento, pero podra usarse si hay inestabilidad.
End Function
'*****************************************************************************
'******************** FUNCIONES DE POSICIONAMIENTO DE CURSOR *****************
'*****************************************************************************

Private Sub AjustaPantalla()
'Ajusta las coordenadas de la pantalla para que sea visible el cursor
'No modifica nada en el caso que el cursor sea visible.
'Actualiza las variables globales "curXt", "curYt"
    'Ubica horizontal
    If curXt < col1 Then
        FijaCol1 curXt
        curXt = col1
    End If
    If curXt > col2 Then
        FijaCol1 curXt - maxColVis + 1
        curXt = col2
    End If
    'Ubica vertical
    If curYt < fil1 Then
        FijaFil1 curYt
        curYt = fil1
    End If
    If curYt > fil2 Then
        FijaFil1 curYt - maxLinVis + 1   'desplaza
        curYt = fil2    'debe actualizarse tambin
    End If
End Sub

Private Sub FijaCursor(ByVal xt As Integer, ByVal yt As Long, _
            Optional ajus_hor As Integer = A_NULO)
'Fija el cursor en la posicin xt, yt.
'Slo permite poner el cursor en una zona vlida del texto (aunque no sea
'visible en la pantalla actual). Si cae fuera del texto lo ajusta a caer dentro.
'No hace desplazamiento de pantalla.
'Actualiza las variables globales "curXt", "curYt" y "linact"
''"ajus_hor" es el ajuste que se desea realizar, puede ser:
'A_NULO ->     Sin ajuste. Puede aparecer en medio de la zona del tab
'A_IZQ_TAB ->  A izquierda cuando hay tabulacin
'A_DER_TAB ->  A derecha cuando hay tabulacin
Dim i As Integer
Dim posSigCar As Integer
    '-----Verifica si hay lneas en el control
    If nLin = 0 Then    'no hace nada, slo posiciona
        curXt = 1: curYt = 1
        linact = ""
        'Muestra estado
        If verEstado Then
            lblEstado2 = "Fil=" & curYt & " Col=" & curXt
        End If
        Exit Sub
    End If
    '-----valida que caiga en una zona vlida del texto
    'calcula y valida "curYt"
    curYt = yt                     'valor inicial
    If curYt < 1 Then curYt = 1    'valida por abajo
    If curYt > nLin Then curYt = nLin  'valida por arriba
    linact = linexp(curYt)          'actualiza lnea actual
    If Len(linact) > maxTamLin Then
        maxTamLin = Len(linact)     'es la lnea mayor
        Call ActLimitesBarDesp      'actualiza barra
    End If
    'calcula y valida "curXt"
    If CLng(xt) > 32767 Then xt = col1  'proteccin
    curXt = xt                      'valor inicial
    If curXt < 1 Then curXt = 1     'valida por abajo
    If curXt > Len(linact) + 1 Then curXt = Len(linact) + 1 'valida por derecha
    '----Realiza los ajustes si se han pedido.
    If ajus_hor <> A_NULO Then  'Hay que realizar ajustes
        'Verifica si cae en posicin prohibida por haber tabulacin
        ExplorarTabs curYt  'lee posiciones de tabulacin
        For i = 1 To UBound(ptabexp)
            'Verifica si cae en la zona prohibida definida por un "tab"
            posSigCar = posFinTab(ptabexp(i))
            If curXt > ptabexp(i) And curXt < posSigCar Then
                If ajus_hor = A_DER_TAB Then
                    curXt = posSigCar   'actualiza "curXt"
                End If
                If ajus_hor = A_IZQ_TAB Then
                    curXt = ptabexp(i)    'actualiza "curXt"
                End If
            End If
        Next
    End If
    'Muestra estado
    If verEstado Then
        lblEstado2 = "Fil=" & curYt & " Col=" & curXt
    End If
End Sub

Private Sub tCursorA(xt As Integer, yt As Long, Optional ajus_hor As Integer = A_IZQ_TAB)
'Funcin similar a FijaCursor(), pero realiza el desplazamiento de
'la pantalla cuando sea necesario para que el cursor siempre aparezca visible
'Actualiza la bandera "Redibujar", cuando se requiere dibujar toda la pantalla.
    FijaCursor xt, yt, ajus_hor      'mueve el cursor
    'verifica si es necesario refrescar la pantalla
    If CursorFueraPantalla Then
        Call AjustaPantalla
        Redibujar = True    'pide que se redibuje
    End If
End Sub

Private Sub tCursorA2(xt As Integer, yt As Long, Optional ajus_hor As Integer = A_IZQ_TAB)
'Versin de tCursorA() que verifica si el cursor queda en una posicin
'horizontal lmite y encuadra la pantalla para que se vea mejor.
'Actualiza la bandera "Redibujar", cuando se requiere dibujar toda la pantalla.
    FijaCursor xt, yt, ajus_hor
    'Verifica si el cursor cae en una zona no visible de la pantalla
    If CursorFueraPantalla Then
        AjustaPantalla
        'Verifica si qued al final de lnea
        If curXt = col2 Then
            FijaCol1 col1 + 12
            AjustaPantalla   'porque puede que se haya ocultado el cursor
                             'y para actualizar curXt
        End If
        'Verifica si cae al inicio
        If curXt = col1 Then
            FijaCol1 col1 - 12  'Intenta desplazar
            AjustaPantalla   'porque puede que se haya ocultado el cursor
                             'y para actualizar curXt
        End If
        Redibujar = True
    End If
End Sub
                        
Private Sub posCursorA(pos As Tpostex, Optional ajus_hor As Integer = A_IZQ_TAB)
'Versin de tCursorA(), pero acepta una posicin de tipo "Tpostex"
    tCursorA pos.xt, pos.yt, ajus_hor
End Sub

Private Sub posCursorA2(pos As Tpostex, Optional ajus_hor As Integer = A_IZQ_TAB)
'Versin de tCursorA2(), pero acepta una posicin de tipo "Tpostex"
    tCursorA2 pos.xt, pos.yt, ajus_hor
End Sub

'Public Sub CursorText(xt As Integer, yt As Long)
''Funcin pblica para fijar la posicin del cursor
'    Redibujar = False
'    tCursorA2 maxTamLin + 1, nLin, A_IZQ_TAB    'para encuadrar desde arriba
'    Call tCursorA2(xt, yt)
'    curXd = curXt     'actualiza posicin deseada
'    Call LimpSelec(True)      'Limpia seleccin
'    'Marca la posicin del cursor antes de una seleccin
'    Call FijarSel0      'Fija punto base
'    Call EncenCursor    'Enciende para que sea visible en la nueva posicin
'    If Redibujar Then Call Refrescar
'End Sub

Public Sub SelectHasta(xt As Integer, yt As Long)
'Funcin pblica para fijar el fin de una seleccin. Se debe habe definido el inicio
'con CursorText
    tCursorA2 xt, yt
    Call ExtenderSel 'Extiende seleccin
End Sub

'*****************************************************************************
'******************** FUNCIONES DE DIBUJO DEL TEXTO  *****************
'*****************************************************************************

Private Sub LeerXPosSel(x1 As Long, x2 As Long)
'Devuelve las coordenadas horizontales x1 y x2 del bloque de seleccin
'a mostrar en pantalla. Devuelve en de pixeles
    'Calcula posicin horizontal de inicio y fin de bloque
    x1 = (sel1.xt - col1) * anccarP
    If x1 < 0 Then x1 = 0
    If x1 > ScaleWidth Then x1 = ScaleWidth
    x2 = (sel2.xt - col1) * anccarP - 1   'incluye slo el recuadro del caracter no el siguiente
    If x2 < 0 Then x2 = 0
    If x2 > ScaleWidth Then x2 = ScaleWidth
End Sub

Private Sub LeerXCurSel(xc1 As Integer, xc2 As Integer)
'Devuelve las coordenadas horizontales xc1 y xc2 del bloque de seleccin
'a mostrar en pantalla. Devuelve en coordenadas de Cursor.
'xc1 es la posicin del caracter en la lnea donde se inicia la seleccin y
'xc2 es la posicin del caracter en la lnea donde termina la seleccin.
    'Calcula posicin horizontal de inicio y fin de bloque
    xc1 = sel1.xt - col1 + 1
    If xc1 < 1 Then xc1 = 1
    If xc1 > maxColVis Then
        xc1 = maxColVis
    End If
    xc2 = sel2.xt - col1 + 1  'incluye slo el recuadro del caracter no el siguiente
    If xc2 < 1 Then xc2 = 1
    If xc2 > maxColVis Then
        xc2 = maxColVis
    End If
End Sub

Private Sub DibBloFonC(yc As Long, xc1 As Integer, xc2 As Integer, col_fon As Long)
'Dibuja un recuadro relleno con color "col_fon". Las coordenadas son de cursor
Dim xp1 As Long, xp2 As Long
Dim yp As Long
    'Valida parmetros
'    If xc2 < 1 Then Exit Sub
'    If xc1 < maxColVis Then Exit Sub
    If xc1 < 1 Then xc1 = 1
    If xc2 > maxColVis + 1 Then xc2 = maxColVis + 1
    'Convierte a pixeles
    xp1 = (xc1 - 1) * anccarP '+ ancNLinP
    xp2 = (xc2 - 1) * anccarP '+ ancNLinP
    yp = (yc - 1) * altcarP 'actualiza coordenada vertical
    FijaRelleno jdc, col_fon
    FijaLapiz jdc, PS_SOLID, 1, col_fon
    If xp2 = xp1 Then xp2 = xp2 + 2     'para que sea visible la seleccin de 0 columnas
    Rectangle jdc, xp1, yp, xp2, yp + altcarP
End Sub

Private Sub cierraSegm(lin() As TDesSeg, i As Integer, _
                       pfin As Long, col As Long, tip As Integer)
'Cierra un segmento de texto y actualiza "pfin".
'"n" es el tamao actual de la matriz. El segmento a cerrar llega hasta "i-1"
'"pfin" es la posicin de fin del bloque anterior
Dim n As Integer
    If i > pfin + 1 Then  'hay segmento antes?
        n = UBound(lin) + 1
        ReDim Preserve lin(n)
        lin(n).tam = i - pfin - 1
        pfin = i - 1  'actualiza el limite
        lin(n).col = col    'texto normal
        lin(n).tip = tip    'asigna tipo
    End If
End Sub

Private Sub cierraSegm1(lin() As TDesSeg, i As Integer, _
                        pfin As Long, col As Long, tip As Integer)
'Similar a cierraSegm() pero considera que el segmento llega hasta "i"
Dim n As Integer
    If i > pfin + 1 Then   'hay segmento antes?
        n = UBound(lin) + 1
        ReDim Preserve lin(n)
        lin(n).tam = i - pfin
        pfin = i   'actualiza el limite
        lin(n).col = col    'color de texto
        lin(n).tip = tip    'asigna tipo
    End If
End Sub

Private Function cierraSegmId(lin() As TDesSeg, i As Integer, _
                       pfin As Long, col As Long, tip As Integer, _
                       tmp As String, iden As String, largo As Integer) As Boolean
'Cierra un segmento y crea uno nuevo, basado siempre que se encuentre
'un identificador en la cadena "tmp" a partir de la posicin "i".
    If Mid$(tmp, i, largo) = iden And Not (UCase(Mid$(tmp, i + largo, 1)) Like CAR_IDEN_VALM) Then
        cierraSegm lin(), i, pfin, col, tip   'cierra anterior
        i = i + largo - 1   'adelanta el ndice, se adelantar 1 en el "for"
        'crea segmento de palabra reservada
        cierraSegm1 lin(), i, pfin, mColPalRes, TSEG_PRS
        
        cierraSegmId = True 'indica que se encontr segmento
    Else
        cierraSegmId = False
    End If
End Function

Private Function cierraSegmId2(lin() As TDesSeg, i As Integer, _
                       pfin As Long, col As Long, tip As Integer, _
                       tmp As String, iden As String, largo As Integer) As Boolean
'Igual a "cierraSegmId", pero para el segundo grupo de palabras reservadas
    If Mid$(tmp, i, largo) = iden And Not (Mid$(tmp, i + largo, 1) Like CAR_IDEN_VALM) Then
        cierraSegm lin(), i, pfin, col, tip   'cierra anterior
        i = i + largo - 1   'adelanta el ndice, se adelantar 1 en el "for"
        'crea segmento de palabra reservada
        cierraSegm1 lin(), i, pfin, mColPalRes2, TSEG_PRS2
        
        cierraSegmId2 = True 'indica que se encontr segmento
    Else
        cierraSegmId2 = False
    End If
End Function

Private Sub AnalizarIdentificador(c As String, tmp As String, _
                        lin() As TDesSeg, i As Integer, _
                        pfin As Long, colseg As Long, tipseg As Integer)
'Analiza los identificadores en busca de palabras reservadas
    Select Case c
    Case "a"
        If cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "awk", 3) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        End If
    Case "b"
        If cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "banner", 6) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "break", 5) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        End If
    Case "c"
        If cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "cal", 3) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "case", 4) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "cat", 3) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "cd", 2) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "chgrp", 5) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "chmod", 5) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "continue", 8) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "cp", 2) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "crontab", 7) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        End If
    Case "d"
        If cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "date", 4) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "df", 2) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "do", 2) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "done", 4) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "du", 2) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "dr", 2) Then  'lista de archivos con directorio
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "drw", 3) Then  'lista de archivos con directorio
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "drwx", 4) Then  'lista de archivos con directorio
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "drwxr", 5) Then  'lista de archivos con directorio
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "drwxrwxr", 8) Then  'lista de archivos con directorio
            tipseg = TSEG_DES    'prepara tipo siguiente
        End If
    Case "E"
        If cierraSegmId2(lin(), i, pfin, colseg, tipseg, tmp, "ERROR", 5) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId2(lin(), i, pfin, colseg, tipseg, tmp, "Error", 5) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        End If
    Case "e"
        If cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "echo", 4) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "elif", 4) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "else", 4) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId2(lin(), i, pfin, colseg, tipseg, tmp, "error", 5) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "esac", 4) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "exit", 4) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "expr", 4) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        End If
    Case "f"
        If cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "fi", 2) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "fcopy", 5) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "for", 3) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "format", 6) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "ftp", 3) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        End If
    Case "g"
        If cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "grep", 4) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        End If
    Case "h"
        If cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "head", 4) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        End If
    Case "i"
        If cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "id", 2) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "if", 2) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "in", 2) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        End If
    Case "j"
        If cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "join", 4) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        End If
    Case "k"
        If cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "kill", 4) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        End If
    Case "l"
        If cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "ln", 2) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "ls", 2) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        End If
    Case "m"
        If cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "man", 3) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "mail", 4) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "mkdir", 5) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "mv", 2) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        End If
    Case "n"
        If cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "nawk", 4) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        End If
    Case "p"
        If cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "passwd", 6) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "ping", 4) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "ps", 2) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "pwd", 3) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        End If
    Case "r"
        If cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "read", 4) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "rm", 2) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "rmdir", 5) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        End If
    Case "s"
        If cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "sleep", 5) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "sort", 4) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        End If
    Case "t"
        If cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "tail", 4) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "tar", 3) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "telnet", 6) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "then", 4) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "top", 3) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "tty", 3) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        End If
    Case "u"
        If cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "uname", 5) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "until", 5) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "uniq", 4) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        End If
    Case "v"
        If cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "vi", 2) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "vmstat", 6) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        End If
    Case "w"
        If cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "wc", 2) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "while", 5) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "who", 3) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "write", 5) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        End If
    End Select

End Sub

Private Sub ActualDescColFil(txt As String, lin() As TDesSeg, yt As Long)
'Actualiza el vector descriptor de segmentos de una fila.
'Sirve para facilitar el anlisis semntico y el coloreado de sintaxis.
'Solo soporta filas menores a 32767 caracteres. Requiere "yt" para anlisis de "prompt".
Dim pfin As Long  'posicin de fin de bloque
Dim i As Integer, n As Integer, j As Integer
Dim colseg As Long      'color de segmento
Dim tipseg As Integer   'tipo de segmento
Dim buscafincad1 As Boolean
Dim buscafincad2 As Boolean
Dim c As String
Dim IniIden As Boolean  'bandera de inicio de identificador
    'n = 0   'nmero de elementos de la matriz
    ReDim lin(0)
    If txt = "" Then Exit Sub
    colseg = mColTxtNor    'inicia color de segmento
    tipseg = TSEG_NOR
    pfin = 0    'Posicin del caracter final del bloque
'    tmp = UCase(txt)    'La comparacin se hace ignorando la caja
'    tmp = txt           'La comparacin se hace considerando la caja
    IniIden = True      'El inicio de la lnea es inicio de identificador
    'Verifica si es prompt. Slo se verifica una vez al inicio.
    If recPrompt Then
        i = InStr(txt, patPromptFin)
        If i > 0 And patPromptIni = Left$(txt, Len(patPromptIni)) Then
            cierraSegm lin(), 1, pfin, colseg, tipseg      'cierra anterior
            cierraSegm1 lin(), i, pfin, mColPalRes2, TSEG_PRS2   'cierra
            j = i
            If yt <> nLlegoPrompt Then
                RaiseEvent LlegoPrompt(nLlegoPrompt, yt)
                nLlegoPrompt = yt
            End If
        Else
            j = 1
        End If
    Else
        j = 1
    End If
    For i = j To Len(txt)
        c = Mid$(txt, i, 1)    'caracter i
        If buscafincad1 Then   'Estamos dentro de una constante de cadena
            If c = """" Then
                'se toma hasta i para incluir las comillas
                cierraSegm1 lin(), i, pfin, mColTxtCad, TSEG_CAD   'cierra
                buscafincad1 = False     'Marca fin de constante cadena
            End If
        ElseIf buscafincad2 Then   'Estamos dentro de una constante de cadena
            If c = "'" Then
                'se toma hasta i para incluir las comillas
                cierraSegm1 lin(), i, pfin, mColTxtCad, TSEG_CAD   'cierra
                buscafincad2 = False     'Marca fin de constante cadena
            End If
        ElseIf c = "#" Then  'Busca comentario
            cierraSegm lin(), i, pfin, colseg, tipseg     'cierra anterior
            'crea segmento final
            n = UBound(lin) + 1
            ReDim Preserve lin(n)
            lin(n).tam = Len(txt) - pfin
            lin(n).col = mColTxtCom    'comentario
            lin(n).tip = TSEG_COM
            Exit Sub    'Ya no hay ms segmentos despus de este
        ElseIf c = """" Then      'Busca comilla
            cierraSegm lin(), i, pfin, colseg, tipseg   'cierra anterior
            buscafincad1 = True  'marca bandera
        ElseIf c = "'" Then      'Busca comilla
            cierraSegm lin(), i, pfin, colseg, tipseg  'cierra anterior
            buscafincad2 = True   'marca bandera
        'busca palabras reservadas
        ElseIf IniIden Then     'Es el inicio de identificador (palabras reservadas)
            AnalizarIdentificador c, txt, lin(), i, pfin, colseg, tipseg
        End If
        'Valida estado de "IniIden" para el siguiente caracter
        If UCase(c) Like CAR_IDEN_VALM Then IniIden = False Else IniIden = True
    Next
    'Termin la exploracin, cierra segmento
    If buscafincad1 Then
        'Cadena sin delimitador final
        cierraSegm1 lin(), i, pfin, mColTxtCad, TSEG_NOR     'cierra
    ElseIf buscafincad2 Then
        'Cadena sin delimitador final
        cierraSegm1 lin(), i, pfin, mColTxtCad, TSEG_NOR     'cierra
    Else
        cierraSegm lin(), i, pfin, colseg, tipseg
    End If
End Sub

Private Sub DibLinSel(y As Long, yc As Long, yt As Long, linvis As String)
'Dibuja una lnea de texto en modo BN.
'La lnea a dibujar debe estr en el bloque se seleccin
Dim xc1 As Integer, xc2 As Integer
Dim tmp As String
    'Dibuja el fondo con la seleccin
    LeerXCurSel xc1, xc2    'obtiene coordenadas de seleccin
    If tipSelec = 1 Then    '--------Seleccin por columnas
        'Dibuja el texto antes del bloque
        SetTextColor jdc, mColTxtNor    'cambia rpidamente color
        tmp = Left$(linvis, xc1 - 1)    'protege de lneas pequeas
        TextOut jdc, 0, y, tmp, Len(tmp)
        'Dibuja el texto despus del bloque
        tmp = Mid$(linvis, xc2)         'protege de lneas pequeas
        TextOut jdc, (xc2 - 1) * anccarP, y, tmp, Len(tmp)
        'Dibuja fondo de seleccin
        Call DibBloFonC(yc, xc1, xc2, mColFonSel)
        'Dibuja texto seleccionado
        SetTextColor jdc, mColTxtSel    'cambia rpidamente color
        If xc2 > xc1 Then   'Verificacin de la menor corrdenada
            tmp = Mid$(linvis, xc1, xc2 - xc1)       'protege de lneas pequeas
            TextOut jdc, (xc1 - 1) * anccarP, y, tmp, Len(tmp)
        Else
            tmp = Mid$(linvis, xc2, xc1 - xc2)       'protege de lneas pequeas
            TextOut jdc, (xc2 - 1) * anccarP, y, tmp, Len(tmp)
        End If
    Else                    '--------Seleccin normal
        'Dibuja el fondo,
        If yt = sel1.yt And yt = sel2.yt Then 'nica lnea con la seleccin
            'Dibuja el texto antes del bloque
            SetTextColor jdc, mColTxtNor    'cambia rpidamente color
            tmp = Left$(linvis, xc1 - 1)    'protege de lneas pequeas
            TextOut jdc, 0, y, tmp, Len(tmp)
            'Dibuja el texto despus del bloque
            tmp = Mid$(linvis, xc2)         'protege de lneas pequeas
            TextOut jdc, (xc2 - 1) * anccarP, y, tmp, Len(tmp)
            'Dibuja fondo de seleccin
            Call DibBloFonC(yc, xc1, xc2, mColFonSel)
            'Dibuja texto seleccionado
            SetTextColor jdc, mColTxtSel    'cambia rpidamente color
            tmp = Mid$(linvis, xc1, xc2 - xc1)       'protege de lneas pequeas
            TextOut jdc, (xc1 - 1) * anccarP, y, tmp, Len(tmp)
        ElseIf yt = sel1.yt Then    'primera lnea de la selecin
            'Dibuja el texto antes del bloque
            SetTextColor jdc, mColTxtNor    'cambia rpidamente color
            tmp = Left$(linvis, xc1 - 1)    'protege de lneas pequeas
            TextOut jdc, 0, y, tmp, Len(tmp)
            'Dibuja fondo de seleccin
            xc2 = Len(linvis) + 1   'selecciona hasta el final
            xc2 = xc2 + 1           'un caracter ms para indicar que la seleccin va hasta el final
            Call DibBloFonC(yc, xc1, xc2, mColFonSel)
            'Dibuja texto seleccionado
            SetTextColor jdc, mColTxtSel    'cambia rpidamente color
            tmp = Mid$(linvis, xc1)       'protege de lneas pequeas
            TextOut jdc, (xc1 - 1) * anccarP, y, tmp, Len(tmp)
        ElseIf yt = sel2.yt Then    'ltima lnea de la selecin
            'Dibuja el texto despus del bloque
            SetTextColor jdc, mColTxtNor    'cambia rpidamente color
            tmp = Mid$(linvis, xc2)         'protege de lneas pequeas
            TextOut jdc, (xc2 - 1) * anccarP, y, tmp, Len(tmp)
            'Dibuja fondo de seleccin
            xc1 = 1                 'selecciona desde el inicio
            Call DibBloFonC(yc, xc1, xc2, mColFonSel)  'fondo de seleccin
            'Dibuja texto seleccionado
            SetTextColor jdc, mColTxtSel    'cambia rpidamente color
            tmp = Mid$(linvis, 1, xc2 - 1)          'protege de lneas pequeas
            TextOut jdc, 0, y, tmp, Len(tmp)
        ElseIf yt > sel1.yt And yt < sel2.yt Then   'lnea completamente seleccionada
            'Dibuja fondo de seleccin
            xc1 = 1                 'selecciona desde el inicio
            xc2 = Len(linvis) + 1   'selecciona hasta el final
            xc2 = xc2 + 1   'un caracter ms para indicar que la seleccin va hasta el final
            Call DibBloFonC(yc, xc1, xc2, mColFonSel)
            'Dibuja texto seleccionado
            SetTextColor jdc, mColTxtSel    'cambia rpidamente color
            TextOut jdc, 0, y, linvis, Len(linvis)
        Else
            'Aqu significa que la lnea no est en la zona de seleccin
            'Nunca debera darse esta condicin, si se verifica antes de
            'llamar a esta rutina
        End If
    End If
End Sub

Private Sub DibujaLinBN(yt As Long, Optional BorraFondo As Boolean = True)
'Refresca una lnea completa que est en la posicin indicada en coordenadas
'de texto (1..nLin). Por defecto borra el fondo antes de dibujar el texto.
'Dibuja el texto considerando la zona seleccionada.
'El texto se dibuja siempre empezando en la coordenada x=0.
Dim y As Long
Dim yc As Long
Dim linvis As String
Dim lin As String
    'Verifica si escapa del texto
    If yt < 1 Or yt > nLin Then Exit Sub
    yc = yt - fil1 + 1   'Coord. de cursor
    If yc < 1 Or yc > maxLinVis Then Exit Sub   'fuera de pantalla
    'toma lnea afectada
    linvis = Mid(linexp(yt), col1, maxColVis)
    y = (yt - fil1) * altcarP    'posicin vertical en pixels
    'Dibuja fondo de lnea
    If BorraFondo Then Call DibBloFonC(yc, 1, maxColVis + 1, mColFonEdi)
    If haysel Then
        'Dibuja texto con seleccin
        If yt >= sel1.yt And yt <= sel2.yt Then
            Call DibLinSel(y, yc, yt, linvis)
        Else    'Lnea sin seleccin
            'Dibuja el texto sin seleccin
            SetTextColor jdc, mColTxtNor    'cambia rpidamente color
            TextOut jdc, 0, y, linvis, Len(linvis)
        End If
    Else
        'Dibuja el texto sin seleccin
        SetTextColor jdc, mColTxtNor    'cambia rpidamente color
        TextOut jdc, 0, y, linvis, Len(linvis)
    End If
End Sub

Private Sub DibujaLinActual()
'Dibuja la lnea actual (curYt), con el fondo apropiado.
'Dim coltmp As Long
'    If verFonLin Then
'        coltmp = mColFonEdi     'Guarda color
'        mColFonEdi = mColLinAct 'Color de lnea activa
'        DibujaLin curYt, True
'        mColFonEdi = coltmp     'Recupera
'    Else
        DibujaLin curYt, True
'    End If
End Sub

Private Sub DibujaLin(yt As Long, Optional BorraFondo As Boolean = True)
'Refresca una lnea completa que est en la posicin indicada en coordenadas
'de texto (1..nLin). Por defecto borra el fondo antes de dibujar el texto.
'Dibuja la lnea de texto a partir de su Vector de descripcin, logrando
'texto multicolor.
Dim xc As Integer
Dim yc As Long, yp As Long
Dim i As Integer, j As Integer
Dim seg As String   'texto del segmento
Dim txtVis As String
Dim pos As Integer  'variable para buscar segmento
Dim tamaju As Integer   'tamao ajustado del primer segmento
Dim txt As String
Dim lin() As TDesSeg
    'Verifica si escapa del texto
    If yt < 1 Or yt > nLin Then Exit Sub
    yc = yt - fil1 + 1   'Coord. de cursor
    If yc < 1 Or yc > maxLinVis Then Exit Sub   'fuera de pantalla
    
    'Verifica si hay seleccin para dbujar en B/N
    If LineaEnSel(yt) Then
        'No nos complicamos
        Call DibujaLinBN(yt, BorraFondo)
        Exit Sub
    End If
    
    'analiza toda la lnea porque los colores
    'pueden depender de elementos no visibles
    txt = linexp(yt)                'lee toda la lnea
    If lincol(yt).tip = TLIN_DES Then
        'No hay descripcin, hay que actualizar
        ActualDescColFil txt, lin(), yt
        lincol(yt).tip = TLIN_MIX
        lincol(yt).seg = lin    'copia descripcin de lnea
    Else    'ya tiene descripcin de segmento
        lin() = lincol(yt).seg()
    End If
    
    yp = (yt - fil1) * altcarP  'actualiza coordenada vertical en pixeles
    'Dibuja fondo de lnea
    If BorraFondo Then Call DibBloFonC(yc, 1, maxColVis + 1, mColFonEdi)
    '-------Busca segmento de inicio "i"-------
    i = 1   'Se asume que empieza en el segmento 1
    pos = 1
    For i = 1 To UBound(lin)
        pos = pos + lin(i).tam
        If pos > col1 Then
            'Este es el segmento que contiene el punto inicial.
            'Calcula el tamao ajustado del primer segmento a
            'dibujar que puede estar fragmentado.
            tamaju = pos - col1
            Exit For
        End If
    Next
    txtVis = Mid$(txt, col1, maxColVis)     'texto visible para graficar
    'Si no cae en ningn segmento, i termina con Ubound(lin)+1
    '-------Imprime desde el segmento "i"------
    xc = 1  'caracter inicial
    For j = i To UBound(lin)
        SetTextColor jdc, lin(j).col    'cambia rpidamente color
        If j = i Then
            'Slo para el primer segmento, el tamao puede variar
            seg = Mid$(txtVis, xc, tamaju)       'texto del segmento
            TextOut jdc, (xc - 1) * anccarP, yp, seg, Len(seg)
            xc = xc + tamaju
        Else
            seg = Mid$(txtVis, xc, lin(j).tam)   'texto del segmento
            TextOut jdc, (xc - 1) * anccarP, yp, seg, Len(seg)
            xc = xc + lin(j).tam
        End If
        If xc > maxColVis Then
            Exit For 'ya no es visible
        End If
    Next
End Sub

Public Sub ReinicColorLin(yt As Long)
'Reinicia coloreado de una lnea
  If yt > nLin Then Exit Sub
  lincol(yt).tip = TLIN_DES
End Sub

Public Sub Dibujar()
'Dibuja el texto completo que es visible en el control.
'Por defecto limpia el fondo a dibujar
Dim yp As Long
Dim i As Long
Dim thread As Long
Dim rc As RECT
Dim ancTerP As Long  'ancho de terminal en pixels
    ancTerP = curXmax * anccarP
    If bmp = 0 Then MsgBox "Error en recursos": Exit Sub    'No hay recursos
    
    
    
    
    
    
Call RecalculaMaxColVis
    If fil1 = 0 Then Exit Sub
    'If nLin = 0 Then Exit Sub  'se permite dibujar sin lneas para borrar
    If maxLinVis = 0 Or maxColVis = 0 Then Exit Sub
    
    thread = GetCurrentThread()
    Call SetThreadPriority(thread, THREAD_PRIORITY_TIME_CRITICAL)
    rc.Left = 0
    rc.Top = 0
    rc.Right = pic.Width
    rc.Bottom = pic.Height
    hBrush = CreateSolidBrush(mColFonEdi)
    'Borra fondo
    FillRect jdc, rc, hBrush
    'Dibuja por lneas
    For i = fil1 To nfilFin
If i = y0 Then
    yp = (i - fil1) * altcarP  'actualiza coordenada vertical en pixeles
    FijaLapiz jdc, PS_DOT, 1, vbYellow
    DibLinea jdc, 0, yp, ancTerP, yp
ElseIf i > y0 Then
    yp = (i - fil1) * altcarP  'actualiza coordenada vertical en pixeles
    DibLinea jdc, ancTerP, yp, ancTerP, yp + altcarP
End If
        DibujaLin i, False  'dibuja sin pintar el fondo
    Next
    Call DibCursorTel   'cursor del terminal
    'copia bmp a pantalla
    Call BitBlt(pic.hdc, 0, 0, pic.Width, pic.Height, jdc, 0, 0, SRCCOPY)
    Call SetThreadPriority(thread, THREAD_PRIORITY_NORMAL)
'Debug.Print hdc & " " & jdc & " " & bmp & " " & Time
End Sub

Private Function CurMenorPos(pos As Tpostex) As Boolean
'Compara el cursor actual con una posicin
Dim poscur As Tpostex
    poscur.xt = curXt
    poscur.yt = curYt
    CurMenorPos = MenorPos(poscur, pos)
End Function

Private Function CurMayorPos(pos As Tpostex) As Boolean
'Compara el cursor actual con una posicin
Dim poscur As Tpostex
    poscur.xt = curXt
    poscur.yt = curYt
    CurMayorPos = MayorPos(poscur, pos)
End Function

Private Function PosSigPos(pos As Tpostex, n As Long) As Tpostex
'Devuelve la siguiente posicin a partir de una posicin base,
'proyectado "n" caracteres adelante. Trabaja en coordenadas de texto
'Slo funciona en el modo de selecin normal.
Dim xt As Integer
Dim yt As Long
Dim lin1 As String  'primera lnea
    PosSigPos = pos
    If n = 0 Then Exit Function
    lin1 = linrea(pos.yt)   'lee primera lnea
    xt = PosXTreal(pos.xt, pos.yt)
    If xt + n <= Len(lin1) + 1 Then
        'Caso simple. No se escapa de la lnea
        PosSigPos.yt = pos.yt
        PosSigPos.xt = PosXTexp(xt + n, pos.yt) 'posicin expandida
    Else
        'Caso ms complicado, porque pasa a otras lneas
        n = n - (Len(lin1) + 1 - xt)    'quita tamao del restante de lnea 1
        yt = pos.yt
        While n > 0
            'Aqu deben estar los dos caracteres CR y LF
            n = n - 2   'Los quitamos
            yt = yt + 1     'nos movemos a la siguiente lnea
            If n < 0 Then
                'Rayos!, algo no anda bien
                MsgBox "Error de ajuste de salto de lnea"
                Exit Function
            End If
            'Aqu puede estar la siguiente lnea
            If n = 0 Then
                'Ya no hay ms lneas
                PosSigPos.yt = yt   'en la siguiente
                PosSigPos.xt = 1    'al inicio
                Exit Function
            ElseIf n > 0 Then
                'An no se cubren todos los caracteres
                If n > Len(linrea(yt)) Then
                    'Toma siguiente lnea completa
                    n = n - Len(linrea(yt))
                Else
                    'Es la ltima lnea
                    PosSigPos.yt = yt   'en la siguiente
                    PosSigPos.xt = PosXTexp(n + 1, yt)
                    Exit Function
                End If
            End If
        Wend
    End If
End Function

Private Sub DibTextPos(p1 As Tpostex, p2 As Tpostex)
'Dibuja las lneas entre las posiciones p1 y p2.
'Si p1 es menor que p2, se corrige.
Dim f As Long
    If p1.yt <= p2.yt Then
        For f = p1.yt To p2.yt
            Call DibujaLin(f)
        Next
    Else
        For f = p2.yt To p1.yt
            Call DibujaLin(f)
        Next
    End If
End Sub

Public Sub ActLimitesBarDesp()
'Actualiza los lmites de las barras de desplazamiento
Dim nLinVis As Integer
    'Calcula el nmero de lneas visibles en el editor
    nLinVis = nfilFin - fil1 + 1

    If nLin > 32700 Then
        'Verifica si se puede trabajar con desplazamientos simples
        'de la barra vertical
        facdesV = 1 / (Int(nLin / 32700) + 1)
    Else    'Si se puede
        facdesV = 1     'factor de desplazamiento vertical
    End If
    If nLin + 1 > maxLinVis Then
        VScroll1.enabled = True
        VScroll1.Max = (nLin - nLinVis) * facdesV + 1 'Valor mximo
        If nLinVis > 0 Then VScroll1.LargeChange = nLinVis
    Else
        VScroll1.enabled = False
    End If
    
    If maxTamLin + 1 > maxColVis Then
        HScroll1.enabled = True
        HScroll1.Max = MaxCol1
        If maxColVis > 0 Then HScroll1.LargeChange = maxColVis
    Else    'deshabilita
        HScroll1.enabled = False
    End If
End Sub

Private Sub ActPosicionBarDesp()
'Actualiza la posicin del cursor de las barras de desplazamiento
    pintando = True     'activa bandera para evitar lanzar otra vez el evento "Paint"
    If CInt((fil1 - 1) * facdesV + 1) > VScroll1.Max Then
        'Esta situacin no debera producirse pero, parece que con muchas
        'lineas el redondeo puede ocasionar exceso
        MsgBox "Error de ajuste vertical: " & (fil1 - 1) * facdesV + 1 - VScroll1.Max
        VScroll1.Value = VScroll1.Max
    Else
        If fil1 = 0 Then    'OJO, esta condicin no debera suceder
            VScroll1.Value = 1
        Else
            VScroll1.Value = (fil1 - 1) * facdesV + 1
        End If
    End If
    If col1 > HScroll1.Max Then
        MsgBox "Error de ajuste horizontal."
        HScroll1.Max = col1
        HScroll1.Value = col1
    Else
        HScroll1.Value = col1
    End If
    pintando = False
End Sub
'**********************************************************************************
'******************************FUNCIONES DE NIVEL MAYOR****************************
'**********************************************************************************
Public Sub CargarArch(arch As String)
'Mtodo inicial para cargar un archivo de texto en el editor
Dim nar As Integer
Dim linea As String
Dim a() As String
Dim i As Long
    If Dir(arch) = "" Then
        MsgBox "No se encuentra archivo: " & arch
        Exit Sub
    End If
    Call LimpiarLineas
    'abre archivo de datos
    archivo = arch
    nar = FreeFile
    Open archivo For Input As #nar
'    lblEstado3.Caption = "DOS"      'Se asume que el tipo es DOS
    'OJOOOOOOOOOOOOOOO que si hay una lnea en blanco al final, no se lee
    'porque "Line Input" lee incluyendo el salto de lnea final si lo encuentra
    Do While Not EOF(nar)
        Line Input #nar, linea
'        If InStr(linea, Chr(10)) <> 0 Then
'            'Hay saltos de lnea, debe ser un formato unix
'            tipArch = 1
'            lblEstado3.Caption = "UNIX"
'            a = Split(linea, Chr(10))
'            For i = 0 To UBound(a)
'                AgregaLinea a(i)    'Agregamos lnea
'            Next
'        Else
            AgregaLinea linea   'Agrega la lnea tal como se lee
'        End If
        If nLin > MAX_LIN_EDI Then
            MsgBox "Demasiadas lneas para leer en el editor"
            Exit Do
        End If
    Loop
    Close #nar
    tCursorA 1, 1
    Call ActualizaNLinFin   'actualiza las lneas visible
'    Call UserControl_Resize
    Call Dibujar
    
    
    
End Sub

Public Sub GuardarArch()
'Mtodo inicial para guardar el archivo de texto del editor
    If archivo = "" Then
        MsgBox "No se ha especificado un nombre para el archivo", vbExclamation
        Exit Sub
    End If
    GuardarArchComo archivo
End Sub

Public Sub GuardarArchComo(nomb As String)
'Mtodo inicial para guardar el archivo de texto del editor
Dim nar As Integer
Dim f As Long
    archivo = nomb  'actualiza nombre actual
    nar = FreeFile
    Open archivo For Output As #nar
    For f = 1 To nLin
        Print #nar, linrea(f)
    Next
    Close #nar
'    Call InicDeshacer       'Inicia deshacer
'    Call FijarTextNoModif   'Fija punto de "No Modificado"
'    Call RefresEstadoModif  'Refresca estado
End Sub

Private Sub LimpSelec(Optional refres As Boolean = False)
'Quita el rea seleccionada, del control. Por defecto no actualiza la pantalla,
'pero si "refres" es TRUE, se redibuja la pantalla si es necesario
    If haysel Then      'Haba una seleccin
        haysel = False  'desactiva
        If refres Then  'Hay que refrescar
            If sel1.yt = sel2.yt Then   'Slo basta con dibujar la lnea
                Call DibujaLin(sel1.yt)
            Else    'Hay que dibujar varias lneas
                Call Dibujar
            End If
        End If
        sel1 = sel0         'Inicia seleccin nula
        sel2 = sel0         'Inicia seleccin nula
    End If
    lblEstado3.Caption = "Sin seleccin."
End Sub

Public Sub SeleccionaTodo()
'Selecciona todo el texto contenido en el editor
    If nLin = 0 Then Exit Sub
    Redibujar = False
    'se mueve al inicio
    tCursorA 1, 1
    Call FijarSel0      'Fija punto base
    'nos movemos al final
    tCursorA2 maxTamLin + 1, nLin
    curXd = curXt      'actualiza posicin deseada
    Call ExtenderSel
End Sub

Public Sub SelecLinea(yt As Long)
'Funcin pblica para seleccionar lnea del texto
    Redibujar = True       'para no complicarnos, dibuja todo
    If haysel Then Call LimpSelec
    'Selecciona lnea
    tCursorA 1, yt
    Call FijarSel0      'Fija punto base
    tCursorA2 maxTamLin + 1, yt
    Call ExtenderSel 'Extiende seleccin
End Sub

Public Sub PegaSeleccion()
'Pega el texto seleccionado al control
'No hay problema en pegar selecciones grandes de texto
    On Error GoTo errPegSel
    CurInsertar Clipboard.GetText
    On Error GoTo 0
    Exit Sub
errPegSel:
    MsgBox "Error Leyendo el portapapeles.", vbExclamation
    On Error GoTo 0
End Sub

Public Sub CortaSeleccion()
'Elimina el texto seleccionado y copia la seleccin al portatpapeles
    Call CopiaSeleccion
    If haysel Then Call CurEliminar
End Sub

Public Sub CopiaSeleccion()
'Copia el texto seleccionado al portapapeles
Dim hData As Long   'Manejador de memoria
Dim nbytes As Long
    If nLin = 0 Then Exit Sub   'por seguridad
    If sel1.xt = sel2.xt And sel1.yt = sel2.yt Then Exit Sub
    '---------Obtiene seleccin-------------
    'Copia seleccin a memoria
    hData = BloAMem(nbytes, sel1, sel2)
    If hData = 0 Then
        MsgBox "No se puede copiar texto. Error asignando memoria", vbCritical
        Exit Sub
    End If
    '---------Copia al portapapeles-------------
    If OpenClipboard(0) Then
        Call EmptyClipboard
        'SetClipboardData CF_METAFILEPICT, hGlobal
        Call SetClipboardData(CF_TEXT, hData)
        'No es necesario ya liberar "hData", porque el portapapapeles lo har
        'cuando ya no lo necesite
        Call CloseClipboard
    Else    'Fallo abrir el Portapapeles
        'Liberamos la memoria porque no la vamos a usar
        GlobalFree hData
    End If
End Sub

Public Sub CurInsertar(cad As String)
End Sub

Public Sub CurEliminar(Optional forzardib As Boolean = False)
End Sub

Public Sub CurEliminarB()
End Sub

'*************************************************************************************
'************************* FUNCIONES PARA OPCIONES DE BSQUEDA ***********************
'*************************************************************************************

Private Function BuscarCadPos(bus As String, p1 As Tpostex, p2 As Tpostex, _
                    Optional ignCaja As Boolean = True) As Tpostex
'Busca una cadena de texto cargado en el editor, en el bloque definido
'por pos1 y pos2, a partir de la posicin pos1 hacia adelante.
'Devuelve la posicin donde empieza la cadena encontrada. Si no encuentra,
'devuelve (0,0)
Dim cad As String
Dim pos As Integer
Dim f As Long
Dim cmp As VbCompareMethod
    If MenorPos(p2, p1) Then Exit Function
    If ignCaja Then
        cmp = vbTextCompare
    Else
        cmp = vbBinaryCompare
    End If
    If p1.yt = p2.yt Then    'Texto de una sola lnea-------
        cad = TextPosLin(p1, p2)
        pos = InStr(1, cad, bus, cmp) 'busca
        If pos <> 0 Then
            BuscarCadPos.xt = p1.xt + PosXTexp(pos, p1.yt)
            BuscarCadPos.yt = p1.yt
            Exit Function
        End If
    Else                     'Hay varias lneas---------------
        'busca en lnea inicial
        cad = TextPosIni(p1)
        pos = InStr(1, cad, bus, cmp)   'busca
        If pos <> 0 Then
            BuscarCadPos.xt = p1.xt + PosXTexp(pos, p1.yt) - 1
            BuscarCadPos.yt = p1.yt
            Exit Function
        End If
        'busca en lneas intermedias
        For f = p1.yt + 1 To p2.yt - 1
            cad = linrea(f)
            pos = InStr(1, cad, bus, cmp) 'busca
            If pos <> 0 Then
                BuscarCadPos.xt = PosXTexp(pos, f)
                BuscarCadPos.yt = f
                Exit Function
            End If
        Next
        'busca en lnea final
        cad = TextPosFin(p2)
        pos = InStr(1, cad, bus, cmp) 'busca
        If pos <> 0 Then
            BuscarCadPos.xt = PosXTexp(pos, p2.yt)
            BuscarCadPos.yt = p2.yt
            Exit Function
        End If
    End If
End Function

Public Sub InicBuscar(bus As String, _
                      Optional ambito As Integer = AMB_TODO, _
                      Optional ignCaja As Boolean = True, _
                      Optional palComp As Boolean = False)
'Inicia una bsqueda definiendo sus parmetros.
'La cadena "bus" debe ser de una sola lnea.
    If ambito = AMB_TODO Then
        'Se buscar en todo el texto
        PosBus1 = MinPos
        PosBus2 = MaxPos
    ElseIf ambito = AMB_SELE Then
        'Se buscar en la seleccin
        PosBus1 = sel1
        PosBus2 = sel2
    End If
    PosEnc = PosBus1    'Fija posicin inicial para buscar
    CadBus = bus        'Guarda cadena de bsqueda
    CajBus = ignCaja    'Guarda parmetro de caja
    PalCBus = palComp
End Sub

Public Function BuscarSig() As String
'Realiza una bsqueda iniciada con "InicBuscar"
'La bsqueda se hace a partir de la posicin donde se dej en la ltima bsqueda.
'Devuelve la cadena de bsqueda.
Dim p As Tpostex
Dim p2 As Tpostex
    PosEnc = LeePosCur()    'Busca desde el cursor
    'Protecciones
    If PosNulo(PosEnc) Then Exit Function
    If PosNulo(PosBus2) Then Exit Function
    If MayorPos(PosBus2, MaxPos) Then PosBus2 = MaxPos
    If MayorPos(PosEnc, PosBus2) Then Exit Function
    'bsqueda
    If PalCBus Then 'Debe ser palabra completa
        p = BuscarCadPos(CadBus, PosEnc, PosBus2, CajBus)
        Do While p.xt <> 0
            p2 = PosSigPos(p, Len(CadBus))
            If EsPalabraCompleta(p, p2) Then Exit Do
            PosEnc = p2
            p = BuscarCadPos(CadBus, PosEnc, PosBus2, CajBus)
        Loop
    Else    'Bsqueda normal
        p = BuscarCadPos(CadBus, PosEnc, PosBus2, CajBus)
        If p.xt <> 0 Then p2 = PosSigPos(p, Len(CadBus))
    End If
    'verifica si encontr
    If p.xt <> 0 Then
        Redibujar = True       'para no complicarnos, dibuja todo
        If haysel Then Call LimpSelec
        'Selecciona cadena
        posCursorA p
        Call FijarSel0      'Fija punto base
        posCursorA2 p2
        Call ExtenderSel 'Extiende seleccin
        BuscarSig = CadBus  'devuelve cadena
    Else
        BuscarSig = CadBus  'devuelve cadena
        MsgBox "No se encuentra el texto: '" & CadBus & "'", vbExclamation
    End If
End Function

Private Function EsPalabraCompleta(p1 As Tpostex, p2 As Tpostex) As Boolean
'Indica si la palabra en la posicin [p,p+lar] es una palabra completa, es decir,
'que no est en medio de un identificador
Dim Cant As String
Dim Csig As String
    If p1.xt = 0 Then Exit Function
    Cant = UCase(CarPosAnt(p1)) 'caracter anterior
    Csig = UCase(CarPos(p2))    'caracter siguiente
    If Not (Cant Like CAR_IDEN_VALM) And Not (Csig Like CAR_IDEN_VALM) Then
        EsPalabraCompleta = True
    End If
End Function

'*************************************************************************************
'***************************** CDIGO DE RESPUESTA A EVENTOS *************************
'*************************************************************************************
Private Sub pic_KeyUp(KeyCode As Integer, Shift As Integer)
    RaiseEvent KeyUp(KeyCode, Shift)
End Sub

Private Sub pic_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, x As Single, y As Single)
'Se ha soltado un archivo
Dim arc As String
    If Data.GetFormat(vbCFFiles) Then
        'Hay nombre de archivos
        arc = Data.Files(1)     'Devuelve el primer archivo
        'Dispara evento
        RaiseEvent ArchivoSoltado(arc)
    End If
End Sub

Private Sub pic_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
'Se ha hecho click en el control
Dim xt As Integer
Dim yt As Long
'    If x < ancNLinP Then
'        'MsgBox "En columna de lneas"
'        Exit Sub
'    End If
'    If MouseDownBarras(CLng(x), CLng(y)) Then Exit Sub
    'Movemos el cursor en la posicin indicada
    xt = Round(x / anccarP) + col1
    yt = Int(y / altcarP) + fil1
    Redibujar = False
    tCursorA2 xt, yt
    curXd = curXt      'actualiza posicin deseada
    If Button = 1 Then
        '---------botn izquierdo----------
        If Shift = 1 Then   'Con shift encendido
            Call ExtenderSel
        Else
            Call LimpSelec(True)        'Limpia seleccin
            'Marca la posicin del cursor antes de una seleccin
            Call FijarSel0
            If Redibujar Then Call Refrescar
            Call EncenCursor    'Enciende para que sea visible en la nueva posicin
        End If
        'Inicia bandera para arrastre
        pulsadoI = True
        xt0 = xt: yt0 = yt  'Inicia coordenadas para movimiento
    Else
        '---------botn derecho----------
    End If
    ultBotPul = Button  'Actualiza ltimo botn pulsado

End Sub

Private Sub pic_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
Dim xt As Integer
Dim yt As Long
'    If X / TwipsPorPixelX < ancNumLin Then
'        Exit Sub
'    End If
    If pulsadoI Then
        'Para indicar arrastre
'        UserControl.MousePointer = vbNoDrop
        '-----Contina seleccin----
        'Movemos el cursor en la posicin indicada
        xt = Int(x / anccarP) + col1
        yt = Int(y / altcarP) + fil1
        If xt0 = xt And yt0 = yt Then Exit Sub
        Redibujar = False
        tCursorA2 xt, yt      'Para realizar desplazamiento
        Call ExtenderSel
    End If
    xt0 = xt: yt0 = yt
    RaiseEvent MouseMove(Button, Shift, x, y)
End Sub

Private Sub pic_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
'    If MouseUpBarras(CLng(x), CLng(y)) Then Exit Sub
    If Button = 1 Then
        pulsadoI = False
'        UserControl.MousePointer = vbDefault    'Termina arrastre
    ElseIf Button = 2 Then
        'Activa men contextual si es que hay
        If Not (menuContext Is Nothing) Then
            PopupMenu menuContext
        End If
    End If
End Sub

Private Sub pic_DblClick()
'    If DblClickBarras Then Exit Sub
    If ultBotPul = 1 Then
        '------Doble click izquierdo ---------
        Redibujar = False
        tCursorA2 curIniPal2(), curYt
        Call FijarSel0
        tCursorA2 curFinPal(), curYt
        Call ApagCursor 'Para que no interfiera
        Call ExtenderSel
    End If
End Sub

Private Sub UserControl_GotFocus()
    pic.SetFocus    'pasa el enfoque
End Sub

Private Sub UserControl_Initialize()
Dim tm As TEXTMETRIC
'MsgBox parent.Name
    y0 = 1      'inicia posicin inicial de terminal VT100
    
    
    
    pic.ScaleMode = vbPixels
    UserControl.ScaleMode = vbPixels
    facdesV = 1
    Call LimpiarLineas
    
    verEstado = False
    verDesVer = False
    verDesHor = False
    
    FijaFil1 1      'fil1= 1
    FijaCol1 1      'col1= 1
    nEspTab = 6     '6 espacios para tabulacin
    'Crea contexto de salida
    jdc = CreateCompatibleDC(pic.hdc)
    bmp = CreateCompatibleBitmap(pic.hdc, pic.ScaleWidth, pic.ScaleHeight)
    SetBkMode jdc, TEXT_TRANSPARENT
    Call SelectObject(jdc, bmp)
    'Inicia colores del editor
    mColFonEdi = vbWhite  'vbblack     'fondo de editor
    mColTxtNor = vbBlack  'vbWhite     'texto normal
    mColFonSel = RGB(130, 130, 255)
'    mColLinAct = RGB(255, 255, 128) 'fondo de lnea actual
    mColTxtSel = vbWhite
    mColFonNli = RGB(210, 210, 210)
    mColTxtCom = RGB(128, 128, 128)
    mColTxtCad = RGB(90, 90, 255)
    mColPalRes = RGB(0, 190, 0)     'verde oscuro
    mColPalRes2 = vbRed     'verde oscuro
    mColTxtFun = RGB(0, 190, 0)     'verde oscuro
    
    pic.BackColor = mColFonEdi
    
    'Define el tipo de texto
'    Call FijaTexto(mColTxtNor, 10, 0, "Courier New")
    
    
    Call FijaTexto(mColTxtNor, 10, 0, "Fixedsys")
    pic.Font = "Fixedsys"   'Si no se le asigna as, no funciona bien
    pic.FontSize = 10       'el "GetTextMetrics"
    
    Call GetTextMetrics(pic.hdc, tm)
    anccarP = tm.tmAveCharWidth  'Siempre en pixels
    altcarP = tm.tmHeight        'Siempre en pixels
    
    maxTamLin = 0   'no hay lneas cargadas an
    VScroll1.Min = 1
    HScroll1.Min = 1
    pintando = False
    
    'inicia cursor
    curXt_ant = 1
    curYt_ant = 1
    FijaCursor 1, 1
    curXd = 1     'Inicia posicin X deseada de cursor
    Call FijarSel0  'inicia parmetros de seleccin
    ActivarCursor
    
    Call InicBuscar("")
    
'    tipArch = 0     'Tipo DOS
    'Posiciones fijas de la barra de estado
    VScroll1.Top = 0
    HScroll1.Left = 0
    lblEstado1.Left = 0
    lblEstado1.Width = 200     'ScaleWidth
    lblEstado2.Left = 200
    lblEstado2.Width = 120
    lblEstado3.Left = 320



    pic.Top = 0     'Ubica el picture en el control
    FijaTamTerminal 80, 25  'tamao inicial de terminal
End Sub

Private Sub UserControl_Terminate()
'Elimina objetos creados
    DeleteObject hPen
    DeleteObject hFont
    DeleteObject hBrush
    'Elimina objetos de contexto
    Call DeleteObject(bmp)
    Call DeleteObject(jdc)
End Sub

Public Sub Refrescar()
'Actualiza la apriencia y el contenido del control
    Call UserControl_Resize
End Sub

Private Sub pic_Paint()
    'Recrea el bmp para que se adapte al tamao del control
    If bmp <> 0 Then Call DeleteObject(bmp)
    bmp = CreateCompatibleBitmap(pic.hdc, _
                    pic.ScaleWidth, pic.ScaleHeight)
    If bmp = 0 Then Exit Sub
    Call SelectObject(jdc, bmp)
    'Re Dibuja todo.
    Call Dibujar
End Sub

Private Sub RecalculaMaxColVis()
'Realiza el Redimensionamiento horizontal, calculando "maxColVis" de acuerdo
'a si se debe mostrar el nmero de lnea y al nmero de lneas totales .
Dim ancVScroll As Long
    If verDesVer Then
        ancVScroll = VScroll1.Width
    Else
        ancVScroll = 0
    End If
    If verNumLin Then
        If nLin > 100000 Then
            ancNLinP = 47
        ElseIf nLin > 10000 Then
            ancNLinP = 40
        ElseIf nLin > 1000 Then
            ancNLinP = 33
        ElseIf nLin > 100 Then
            ancNLinP = 26
        Else
            ancNLinP = 19
        End If
    Else
        ancNLinP = 2    'deja un pequeo espacio lateral
    End If
    'posiciona el "pic"
    pic.Left = ancNLinP
    pic.Width = Posit(ScaleWidth - ancVScroll - ancNLinP)
    maxColVis = pic.Width \ anccarP
    col2 = col1 + maxColVis - 1     'actualiza col2
End Sub

Private Sub UserControl_Resize()
Dim altHScroll As Single   'alto de HScroll1
Dim altEstado As Single   'alto de HScroll1
Dim ancVScroll As Single  'ancho de VScroll1
    'Fija tamao variable de lblEstado3
    lblEstado3.Width = Posit(ScaleWidth - 200)
    'Fija ancho de Barra de desplazamiento horizontal
    If verDesVer Then
        HScroll1.Width = Posit(ScaleWidth - VScroll1.Width)
    Else
        HScroll1.Width = ScaleWidth
    End If
    
    
    'Posicin de barra de desplazamiento vertical
    If verDesVer Then
        If verEstado Then
            VScroll1.Height = Posit(ScaleHeight - lblEstado1.Height)
        Else
            VScroll1.Height = ScaleHeight
        End If
        ancVScroll = VScroll1.Width
        VScroll1.Left = ScaleWidth - ancVScroll
        VScroll1.Visible = True
    Else
        ancVScroll = 0
        VScroll1.Visible = False
    End If
    Call RecalculaMaxColVis
    'Redimensionamiento vertical
    If verDesHor Then
        altHScroll = HScroll1.Height
        'an no se sabe la posicin vertical de HScroll1
        HScroll1.Visible = True
    Else
        altHScroll = 0
        HScroll1.Visible = False
    End If
    If verEstado Then   'Muestra barra de estado
        altEstado = lblEstado1.Height
        lblEstado1.Top = ScaleHeight - altEstado
        lblEstado2.Top = ScaleHeight - altEstado
        lblEstado3.Top = ScaleHeight - altEstado
        
        lblEstado1.Visible = True
        lblEstado2.Visible = True
        lblEstado3.Visible = True
    
    Else
        altEstado = 0
        lblEstado1.Visible = False
        lblEstado2.Visible = False
        lblEstado3.Visible = False
    
    End If
    pic.Height = Posit(ScaleHeight - altHScroll - altEstado)
    'pic.Left = ancNLinP
    'pic.Width = Posit(ScaleWidth - ancVScroll - ancNLinP)
    HScroll1.Top = pic.Height
    'mximo que se puede mostrar
    maxLinVis = pic.ScaleHeight \ altcarP
    If maxLinVis = 0 Then
        Exit Sub  'Probablemente minimizado o demasiado pequeo
    End If
    fil2 = fil1 + maxLinVis - 1
    Call ActualizaNLinFin   'actualiza las lneas visible
    Call Dibujar            'refresca por si acaso. Aqu se puede cambiar
                            'el dimensionamiento horizontal.
    Call ActLimitesBarDesp  'actualiza lmites de Scroll Bar's
End Sub

Private Sub pic_KeyDown(KeyCode As Integer, Shift As Integer)
Dim conShift As Boolean
Dim conCtrl As Boolean
    'dispara evento, antes para permitir cambiar la tecla
    RaiseEvent KeyDown(KeyCode, Shift)
    If KeyCode = 0 Then Exit Sub    'se ha cancelado
    'procesamiento normal
    If KeyCode = 67 And Shift = 4 Then
        RaiseEvent CambiaModo   'Peticin de cambio de modo
    End If
    If KeyCode = 16 Then Exit Sub   'Ignora <Shift> solo
    If KeyCode = 17 Then Exit Sub   'Ignora <Ctrl> solo
    If KeyCode = 18 Then Exit Sub   'Ignora <Alt> solo
    If (Shift And 1) = 1 Then conShift = True
    If (Shift And 2) = 2 Then conCtrl = True
    
    
    
    
    Select Case KeyCode
    'Teclas de desplazamiento
    Case 39 'flecha derecha
        If conCtrl Then    'Ctrl
            DesplazaCursor DIR_DERPAL, , conShift
        Else
            DesplazaCursor DIR_DER, , conShift
        End If
    Case 37 'flecha izquierda
        If conCtrl Then    'Ctrl
            DesplazaCursor DIR_IZQPAL, , conShift
        Else
            DesplazaCursor DIR_IZQ, , conShift
        End If
    Case 40 'flecha abajo
        If conCtrl Then
            DesplazaCursor DIR_ABAPAR, , conShift
        Else
            DesplazaCursor DIR_ABA, , conShift
        End If
    Case 38 'flecha arriba
        If conCtrl Then
            DesplazaCursor DIR_ARRPAR, , conShift
        Else
            DesplazaCursor DIR_ARR, , conShift
        End If
    Case 34     'pag.abajo
        DesplazaCursor DIR_PABA, maxLinVis - 1, conShift
    Case 33     'pag.arriba
        DesplazaCursor DIR_PARR, maxLinVis - 1, conShift
    Case 36     'inicio
        If conCtrl Then    'Ctrl
            DesplazaCursor DIR_HOM, , conShift
        Else
            DesplazaCursor DIR_INI, , conShift
        End If
    Case 35     'fin
        If conCtrl Then    'Ctrl
            DesplazaCursor DIR_END, , conShift
        Else
            DesplazaCursor DIR_FIN, , conShift
        End If
    Case 116    'F5 refresca
        Call Dibujar    'Dibuja el control
    'de modificacin
    Case 46     'DEL
        If conShift Then
            Call CortaSeleccion
        Else
            Call CurEliminar
        End If
    Case 45     'INSERT
        If conCtrl Then
            Call CopiaSeleccion
        ElseIf conShift Then
            Call PegaSeleccion
        End If
    Case 13
        CurInsertar vbCrLf
    Case 8
        Call CurEliminarB
    End Select
End Sub

Private Sub pic_KeyPress(KeyAscii As Integer)
'Procesa una tecla pulsada
    RaiseEvent KeyPress(KeyAscii)
    If KeyAscii >= 32 Or KeyAscii = 9 Then
'        If Not HayAyudC Then
            'CurInsertar Chr(KeyAscii)
'        End If
    End If
'    If KeyAscii = 27 And Not HayAyudC Then
'        RaiseEvent TeclaEscape  'Evento de escape
'    End If
'    Call fContex.KeyPress(KeyAscii)
End Sub

'-----Eventos del desplazamiento
Private Sub VScroll1_Change()
Dim dy As Long
    If pintando Then Exit Sub   'Se est en medio de un redibujo
    dy = VScroll1.Value / facdesV - fil1
    FijaFil1 fil1 + dy
    Call Dibujar    'Dibuja el control
End Sub

Private Sub HScroll1_Change()
Dim dx As Integer
    If pintando Then Exit Sub   'Se est en medio de un redibujo
    dx = HScroll1.Value - col1
    FijaCol1 col1 + dx  'desplaza
    Call Dibujar    'Dibuja el control
End Sub

'*************************************************************************************
'****************** FUNCIONES GRFICAS Y DE DESPLAZAMIENTO DEL CURSOR ****************
'*************************************************************************************
Private Sub FijaLapiz(dc As Long, estilo As Long, Ancho As Long, color As Long)
'Establece el lpiz actual de dibujo
    
    
    If hPen <> 0 Then DeleteObject hPen     'si ya hay un lpiz, lo elimina
    hPen = CreatePen(estilo, Ancho, color)
    SelectObject dc, hPen                   'queda pendiente eliminarlo
End Sub

Private Sub FijaRelleno(dc As Long, colorr As Long)
'Establece el relleno actual
    
    
    If hBrush <> 0 Then DeleteObject hBrush 'si hay relleno, lo elimina
    hBrush = CreateSolidBrush(colorr)
    SelectObject dc, hBrush             'queda pendiente eliminarlo
End Sub

Private Sub FijaTexto(color As Long, tam As Long, nDegrees As Single, _
              Optional Letra As String = "Times New Roman", _
              Optional negrita As Boolean = False, _
              Optional cursiva As Boolean = False, _
              Optional subrayado As Boolean = False)
'Establece las caractersticas de texto
Dim grosor As Long
    SetTextColor jdc, color
    If negrita Then grosor = FW_BOLD Else grosor = FW_NORMAL
    If hFont <> 0 Then DeleteObject hFont
    hFont = CreateFont(-MulDiv(tam, GetDeviceCaps(jdc, LOGPIXELSY), 72), _
        0, nDegrees * 10, 0, grosor, cursiva, subrayado, False, DEFAULT_CHARSET, _
        OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, PROOF_QUALITY, DEFAULT_PITCH, Letra)
    SelectObject jdc, hFont                 'queda pendiente eliminarlo
End Sub

Sub DibLinea(dc As Long, x1 As Long, y1 As Long, x2 As Long, y2 As Long)
'Dibuja una lnea en el color actual
Dim p As POINTAPI
    MoveToEx dc, x1, y1, p
    LineTo dc, x2, y2
End Sub

Private Sub DesplazaCursor(direccion As Integer, Optional paso As Long = 1, _
                           Optional actselec As Boolean = False)
'Mueve el cursor en la pantalla, considerando que deba caer en una posicin
'vlida. Desplaza y refresca la pantalla si es necesario
'Implementado a responder los desplazamientos por teclado. Se ha diseado
'para que los rerfrescos de pantalla sean slo cuando es necesario.
Dim posi As Integer 'posicin inicial
Dim lin As String   'linea de trabajo
    Redibujar = False       'inicia para verificar si se debe redibujar
    'Verifica si escapa de la pantalla o de zona vlida
    Select Case direccion
    Case DIR_IZQ
        If curXt = 1 And curYt > 1 Then   'Esta al inicio de lnea y hay anterior
            tCursorA2 Len(linexp(curYt - 1)) + 1, curYt - 1, A_IZQ_TAB
        Else
            tCursorA2 curXt - paso, curYt, A_IZQ_TAB
        End If
        curXd = curXt     'actualiza posicin deseada
    Case DIR_DER
        If curXt >= Len(linact) + 1 And curYt < nLin Then  'Final de lnea y hay siguiente
            tCursorA2 1, curYt + 1, A_DER_TAB
        Else
            tCursorA2 curXt + paso, curYt, A_DER_TAB
        End If
        curXd = curXt     'actualiza posicin deseada
    Case DIR_ARR
        If curXd <> curXt Then curXt = curXd  'intenta recuperar posicin
        tCursorA2 curXt, curYt - paso, A_IZQ_TAB
    Case DIR_ABA
        If curXd <> curXt Then curXt = curXd  'intenta recuperar posicin
        tCursorA2 curXt, curYt + paso, A_IZQ_TAB
    Case DIR_PARR   'Pgina arriba
        If curXd <> curXt Then curXt = curXd  'intenta recuperar posicin
'        VerticalScroll CInt(-paso)
        tCursorA2 curXt, curYt - paso, A_IZQ_TAB
    Case DIR_PABA   'Pgina abajo
        If curXd <> curXt Then curXt = curXd  'intenta recuperar posicin
'        VerticalScroll CInt(paso)
        tCursorA2 curXt, curYt + paso, A_IZQ_TAB
    Case DIR_ARRPAR
        If curXd <> curXt Then curXt = curXd  'intenta recuperar posicin
        tCursorA2 curXt, curIniPar(), A_IZQ_TAB
    Case DIR_ABAPAR
        If curXd <> curXt Then curXt = curXd  'intenta recuperar posicin
        tCursorA2 curXt, curFinPar(), A_IZQ_TAB
    Case DIR_INI    'lleva hasta el inicio de la lnea
        tCursorA 1, curYt, A_IZQ_TAB
        curXd = curXt     'actualiza posicin deseada
    Case DIR_FIN    'lleva hasta el final de la lnea
        tCursorA maxTamLin + 1, curYt, A_DER_TAB
        curXd = curXt     'actualiza posicin deseada
    Case DIR_HOM    'Al inicio del texto
        tCursorA 1, 1, A_IZQ_TAB
        curXd = curXt     'actualiza posicin deseada
    Case DIR_END    'Al final del texto
        tCursorA2 maxTamLin + 1, nLin, A_IZQ_TAB
        curXd = curXt     'actualiza posicin deseada
    Case DIR_IZQPAL
        If curXt = 1 And curYt > 1 Then   'Esta al inicio de lnea y hay anterior
            tCursorA2 Len(linexp(curYt - 1)) + 1, curYt - 1, A_IZQ_TAB
        Else
            tCursorA2 curIniPal(), curYt, A_IZQ_TAB
        End If
        curXd = curXt     'actualiza posicin deseada
    Case DIR_DERPAL 'A la derecha por palabra
        If curXt >= Len(linact) + 1 And curYt < nLin Then  'Final de lnea y hay siguiente
            tCursorA2 1, curYt + 1, A_DER_TAB
        Else
            tCursorA2 curSigPal(), curYt, A_IZQ_TAB
        End If
        curXd = curXt      'actualiza posicin deseada
    End Select
    'Procesa el dibujo de la seleccin
    If actselec Then    'Activar seleccin
        Call ExtenderSel
    Else
        If Redibujar Then   'Se movi la pantalla, redibujamos todo
            Call LimpSelec  'Aprovechamos para limpiar si hay seleccin
            Call Dibujar
        Else
            Call LimpSelec(True)      'Limpia seleccin
        End If
        'Marca la posicin del cursor antes de una seleccin
        Call FijarSel0      'Fija punto base
        Call EncenCursor    'Enciende para que sea visible en la nueva posicin
    End If
    'actualiza la posicin del cursor
    Call ActPosicionBarDesp
End Sub

Private Sub ExtenderSel()
'Refresca el texto del control considerando que la posicin actual del cursor define
'un lmite (inicial o final) en el bloque de seleccin. El otro lmite es "sel0" que
'debe haber sido previamente fijado.
'Lo que se trata de hacer con este procedimiento es evitar llamar innecesariamente
'a Dibujar(). Pero si la variable "Redibujar" est en true, se redibuja todo
'incondicionalmente.
Dim Ptmp As Tpostex      'define el intervalo de la zona a dibujar
    If tipSelec = 1 Then Redibujar = True   'Fuerza actualizacin Total en este modo
    Call DesactivarCursor   'Se desactiva para no interferir
    haysel = True   'se marca la bandera
    If CurMenorPos(sel0) Then   '--------Cursor antes de sel0---------
        sel1 = LeePosCur()     'Inicio de la seleccin est ahora en el cursor
        sel2 = sel0
        Call Dibujar
    ElseIf CurMayorPos(sel0) Then   '--------Cursor despus de sel0---------
        sel1 = sel0
        sel2 = LeePosCur()    'Fin de la seleccin est ahora en el cursor
        Call Dibujar
    Else            '--------Cursor en la misma posicin---------
        'No hay nada que procesar, slo ver si hay que borrar
        sel1 = sel0
        sel2 = sel0
        Call Dibujar
    End If
    'actualiza anteriores
    sel1ant = sel1
    sel2ant = sel2
    'muestra estado de seleccin
    If verEstado Then
        If sel1.xt = sel2.xt And sel1.yt = sel2.yt Then
            lblEstado3.Caption = "sin seleccin"
        Else
            If sel2.xt = sel1.xt Then
                lblEstado3.Caption = "Selec: " & CStr(sel2.yt - sel1.yt) & " filas."
            ElseIf sel2.yt = sel1.yt Then
                lblEstado3.Caption = "Selec: " & CStr(sel2.xt - sel1.xt) & " colum."
            Else
                lblEstado3.Caption = "Selec: " & _
                    CStr(sel2.yt - sel1.yt) & " fil. " & CStr(sel2.xt - sel1.xt) & " col."
            End If
        End If
    End If
End Sub

Public Sub VerticalScroll(dy As Integer)
'Funcin pblica para realizar un desplazamiento vertical de la pantalla.
'Se ha creado pensando en el desplazamiento con el evento "MouseWheel"
Dim vFinal As Integer
    vFinal = VScroll1.Value + dy
    If vFinal > VScroll1.Max Then vFinal = VScroll1.Max
    If vFinal < VScroll1.Min Then vFinal = VScroll1.Min
    VScroll1.Value = vFinal
End Sub

Public Sub Panel1(txt As String, col As Long, _
        Optional colfon As Long = vbMenuBar)
'Escribe valor en Panel1
    lblEstado1.ForeColor = col
    lblEstado1 = txt
    lblEstado1.BackColor = colfon
End Sub

'*****************************************************************************
'***************** FUNCIONES PARA MANEJO DE TERMINAL VT100 *****************
'*****************************************************************************
Public Sub FijaTamTerminal(Ancho As Integer, Alto As Integer)
'Fija el ancho de la pantalla del terminal
    curXmax = Ancho - 1
    curYmax = Alto - 1
End Sub

Public Sub EliminarLineasIni(nelim As Long)
'Elimina lneas iniciales en la matriz de cadenas, desplazando los
'elementos. Actualiza la posicin del cursor
Dim i As Long
    'protecciones
    If 1 > nLin Then Exit Sub       'proteccin
    If nelim > nLin Then Exit Sub   'a eliminar ms de lo que hay
    'Desplaza elementos
    For i = 1 To nLin - nelim
        linrea(i) = linrea(i + nelim)
        lincol(i) = lincol(i + nelim)
    Next
    'Actualiza tamao
    nLin = nLin - nelim
    nLlegoPrompt = nLlegoPrompt - nelim 'corrige
    ReDim Preserve linrea(nLin)
    ReDim Preserve lincol(nLin)
    'Actualiza ventana
    FijaCursor curXt, curYt - nelim 'mantiene el cursor
    FijaFil1 fil1 - nelim   'mantiene la ventana en su posicin
    y0 = y0 - nelim     'actualiza inicio de ventana de terminal
End Sub

Private Function CurY_a_Yt(yvt As Long) As Long
'Convierte coordenada Cury de VT100 a coordenada de texto del editor
    CurY_a_Yt = y0 + yvt
End Function

Private Function CurY_a_Xt(xvt As Long) As Long
'Convierte coordenada Cury de VT100 a coordenada de texto del editor
    CurY_a_Xt = xvt
End Function

Private Sub AgregaLineaTel(lin As String)
'Versin de AgregaLinea() para "Telnet"
'Agrega una lnea al final del control pero sin cambiar "fil1"
Dim tamexp As Integer
    nLin = UBound(linrea) + 1   'actualiza nuevo nmero de lneas
    ReDim Preserve linrea(nLin) 'crea espacio
    ReDim Preserve lincol(nLin) 'crea espacio
    linrea(nLin) = lin      'escribe la nueva lnea
    'actualiza ancho mximo de lnea
    tamexp = Len(LineaFin(lin))
    If tamexp > maxTamLin Then maxTamLin = tamexp
    'Actualiza "nfilFin"
    nfilFin = fil2
    If nfilFin > nLin Then nfilFin = nLin
End Sub

Private Sub ValidaCurTelEdit(yt As Long)
'Valida la posicin del cursor del terminal en el Editor
'Se asegura que haya texto en la posicin del cursor para
'que no se escriba texto "en el aire".
    If yt > nLin Then
        While yt > nLin
            AgregaLineaTel Space$(curX)     'completa con espacios para no perder la ubicacin vertical
        Wend
        'Debera actualizarse los lmites de las barras aqu
        'pero, toma mucho tiempo refrescarlas cuando llegan
        'muchos datos por el terminal.
        'Call ActLimitesBarDesp  'cambia lmites
        'En su lugar se marca una bandera para que el temporizador
        'lo refresque.
        ActLimBarDes = True
    End If
End Sub

Public Sub TelnetCar(ch As Byte)
'Procesa un caracter recibido en el Terminal. Puede ser un caracter,
'de control o un caracter imprimible. Maneja sus propias coordenadas
'de cursor.
'No refresca la pantalla
Dim a() As String
Dim yt As Long
Dim txt As String
    Select Case ch
    Case 7
        Beep
    Case 8  'Backspace, En VT100 indica mover el cursor a la izquierda
'        DesplazaCursor DIR_IZQ
        If curX > 0 Then curX = curX - 1
    Case 9
Debug.Print "Secuencia no soportada TAB"
'        bolsa(ibolsa) = CH       'escribe byte
'        ibolsa = ibolsa + 1      'apunta a siguiente
    Case 10         'salto de lnea
        curY = curY + 1   'baja cursor
        yt = y0 + curY  'convierte a coordenada de texto
        Call ValidaCurTelEdit(yt)
        'verifica si hay que desplazar pantalla
        If curY > curYmax Then   'hay desplazamiento
            y0 = yt - curYmax  'reposiciona inicio de ventana de terminal
            curY = curYmax     '25 lneas
        End If
    Case 13         'retorno de carro
        'curX = 0   '----comentado 21/07/13
        '----Agregado 21/07/13
        'se supone que no debera moverse hacia abajo, pero he visto que un servidor genera
        'la secuencia 32,13,0, en la columna final, cuando quiere cambiar de lnea.
        If curX = curXmax + 2 Then  'justo despus de salirse
            curX = 0
            curY = curY + 1   'baja cursor
            yt = y0 + curY  'convierte a coordenada de texto
            Call ValidaCurTelEdit(yt)
            'verifica si hay que desplazar pantalla
            If curY > curYmax Then   'hay desplazamiento
                y0 = yt - curYmax  'reposiciona inicio de ventana de terminal
                curY = curYmax     '25 lneas
            End If
        Else    'es una simple orden de retorno de carro
            curX = 0
        End If
        '--------------------------------
    Case Else       'Caracter normal
        yt = y0 + curY  'convierte a coordenada de texto
        txt = linrea(yt)
        If curX >= Len(txt) Then  'al final
            'linrea(curYt) = txt & Space$(curXt - Len(txt) + 1) & Chr(ch)
            linrea(yt) = txt & Chr(ch)
        Else    'inserta en texto intermedio
            'linrea(yt) = Left$(txt, curX) & Chr(ch) & Mid$(txt, curX + 2)
            Mid$(linrea(yt), curX + 1, 1) = Chr(ch)
        End If
        curX = curX + 1   'increnenta posicin
        lincol(yt).tip = TLIN_DES 'Fuerza a actualizar colores
    End Select
End Sub

Public Sub FijaCursorTel(xvt As Integer, yvt As Long)
'Funcin pblica para fijar la posicin del cursor en coordenadas
'de terminal VT100. En (0,0) como la esquina superior izquierda.
'No realiza refresco, solo psoiciona el cursor y valida.
Dim yt As Long
    'posiciona coordenada vertical
    curY = yvt
    If curY < 0 Then curY = 0
    yt = y0 + curY  'convierte a coordenada de texto
    Call ValidaCurTelEdit(yt)
    'posiciona coordenada horizontal
    curX = xvt
    If curX < 0 Then curX = 0
    'verifica si cursor queda "en el aire"
    If curX > Len(linrea(yt)) Then
        'completa con espacios
        linrea(yt) = linrea(yt) & String$(curX - Len(linrea(yt)), " ")
    End If
'Debug.Print "FijaCursorTel:" & xvt & "," & yvt
End Sub

Public Sub LeeCursorTel(xvt As Integer, yvt As Long)
'Funcin pblica para leer la posicin del cursor
    xvt = curX
    yvt = curY
End Sub

Public Sub eraseBOL()
'Borra desde el inicio de la lnea
Dim yt As Long
    yt = y0 + curY  'convierte a coordenada de texto
    Mid$(linrea(yt), 1, curX + 1) = Space$(curX + 1)
    lincol(yt).tip = TLIN_DES     'para actualizar
End Sub

Public Sub eraseBOS()
'Borra todo desde el inicio de la pantalla hasta el cursor.
Dim f As Long
    Call eraseBOL
    For f = y0 To y0 + curY - 1
        linrea(f) = ""
        lincol(f).tip = TLIN_DES    'para actualizar
    Next
End Sub

Public Sub eraseEOL()
'Borra desde el cursor hasta el fin de la lnea
Dim yt As Long
    yt = y0 + curY  'convierte a coordenada de texto
    'Mid$(linrea(yt), curX + 1) = ""
    linrea(yt) = Left$(linrea(yt), curX)
    lincol(yt).tip = TLIN_DES     'para actualizar
End Sub

Public Sub eraseEOS()
'Borra desde el cursor hasta el fin de la pantalla.
Dim f As Long
    Call eraseEOL
    For f = y0 + curY + 1 To y0 + curYmax
        If f <= UBound(linrea) Then
            linrea(f) = ""
            lincol(f).tip = TLIN_DES    'para actualizar
        End If
    Next
End Sub

Public Sub eraseLINE()
'Borra la lnea actual
Dim f As Long
    f = y0 + curY
    'completa con espacios para que el cursor no quede en el aire
    linrea(f) = String$(curX, " ")
    lincol(f).tip = TLIN_DES    'para actualizar
End Sub

Public Sub eraseSCREEN()
'Borra el contenido de la pantalla del terminal.
'No toca el "buffer".
Dim f As Long
    If nLin < y0 + curYmax Then   '-----hay pocas lneas
        For f = y0 To nLin
            linrea(f) = ""
            lincol(f).tip = TLIN_DES    'para actualizar
        Next
    Else    '-----hay ms lneas abajo
        For f = y0 To y0 + curYmax
            linrea(f) = ""
            lincol(f).tip = TLIN_DES    'para actualizar
        Next
    End If
    curX = 0
    curY = 0
End Sub

Public Function CursorEditEngan() As Boolean
'Indica si el cursor del Editor coincide con el cursor del
'terminal VT100.
    If curX + 1 = curXt And y0 + curY = curYt Then
        CursorEditEngan = True
    End If
End Function

Public Sub EnganCursorEdit()
'Hace coincidir el cursor del Editor con el cursor del
'terminal VT100 (lo engancha).
    'FijaCursor curX + 1, y0 + curY
    tCursorA curX + 1, y0 + curY
End Sub

Private Sub DibCursorTel()
'Dibuja el cursor del terminal en la posicin (curX, curY)
'en la pantalla. Actualiza (curX_ant, curY_ant)
Dim car As String
'Dim hdc As Long
Dim posX As Long, posY As Long
Dim posXfin As Long, posYfin As Long
    posX = anccarP * (curX + 1 - col1) '+ ancNLinP
    posY = altcarP * (y0 + curY - fil1)
    posXfin = posX + (anccarP - 1)
    posYfin = posY + (altcarP - 1)
'    hdc = pic.hdc
        
        
        
        
    FijaRelleno jdc, mColTxtNor
    FijaLapiz jdc, PS_SOLID, 1, mColTxtNor
    Rectangle jdc, posX, posY, posXfin, posYfin
    
'    curBorrado = False   'marca bandera
'    'Actualiza posicin donde se dibuj el cursor
'    curXt_ant = curXt
'    curYt_ant = curYt
End Sub

Public Function CadPropiedades() As String
'Devuelve una cadena con las principales propiedades del editor
Dim tmp As String
    tmp = B2f(verEstado) & W & B2f(verDesHor) & W & B2f(verDesVer) & W & _
          B2f(verNumLin) & W & W & W & _
          mColFonEdi & W & mColFonSel & W & mColTxtNor & W & _
          mColTxtSel & W & mColFonNli & W & W & _
          mColTxtCom & W & mColTxtCad & W & mColPalRes & W & _
          mColPalRes2 & W & mColTxtFun & W & W
    CadPropiedades = tmp
End Function

Public Sub LeePropiedades(cad As String)
'Carga las principales propiedades del editor de una cadena
Dim a() As String
    a = Split(cad, W)
    verEstado = f2B(a(0))
    verDesHor = f2B(a(1))
    verDesVer = f2B(a(2))
    verNumLin = f2B(a(3))
    
    mColFonEdi = a(6)
    mColFonSel = a(7)
    mColTxtNor = a(8)
    mColTxtSel = a(9)
    mColFonNli = a(10)
    
    mColTxtCom = a(12)
    mColTxtCad = a(13)
    mColPalRes = a(14)
    mColPalRes2 = a(15)
    mColTxtFun = a(16)
End Sub

Public Property Get enabled() As Boolean
    enabled = pic.enabled
End Property

Public Property Let enabled(ByVal vNewValue As Boolean)
    pic.enabled = vNewValue
    HScroll1.enabled = vNewValue
    VScroll1.enabled = vNewValue
End Property

