sqlplus SIGGSM/SIGGSM@gerweb;
col machine format a18
col osuser format a15
col username format a15
col "SID,SERIAL" format a14
set LINESIZE 300
SET PAGESIZE 5000
select a.osuser, a.USERNAME, a.machine, a.status, c.seconds_in_wait, 
   a.SID || ',' || a.SERIAL# "SID,SERIAL", b.SPID "OS PID"
from v$session a, v$process  b, v$session_wait c
where a.PADDR= b.ADDR AND a.sid = c.sid order by 1;

--ALTER SYSTEM KILL SESSION '620,15930';

