VERSION 5.00
Object = "{248DD890-BB45-11CF-9ABC-0080C7E7B78D}#1.0#0"; "MSWINSCK.OCX"
Begin VB.UserControl CtlTelnet 
   ClientHeight    =   3600
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   InvisibleAtRuntime=   -1  'True
   ScaleHeight     =   3600
   ScaleWidth      =   4800
   Begin VB.Timer tmrConnect 
      Enabled         =   0   'False
      Left            =   720
      Top             =   720
   End
   Begin MSWinsockLib.Winsock Winsock1 
      Left            =   2040
      Top             =   720
      _ExtentX        =   741
      _ExtentY        =   741
      _Version        =   393216
   End
   Begin VB.Label Label1 
      Alignment       =   2  'Center
      BackColor       =   &H0000C000&
      BorderStyle     =   1  'Fixed Single
      Caption         =   "telnet"
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   11.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00FFFFFF&
      Height          =   375
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   1095
   End
End
Attribute VB_Name = "CtlTelnet"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'Implementa una conexin Telnet en un terminal VT100

'Eventos del control
Public Event Closed()
Public Event Receive(ByRef ch() As Byte)
'Public Event ReceiveCom(ByVal com As Integer)
Public Event Connected()
Public Event Error(ByVal Description As String)
Public Event ConnectTimeout()

Private parsedata(10)   As Integer
Private ppno            As Integer
Public Receiving        As Boolean

'Opciones de estado del Terminal
Public sw_ugoahead As Boolean
Public sw_igoahead As Boolean
Public sw_echo     As Boolean
Public sw_linemode As Boolean
Public sw_termsent As Boolean
Public substate    As Boolean

Private Const GO_NORM = 0

Private Const GO_ESC1 = 1
Private Const GO_ESC2 = 2
Private Const GO_ESC3 = 3
Private Const GO_ESC4 = 4
Private Const GO_ESC5 = 5

Private Const GO_IAC1 = 6
Private Const GO_IAC2 = 7
Private Const GO_IAC3 = 8
Private Const GO_IAC4 = 9
Private Const GO_IAC5 = 10
Private Const GO_IAC6 = 11

'***Telnet Options***
Private Const OPT_BIN = 0 ' Binary Transmission
Private Const OPT_ECHO = 1 ' Echo
Private Const OPT_RECN = 2 ' Reconnection
Private Const OPT_SUPP = 3 ' Suppress Go Ahead
Private Const OPT_APRX = 4 ' Approx Message Size Negotiation
Private Const OPT_STAT = 5 ' Status
Private Const OPT_TIM = 6 ' Timing Mark
Private Const OPT_REM = 7 ' Remote Controlled Trans and Echo
Private Const OPT_OLW = 8 ' Output Line Width
Private Const OPT_OPS = 9 ' Output Page Size
Private Const OPT_OCRD = 10 ' Output Carriage-Return Disposition
Private Const OPT_OHT = 11 ' Output Horizontal Tabstops
Private Const OPT_OHTD = 12 ' Output Horizontal Tab Disposition
Private Const OPT_OFD = 13 ' Output Formfeed Disposition
Private Const OPT_OVT = 14 ' Output Vertical Tabstops
Private Const OPT_OVTD = 15 ' Output Vertical Tab Disposition
Private Const OPT_OLD = 16 ' Output Linefeed Disposition
Private Const OPT_EXT = 17 ' Extended ASCII
Private Const OPT_LOGO = 18 ' Logout
Private Const OPT_BYTE = 19 ' Byte Macro
Private Const OPT_DATA = 20 ' Data Entry Terminal
Private Const OPT_SUP = 21 ' SUPDUP
Private Const OPT_SUPO = 22 ' SUPDUP Output
Private Const OPT_SNDL = 23 ' Send Location
Private Const OPT_TERM = 24 ' Terminal Type
Private Const OPT_EOR = 25 ' End of Record
Private Const OPT_TACACS = 26 ' TACACS User Identification
Private Const OPT_OM = 27 ' Output Marking
Private Const OPT_TLN = 28 ' Terminal Location Number
Private Const OPT_3270 = 29 ' Telnet 3270 Regime
Private Const OPT_X3 = 30 ' X.3 PAD
Private Const OPT_NAWS = 31 ' Negotiate About Window Size
Private Const OPT_TS = 32 ' Terminal Speed
Private Const OPT_RFC = 33 ' Remote Flow Control
Private Const OPT_LINE = 34 ' Linemode
Private Const OPT_XDL = 35 ' X Display Location
Private Const OPT_ENVIR = 36 ' Telnet Environment Option
Private Const OPT_AUTH = 37 ' Telnet Authentication Option
Private Const OPT_NENVIR = 39 ' Telnet Environment Option
'***End of Telnet Options***

'***Telnet Command: 240~255***
Private Const CMD_SE = 240 'end sub negotiation
Private Const CMD_NOP = 241 'nop
Private Const CMD_DM = 242 'data mark--for connect. cleaning
Private Const CMD_BRK = 243 'break
Private Const CMD_IP = 244 'interrupt process--permanently
Private Const CMD_AO = 245 'abort output--but let prog finish
Private Const CMD_AYT = 246 'are you there
Private Const CMD_EC = 247 'erase the current character
Private Const CMD_EL = 248 'erase the current line
Private Const CMD_GA = 249 'you may reverse the line
Private Const CMD_SB = 250 'interpret as subnegotiation
Private Const CMD_WILL = 251 'I will use option
Private Const CMD_WONT = 252 'I won't use option
Private Const CMD_DO = 253 'please, you use option
Private Const CMD_DONT = 254 'you are not to use option
Private Const CMD_IAC = 255 'Interpret Aa Command:
'***End of Telnet Command***

Private Const MOD_INIT = 0
Private Const MOD_IAC_START = 1
Private Const MOD_DONT = 2
Private Const MOD_DO = 3
Private Const MOD_WONT = 4
Private Const MOD_WILL = 5
Private Const MOD_SB = 6
Private Const MOD_WAITFOR_SE = 7

Private DispBuf()   As Byte     'Cannot declare Public here
Private DispData    As String   'Cadena de datos recibidos a mostrar

Private WithEvents edit As ctlEdTelnet
Attribute edit.VB_VarHelpID = -1

Public control_on   As Boolean  'Estado de la tecla <CTRL>
Public TraceTelnet  As Boolean  'Opcin de depuracin
Public Tracevt100   As Boolean

Public curX         As Integer
Public curY         As Long
Private SavecurX    As Integer
Private SavecurY    As Long
Private InEscape    As Boolean  ' Processing an escape seq?
Private EscString   As String   ' String so far
Private yt0         As Long     'coordenada yt que equivale a x=0 en en VT100

Public LlegoPrompt As Boolean   'indica si ha llegado el "prompt"
Public linPrompt1 As Long   'lnea anterior del "prompt"
Public linPrompt2 As Long   'lnea actual del "prompt"

Public AncTerm As Integer   'ancho del terminal (caracteres)
Public AltTerm As Integer   'alto del terminal (caracteres)

Private Declare Function IsCharAlpha Lib "user32" Alias "IsCharAlphaA" (ByVal cChar As Byte) As Long

Private Sub tmrConnect_Timer()
    RaiseEvent ConnectTimeout
End Sub

Private Sub UserControl_Initialize()
    Width = Label1.Width
    Height = Label1.Height
    yt0 = 1
    AncTerm = 80    'Ancho del terminal inicial
    AltTerm = 25    'Alto del terminal inicial
End Sub

Public Sub Iniciar(ed As ctlEdTelnet)
'Inicia el terminal. Requiere que se le indique el editor
    Set edit = ed   'define editor
    'Define tamao del terminal
    AncTerm = 90
    AltTerm = 35
    edit.FijaTamTerminal AncTerm, AltTerm
    edit.Panel1 "Desconectado.", vbBlack
End Sub

Public Function GetDispData(ByRef RecvData() As Byte) As Long
    Dim i As Long
    Dim j As Long
    Dim SB_Option As Byte
    Dim CurMod As Integer
    Dim ReplyBuf As String
    Dim strReplyCmd As String
    Dim byteReplyCmd() As Byte
    Dim sep As String
    Dim b As Byte
    Dim u As Long
    On Error GoTo ErrHandler
    
    'IAC --> WILL/DO/WONT/DONT --> OptionID
    'IAC --> SB --> options data --> SE

    CurMod = MOD_INIT
    u = UBound(RecvData)
    ReDim DispBuf(u)
    j = 0 'Index of DispBuf
    For i = 0 To u 'one byte by byte
        b = RecvData(i)
        If b = 0 Then
            'discard NULL value
            'do nothing
        Else
            Select Case CurMod
            Case MOD_INIT
                If b = CMD_IAC Then '255
                    CurMod = MOD_IAC_START
                Else
                    DispBuf(j) = RecvData(i)
                    j = j + 1
                End If
            Case MOD_IAC_START
                Select Case b
                    Case CMD_DONT
                        CurMod = MOD_DONT
                    Case CMD_DO
                        CurMod = MOD_DO
                    Case CMD_WONT
                        CurMod = MOD_WONT
                    Case CMD_WILL
                        CurMod = MOD_WILL
                    Case CMD_SB 'wait for a SE to end
                        CurMod = MOD_SB
                End Select
            Case MOD_DO
                'Server Request for option
                Select Case RecvData(i)
                    Case OPT_BIN '0 Binary Transmission
                        ReplyBuf = CMD_IAC & "," & CMD_WILL & "," & RecvData(i)
                    Case OPT_SUPP '3 Suppress Go Ahead
                        ReplyBuf = CMD_IAC & "," & CMD_WILL & "," & RecvData(i)
                    Case OPT_TERM '24 Terminal Type
                        ReplyBuf = CMD_IAC & "," & CMD_WILL & "," & RecvData(i)
                    Case OPT_NAWS '31 Negotiate About Window Size (132 columns, 0 rows will receive all data in one time)
                        ReplyBuf = CMD_IAC & "," & CMD_WILL & "," & RecvData(i) & "," & _
                            CMD_IAC & "," & CMD_SB & "," & OPT_NAWS & "," & 0 & "," & 132 & "," & 0 & "," & 0 & "," & CMD_IAC & "," & CMD_SE
                    Case Else
                        ReplyBuf = CMD_IAC & "," & CMD_WONT & "," & RecvData(i)
                End Select
                CurMod = MOD_INIT
            Case MOD_WILL
                Select Case RecvData(i)
                    Case OPT_BIN
                        ReplyBuf = CMD_IAC & "," & CMD_DO & "," & RecvData(i)
                    Case OPT_ECHO
                        'If Not bInEchoRx Then
                        '    bInEchoRx = True
                            ReplyBuf = CMD_IAC & "," & CMD_DO & "," & RecvData(i)
                        'End If
                    Case OPT_SUPP '3 Suppress Go Ahead
                        ReplyBuf = CMD_IAC & "," & CMD_DO & "," & RecvData(i)
                    Case Else
                        ReplyBuf = CMD_IAC & "," & CMD_DONT & "," & RecvData(i)
                End Select
                CurMod = MOD_INIT
            Case MOD_WONT
                Select Case RecvData(i)
                    Case OPT_ECHO '1
                        'If bInEchoRx Then
                        '    bInEchoRx = False
                            ReplyBuf = CMD_IAC & "," & CMD_DONT & "," & RecvData(i)
                        'End If
                    Case OPT_SUPP
                        ReplyBuf = CMD_IAC & "," & CMD_DONT & "," & RecvData(i)
                End Select
                
                CurMod = MOD_INIT
            Case MOD_DONT
                Select Case RecvData(i)
                    Case OPT_ECHO
                        ReplyBuf = CMD_IAC & "," & CMD_WONT & "," & RecvData(i)
                    Case OPT_NAWS
                        ReplyBuf = CMD_IAC & "," & CMD_WONT & "," & RecvData(i)
                End Select
                CurMod = MOD_INIT
            Case MOD_SB 'Indicates that what follows is subnegotiation of the indicated option.
                Select Case RecvData(i)
                    Case OPT_TERM
                        SB_Option = OPT_TERM
                        CurMod = MOD_WAITFOR_SE
                    Case OPT_NENVIR
                        SB_Option = OPT_NENVIR
                        CurMod = MOD_WAITFOR_SE
                    Case Else
                        CurMod = MOD_INIT
                End Select
            Case MOD_WAITFOR_SE
                If RecvData(i) = CMD_SE Then
                    If SB_Option = OPT_TERM Then
                        'IAC SB TERMINAL-TYPE IS ... IAC SE (ex:IAC SB Terminal-Type IS ANSI IAC SE)
                        'The code for IS is 0
                        ReplyBuf = CMD_IAC & "," & CMD_SB & "," & OPT_TERM & "," & 0 & "," & _
                            Asc("V") & "," & Asc("T") & "," & Asc("1") & "," & Asc("0") & "," & Asc("0") & _
                            "," & CMD_IAC & "," & CMD_SE
                    End If
                    CurMod = MOD_INIT
                End If
            End Select
            
            If ReplyBuf <> "" Then
                'קKĤ@ӳr
                If strReplyCmd = "" Then
                    sep = ""
                Else
                    sep = ","
                End If
                strReplyCmd = strReplyCmd & sep & ReplyBuf
                ReplyBuf = ""
            End If
    
        End If
    Next
        
    If j > 0 Then 'there is data
        ReDim Preserve DispBuf(j - 1)
        DispData = StrConv(DispBuf, vbUnicode)
        'Unix to Dos
        Dim dosbuf As String
        dosbuf = Replace(DispData, vbCrLf, Chr(10))
        dosbuf = Replace(dosbuf, Chr(13), "")
        dosbuf = Replace(dosbuf, Chr(10), vbCrLf)
        DispData = dosbuf
    Else
        DispData = ""
    End If
    GetDispData = j 'lenght of data
    'convert it to byte()
    Dim buf
    If strReplyCmd <> "" Then
        buf = Split(strReplyCmd, ",")
        ReDim byteReplyCmd(UBound(buf)) As Byte
        For i = 0 To UBound(buf)
            byteReplyCmd(i) = val(buf(i))
        Next
        Winsock1.SendData byteReplyCmd 'auto respond TELNET CMD
    End If
    
    Exit Function
ErrHandler:
    RaiseEvent Error("GetDispData Error!" & vbCrLf & Err.Description)
End Function

Public Sub Connect(host As String, Port As Integer, Optional Timeout As Long = 30)
    If Winsock1.State <> sckClosed Then
        Winsock1.Close
    End If
    tmrConnect.Interval = CLng(Timeout * 1000)
    tmrConnect.enabled = True
    Winsock1.Connect host, Port
End Sub

Public Sub Disconnect()
    If Winsock1.State <> sckClosed Then
        Winsock1.Close
    End If
    If Winsock1.State <> sckConnected Then
        edit.Panel1 "Desconectado.", vbRed
    End If
End Sub

Private Sub Winsock1_Close()
'this is remote(telnet server) triggered event
    edit.Panel1 "Conexin cerrada.", vbRed
    RaiseEvent Closed
End Sub

Private Sub Winsock1_Connect()
Dim ConnectString As String
    'Inicia estado de terminal
    sw_echo = True
    sw_ugoahead = True
    sw_igoahead = False
    sw_linemode = False
    sw_termsent = False
    substate = False
    ConnectString = Chr$(CMD_IAC) & Chr$(CMD_DO) & Chr$(OPT_ECHO) _
                  & Chr$(CMD_IAC) & Chr$(CMD_DO) & Chr$(OPT_SUPP) _
                  & Chr$(CMD_IAC) & Chr$(CMD_WILL) & Chr$(OPT_NAWS) _
                  & Chr$(CMD_IAC) & Chr$(CMD_WILL) & Chr$(OPT_TERM) _
                  & Chr$(CMD_IAC) & Chr$(CMD_WILL) & Chr$(OPT_TS)
    Winsock1.SendData ConnectString
    If TraceTelnet Then Debug.Print "SENT: CMD_DO ECHO SGA"
    If TraceTelnet Then Debug.Print "SENT: CMD_WILL NAWS TERMTYPE TERMSPEED"
    
    'disable connection time to count down
    tmrConnect.enabled = False
    tmrConnect.Interval = 0
    edit.Panel1 "Conectado a " & Winsock1.RemoteHostIP, RGB(0, 128, 0)
    RaiseEvent Connected
End Sub

Private Sub Winsock1_DataArrival(ByVal bytesTotal As Long)
Dim ch()     As Byte
Dim i        As Integer
Static cmd   As Byte
Dim nLin As Long
Dim enganchado As Boolean
'------------------------------------------------------------
    On Error GoTo ErrHandler
    If Receiving Then Exit Sub Else Receiving = True
    If (bytesTotal > 0) Then  ' If there is any data...
        enganchado = edit.CursorEditEngan    'verifica cursor de editor
        Winsock1.GetData ch, vbByte + vbArray, bytesTotal
        For i = 0 To bytesTotal - 1
'Debug.Print "recibido:" & ch(i) & "-" & Chr(ch(i))
            Select Case cmd
            Case GO_NORM: cmd = term_processChar(ch(i))
            Case GO_IAC1: cmd = iac1(ch(i))
            Case GO_IAC2: cmd = iac2(ch(i))
            Case GO_IAC3: cmd = iac3(ch(i))
            Case GO_IAC4: cmd = iac4(ch(i))
            Case GO_IAC5: cmd = iac5(ch(i))
            Case GO_IAC6: cmd = iac6(ch(i))
            Case Else
                If TraceTelnet Then Debug.Print "Invalid 'next (" + Str$(cmd) + ")' processing routine in cmd loop"
            End Select
        Next
        
        nLin = edit.nLin     've nmero de lneas
        'verifica si se excede la cantidad de lneas permitidas
        If nLin > TerMaxLin Then
            'se eliminan 20 ms para evitar mltiples llamadas
            edit.EliminarLineasIni Abs(nLin - TerMaxLin) + 20
        End If
        'mantiene el enganche al cursor y desplaza pantalla
        If enganchado Then edit.EnganCursorEdit
        Call edit.Dibujar
        RaiseEvent Receive(ch)     'genera evento
    End If
    Receiving = False   'desmarca bandera
    On Error GoTo 0
    Exit Sub
ErrHandler:
    RaiseEvent Error("Error occurred!" & Err.Description)
End Sub

Public Function State() As Integer
    State = Winsock1.State
End Function

'*************************** FUNCIONES DE ENVO DE DATOS **********************
Public Sub KeyDown(KeyCode As Integer, Shift As Integer)
'Respuesta al evento "Form_KeyDown" para comunicacin con el terminal
Dim ch As String
   ch = Chr$(0)
   'Translate keycodes to VT100 escape sequences
   Select Case KeyCode
   Case vbKeyControl
        control_on = True
   Case vbKeyEnd:     ch = Chr$(27) + "[K"
   Case vbKeyHome:    ch = Chr$(27) + "[H"
   Case vbKeyLeft:    ch = Chr$(27) + "[D"
   Case vbKeyUp:      ch = Chr$(27) + "[A"
   Case vbKeyRight:   ch = Chr$(27) + "[C"
   Case vbKeyDown:    ch = Chr$(27) + "[B"
   Case vbKeyF1:      ch = Chr$(27) + "OP"
   Case vbKeyF2:      ch = Chr$(27) + "OQ"
   Case vbKeyF3:      ch = Chr$(27) + "OR"
   Case vbKeyF4:      ch = Chr$(27) + "OS"
   Case Else
      If control_on And KeyCode > 63 Then
          ch = Chr$(KeyCode - 64)
      End If
   End Select
   If ch > Chr$(0) And Winsock1.State = sckConnected Then
      Winsock1.SendData ch
      If TraceTelnet Then Debug.Print ch
   End If
End Sub

Public Sub KeyPress(KeyAscii As Integer)
Dim ch As String
    If Winsock1.State = sckConnected Then
        ch = Chr$(KeyAscii)
        If control_on Then
          If KeyAscii > 63 Then
            ch = Chr$(KeyAscii - 64)
          Else
            ch = Chr$(0)
          End If
        End If
        If ch > Chr$(0) Then
              If ch = Chr$(13) Then
                ch = ch & Chr$(10)
              End If
              Winsock1.SendData ch
        End If
    End If
End Sub

Public Sub KeyUp(KeyCode As Integer, Shift As Integer)
    Select Case KeyCode
    Case vbKeyControl
        control_on = False
    End Select
End Sub

Public Sub SendData(txt As String)
'Enva una cadena completa por el terminal
'Dim i As Integer
    If Winsock1.State <> sckConnected Then Exit Sub
'    If txt = "" Then Exit Sub
'    For i = 1 To Len(txt)
'        KeyPress Asc(Mid$(txt, i, 1))
'    Next
    Winsock1.SendData txt
End Sub

'************************ PROCESAMIENTO DE DATOS DE LLEGADA *********************
Public Function iac1(ch As Byte) As Integer
  ' Debug.Print "IAC : ";
  iac1 = GO_NORM
  Select Case ch
    Case CMD_DO
      iac1 = GO_IAC2
    Case CMD_DONT
      iac1 = GO_IAC6
    Case CMD_WILL
      iac1 = GO_IAC3
    Case CMD_WONT
      iac1 = GO_IAC4
    Case CMD_SB
      iac1 = GO_IAC5
      ppno = 0
    Case CMD_SE
      ' End of negotiation string, string is in parsedata()
      Select Case parsedata(0)
        Case OPT_TERM
          If parsedata(1) = 1 Then
               If TraceTelnet Then Debug.Print "SENT: SB TERMTYPE VT100"
                Winsock1.SendData Chr$(CMD_IAC) & Chr$(CMD_SB) & Chr$(OPT_TERM) & "DEC-VT100" & Chr$(0) & Chr$(CMD_IAC) & Chr$(CMD_SE)
          End If
        Case OPT_TS     '**** La velocidad parece no negociarse bien
          If parsedata(1) = 1 Then
                ' Debug.Print "TERMSPEED"
                If TraceTelnet Then Debug.Print "SENT: SB TERMSPEED 38400"
                Winsock1.SendData Chr$(CMD_IAC) & Chr$(CMD_WILL) & Chr$(ch)
                Winsock1.SendData Chr$(CMD_IAC) & Chr$(CMD_SB) _
                                & Chr$(OPT_TS) & Chr$(0) _
                                & "38400,38400" _
                                & Chr$(CMD_IAC) & Chr$(CMD_SE)
          End If
      End Select
  End Select

End Function

Public Function iac2(ch As Byte) As Integer
  'DO Processing Respond with WILL or WONT
  If TraceTelnet Then Debug.Print "                                                                   RECEIVED DO : ";
  iac2 = GO_NORM

  Select Case ch
    Case OPT_BIN
        If TraceTelnet Then Debug.Print "BINARY"
        Winsock1.SendData Chr$(CMD_IAC) & Chr$(CMD_WONT) & Chr$(OPT_BIN)
        If TraceTelnet Then Debug.Print "SENT: WONT BINARY"
    Case OPT_ECHO
        If TraceTelnet Then Debug.Print "ECHO"
        Winsock1.SendData Chr$(CMD_IAC) & Chr$(CMD_WONT) & Chr$(OPT_ECHO)
        If TraceTelnet Then Debug.Print "SENT: WONT ECHO"
    Case OPT_NAWS
        If TraceTelnet Then Debug.Print "WINDOW SIZE"
        Winsock1.SendData Chr$(CMD_IAC) & Chr$(CMD_SB) & Chr$(OPT_NAWS) & Chr$(0) & _
                          Chr$(AncTerm) & Chr$(0) & Chr$(AltTerm) & Chr$(CMD_IAC) & Chr$(CMD_SE)
        If TraceTelnet Then Debug.Print "SENT: SB WINDOW SIZE 80x24"
    Case OPT_SUPP
        If TraceTelnet Then Debug.Print "SGA"
        If Not sw_igoahead Then
            If TraceTelnet Then Debug.Print "SENT: WILL SGA"
            Winsock1.SendData Chr$(CMD_IAC) & Chr$(CMD_WILL) & Chr$(OPT_SUPP)
            sw_igoahead = True
        Else
           If TraceTelnet Then Debug.Print "DID NOT RESPOND"
        End If
    Case OPT_TERM
        If TraceTelnet Then Debug.Print "TERMTYPE"
        If Not sw_termsent Then
            If TraceTelnet Then Debug.Print "SENT: WILL TERMTYPE"
              sw_termsent = True
              Winsock1.SendData Chr$(CMD_IAC) & Chr$(CMD_WILL) & Chr$(OPT_TERM)
            If TraceTelnet Then Debug.Print "SENT: SB TERMTYPE VT100"
              Winsock1.SendData Chr$(CMD_IAC) & Chr$(CMD_SB) & Chr$(OPT_TERM) & _
              Chr$(0) & "VT100" & Chr$(CMD_IAC) & Chr$(CMD_SE)
         Else
            If TraceTelnet Then Debug.Print "DID NOT RESPOND"
         End If
 
    Case OPT_TS
        If TraceTelnet Then Debug.Print "TERMSPEED"
        If TraceTelnet Then Debug.Print "SENT: WILL TERMSPEED"
        Winsock1.SendData Chr$(CMD_IAC) & Chr$(CMD_WILL) & Chr$(OPT_TS)
      
    If TraceTelnet Then Debug.Print "SENT: SB TERMSPEED 57600"
        Winsock1.SendData Chr$(CMD_IAC) & Chr$(CMD_SB) & Chr$(OPT_TS) & Chr$(0)
        Winsock1.SendData "57600,57600"
        Winsock1.SendData Chr$(CMD_IAC) & Chr$(CMD_SE)
      
    Case OPT_RFC
        If TraceTelnet Then Debug.Print "TFLOWCNTRL"
        If TraceTelnet Then Debug.Print "SENT: WONT FLOWCONTROL"
        Winsock1.SendData Chr$(CMD_IAC) & Chr$(CMD_WONT) & Chr$(ch)
      
    Case OPT_LINE
        If TraceTelnet Then Debug.Print "LINEMODE"
        If TraceTelnet Then Debug.Print "SENT: WONT LINEMODE"
        Winsock1.SendData Chr$(CMD_IAC) & Chr$(CMD_WONT) & Chr$(ch)
      
    Case OPT_STAT
        If TraceTelnet Then Debug.Print "STATUS"
        If TraceTelnet Then Debug.Print "SENT: WONT STATUS"
        Winsock1.SendData Chr$(CMD_IAC) & Chr$(CMD_WONT) & Chr$(ch)
      
    Case OPT_TIM
        If TraceTelnet Then Debug.Print "TIMING"
        If TraceTelnet Then Debug.Print "SENT: WONT TIMING"
        Winsock1.SendData Chr$(CMD_IAC) & Chr$(CMD_WONT) & Chr$(ch)
      
    Case OPT_XDL
        If TraceTelnet Then Debug.Print "DISPLOC"
        If TraceTelnet Then Debug.Print "SENT: WONT DISPLOC"
        Winsock1.SendData Chr$(CMD_IAC) & Chr$(CMD_WONT) & Chr$(ch)
    
    Case OPT_ENVIR
        If TraceTelnet Then Debug.Print "ENVIRON"
        If TraceTelnet Then Debug.Print "SENT: WONT ENVIRON"
        Winsock1.SendData Chr$(CMD_IAC) & Chr$(CMD_WONT) & Chr$(ch)
    
    Case OPT_NENVIR
        If TraceTelnet Then Debug.Print "UNKNOWN39"
        If TraceTelnet Then Debug.Print "SENT: WONT " & Asc(ch)
        Winsock1.SendData Chr$(CMD_IAC) & Chr$(CMD_WONT) & Chr$(ch)
    
    Case OPT_AUTH
        If TraceTelnet Then Debug.Print "AUTHENTICATION"
        If TraceTelnet Then Debug.Print "SENT: WILL "; OPT_AUTH; ""
        Winsock1.SendData Chr$(CMD_IAC) & Chr$(CMD_WILL) & Chr$(ch)
      
        If TraceTelnet Then Debug.Print "SENT: SB AUTHENTICATION"
        Winsock1.SendData Chr$(CMD_IAC) & _
                          Chr$(CMD_SB) & _
                          Chr$(OPT_AUTH) & _
                          Chr$(0) & Chr$(0) & Chr$(0) & Chr$(0) & _
                          Chr$(CMD_IAC) & _
                          Chr$(CMD_SE)
    Case Else
        If TraceTelnet Then Debug.Print "UNKNOWN CMD " & Asc(ch)
        If TraceTelnet Then Debug.Print "SENT: WONT UNKNOWN CMD " & ch
        Winsock1.SendData Chr$(CMD_IAC) & Chr$(CMD_WONT) & Chr$(ch)
  End Select
End Function

Public Function iac3(ch As Byte) As Integer

  ' WILL Processing - Respond with DO or DONT
  
If TraceTelnet Then Debug.Print "                                                                   RECEIVED WILL : ";

  iac3 = GO_NORM

  Select Case ch
    Case OPT_ECHO
    If TraceTelnet Then Debug.Print "ECHO"
      If Not sw_echo Then
        sw_echo = True
        Winsock1.SendData Chr$(CMD_IAC) & Chr$(CMD_DO) & Chr$(OPT_ECHO)
      If TraceTelnet Then Debug.Print "SENT: DO ECHO"
      End If
    Case OPT_SUPP
      If TraceTelnet Then Debug.Print "SGA"
      If Not sw_ugoahead Then
        sw_ugoahead = True
        Winsock1.SendData Chr$(CMD_IAC) & Chr$(CMD_DO) & Chr$(OPT_SUPP)
        If TraceTelnet Then Debug.Print "SENT: DOTEL SGA"
      End If
    
    Case OPT_TS
    If TraceTelnet Then Debug.Print "TERMSPEED"
    If TraceTelnet Then Debug.Print "SENT: DONT TERMSPEED"
      Winsock1.SendData Chr$(CMD_IAC) & Chr$(CMD_DONT) & Chr$(ch)
      
    Case OPT_RFC
    If TraceTelnet Then Debug.Print "TFLOWCNTRL"
    If TraceTelnet Then Debug.Print "SENT: DONT FLOWCONTROL"
      Winsock1.SendData Chr$(CMD_IAC) & Chr$(CMD_DONT) & Chr$(ch)
      
    Case OPT_LINE
    If TraceTelnet Then Debug.Print "LINEMODE"
    If TraceTelnet Then Debug.Print "SENT: DONT LINEMODE"
      Winsock1.SendData Chr$(CMD_IAC) & Chr$(CMD_DONT) & Chr$(ch)
      
    Case OPT_STAT
    If TraceTelnet Then Debug.Print "STATUS"
    If TraceTelnet Then Debug.Print "SENT: DONT STATUS"
      Winsock1.SendData Chr$(CMD_IAC) & Chr$(CMD_DONT) & Chr$(ch)
      
    Case OPT_TIM
    If TraceTelnet Then Debug.Print "TIMING"
    If TraceTelnet Then Debug.Print "SENT: DONT TIMING"
      Winsock1.SendData Chr$(CMD_IAC) & Chr$(CMD_DONT) & Chr$(ch)
      
    Case OPT_XDL
    If TraceTelnet Then Debug.Print "DISPLOC"
    If TraceTelnet Then Debug.Print "SENT: WONT DISPLOC"
      Winsock1.SendData Chr$(CMD_IAC) & Chr$(CMD_DONT) & Chr$(ch)
    
    Case OPT_ENVIR
    If TraceTelnet Then Debug.Print "ENVIRON"
    If TraceTelnet Then Debug.Print "SENT: WONT ENVIRON"
      Winsock1.SendData Chr$(CMD_IAC) & Chr$(CMD_DONT) & Chr$(ch)
    
    Case OPT_NENVIR
    If TraceTelnet Then Debug.Print "UNKNOWN39"
    If TraceTelnet Then Debug.Print "SENT: WONT " & Asc(ch)
      Winsock1.SendData Chr$(CMD_IAC) & Chr$(CMD_DONT) & Chr$(ch)
    
    
    Case Else
    If TraceTelnet Then Debug.Print "UNKNOWN CMD " & Asc(ch)
    If TraceTelnet Then Debug.Print "SENT: WONT UNKNOWN CMD " & Asc(ch)
      Winsock1.SendData Chr$(CMD_IAC) & Chr$(CMD_DONT) & Chr$(ch)
  End Select

End Function

Public Function iac4(ch As Byte) As Integer
  ' WONT Processing
    If TraceTelnet Then Debug.Print "                                                                   RECEIVED WONT : ";
  iac4 = GO_NORM
  Select Case ch
    Case OPT_ECHO
    If TraceTelnet Then Debug.Print "ECHO"
      If sw_echo = True Then
        Winsock1.SendData Chr$(CMD_IAC) & Chr$(CMD_DONT) & Chr$(OPT_ECHO)
      If TraceTelnet Then Debug.Print "SENT: DONTEL ECHO"
        sw_echo = False
      End If
      
    Case OPT_SUPP
    If TraceTelnet Then Debug.Print "SGA"
    If TraceTelnet Then Debug.Print "SENT: DONT SGA"
      Winsock1.SendData Chr$(CMD_IAC) & Chr$(CMD_DONT) & Chr$(OPT_SUPP)
      sw_igoahead = False
    
    Case OPT_TS
    If TraceTelnet Then Debug.Print "TERMSPEED"
    If TraceTelnet Then Debug.Print "SENT: DONT TERMSPEED"
      Winsock1.SendData Chr$(CMD_IAC) & Chr$(CMD_DONT) & Chr$(ch)
    
    Case OPT_RFC
    If TraceTelnet Then Debug.Print "FLOWCONTROL"
    If TraceTelnet Then Debug.Print "SENT: DONT FLOWCONTROL"
      Winsock1.SendData Chr$(CMD_IAC) & Chr$(CMD_DONT) & Chr$(ch)
      
    Case OPT_LINE
    If TraceTelnet Then Debug.Print "LINEMODE"
    If TraceTelnet Then Debug.Print "SENT: DONT LINEMODE"
      Winsock1.SendData Chr$(CMD_IAC) & Chr$(CMD_DONT) & Chr$(ch)
      
    Case OPT_STAT
    If TraceTelnet Then Debug.Print "STATUS"
    If TraceTelnet Then Debug.Print "SENT: DONT STATUS"
      Winsock1.SendData Chr$(CMD_IAC) & Chr$(CMD_DONT) & Chr$(ch)
      
    Case OPT_TIM
    If TraceTelnet Then Debug.Print "TIMING"
    If TraceTelnet Then Debug.Print "SENT: DONT TIMING"
      Winsock1.SendData Chr$(CMD_IAC) & Chr$(CMD_DONT) & Chr$(ch)
      
    Case OPT_XDL
    If TraceTelnet Then Debug.Print "DISPLOC"
    If TraceTelnet Then Debug.Print "SENT: DONT DISPLOC"
      Winsock1.SendData Chr$(CMD_IAC) & Chr$(CMD_DONT) & Chr$(ch)
    
    Case OPT_ENVIR
    If TraceTelnet Then Debug.Print "ENVIRON"
    If TraceTelnet Then Debug.Print "SENT: DONT ENVIRON"
      Winsock1.SendData Chr$(CMD_IAC) & Chr$(CMD_DONT) & Chr$(ch)
    
    Case OPT_NENVIR
    If TraceTelnet Then Debug.Print "UNKNOWN39"
    If TraceTelnet Then Debug.Print "SENT: DONT " & Asc(ch)
      Winsock1.SendData Chr$(CMD_IAC) & Chr$(CMD_DONT) & Chr$(ch)
    
    Case Else
    If TraceTelnet Then Debug.Print "UNKNOWN CMD " & Asc(ch)
    If TraceTelnet Then Debug.Print "SENT: DONT UNKNOWN CMD " & Asc(ch)
      Winsock1.SendData Chr$(CMD_IAC) & Chr$(CMD_WONT) & Chr$(ch)
  End Select

End Function

Public Function iac5(ch As Byte) As Integer

Dim ich As Integer
  ' Collect parms after SB and until another IAC

  
    ich = ch
    If ich = CMD_IAC Then
      iac5 = GO_IAC1
      Exit Function
    End If
    
    If TraceTelnet Then Debug.Print "                                                                   RECEIVED : ";
    If TraceTelnet Then Debug.Print "SB("; ppno; ") = " & ich
    parsedata(ppno) = ich
    ppno = ppno + 1
    iac5 = GO_IAC5
End Function

Public Function iac6(ch As Byte) As Integer
  'DONT Processing
  iac6 = GO_NORM
  Select Case ch
    Case CMD_SE
      If TraceTelnet Then Debug.Print "                                                                   RECEIVED SE"
      If TraceTelnet Then Debug.Print "SENT: SE_ACK " & ch

    Case OPT_ECHO
      If TraceTelnet Then Debug.Print "                                                                   RECEIVED DONT : ";
      If TraceTelnet Then Debug.Print "ECHO"
      If Not sw_echo Then
        sw_echo = True
        Winsock1.SendData Chr$(CMD_IAC) & Chr$(CMD_WONT) & Chr$(OPT_ECHO)
        If TraceTelnet Then Debug.Print "SENT: WONT ECHO"
      End If
    Case OPT_SUPP
      If TraceTelnet Then Debug.Print "                                                                   RECEIVED DONT : ";
      If TraceTelnet Then Debug.Print "SGA"
      If Not sw_ugoahead Then
        sw_ugoahead = True
        Winsock1.SendData Chr$(CMD_IAC) & Chr$(CMD_WONT) & Chr$(OPT_SUPP)
        If TraceTelnet Then Debug.Print "SENT: WONT SGA"
      End If
    
    Case OPT_TS
      If TraceTelnet Then Debug.Print "                                                                   RECEIVED DONT : ";
      If TraceTelnet Then Debug.Print "TERMSPEED"
      If TraceTelnet Then Debug.Print "SENT: WONT TERMSPEED"
      Winsock1.SendData Chr$(CMD_IAC) & Chr$(CMD_WONT) & Chr$(ch)
      
    Case OPT_RFC
      If TraceTelnet Then Debug.Print "                                                                   RECEIVED DONT : ";
      If TraceTelnet Then Debug.Print "TFLOWCNTRL"
      If TraceTelnet Then Debug.Print "SENT: WONT FLOWCONTROL"
      Winsock1.SendData Chr$(CMD_IAC) & Chr$(CMD_WONT) & Chr$(ch)
      
    Case OPT_LINE
      If TraceTelnet Then Debug.Print "                                                                   RECEIVED DONT : ";
      If TraceTelnet Then Debug.Print "LINEMODE"
      If TraceTelnet Then Debug.Print "SENT: WONT LINEMODE"
      Winsock1.SendData Chr$(CMD_IAC) & Chr$(CMD_WONT) & Chr$(ch)
      
    Case OPT_STAT
      If TraceTelnet Then Debug.Print "                                                                   RECEIVED DONT : ";
      If TraceTelnet Then Debug.Print "STATUS"
      If TraceTelnet Then Debug.Print "SENT: WONT STATUS"
      Winsock1.SendData Chr$(CMD_IAC) & Chr$(CMD_WONT) & Chr$(ch)
      
    Case OPT_TIM
      If TraceTelnet Then Debug.Print "                                                                   RECEIVED DONT : ";
      If TraceTelnet Then Debug.Print "TIMING"
      If TraceTelnet Then Debug.Print "SENT: WONT TIMING"
      Winsock1.SendData Chr$(CMD_IAC) & Chr$(CMD_WONT) & Chr$(ch)
      
    Case OPT_XDL
      If TraceTelnet Then Debug.Print "                                                                   RECEIVED DONT : ";
      If TraceTelnet Then Debug.Print "DISPLOC"
      If TraceTelnet Then Debug.Print "SENT: WONT DISPLOC"
      Winsock1.SendData Chr$(CMD_IAC) & Chr$(CMD_WONT) & Chr$(ch)
    
    Case OPT_ENVIR
      If TraceTelnet Then Debug.Print "                                                                   RECEIVED DONT : ";
      If TraceTelnet Then Debug.Print "ENVIRON"
      If TraceTelnet Then Debug.Print "SENT: WONT ENVIRON"
      Winsock1.SendData Chr$(CMD_IAC) & Chr$(CMD_WONT) & Chr$(ch)
    
    Case OPT_NENVIR
      If TraceTelnet Then Debug.Print "                                                                   RECEIVED DONT : ";
      If TraceTelnet Then Debug.Print "UNKNOWN39"
      If TraceTelnet Then Debug.Print "SENT: WONT " & Asc(ch)
      Winsock1.SendData Chr$(CMD_IAC) & Chr$(CMD_WONT) & Chr$(ch)
        
    Case Else
      If TraceTelnet Then Debug.Print "                                                                   RECEIVED DONT : ";
      If TraceTelnet Then Debug.Print "UNKNOWN CMD " & Asc(ch)
      If TraceTelnet Then Debug.Print "SENT: WONT UNKNOWN CMD " & Asc(ch)
      Winsock1.SendData Chr$(CMD_IAC) & Chr$(CMD_WONT) & Chr$(ch)
  End Select
End Function

'************************ FUNCIONES DE RECEPCIN DE DATOS ********************
Public Function term_processChar(ch As Byte) As Byte
    If (InEscape) Then
        Call term_escapeProcess(ch)
    Else
        Select Case ch
        Case 0  'no hace nada
        Case 27
            InEscape = True
            EscString = ""
        Case 255
            term_processChar = GO_IAC1
        Case Else   'Es caracter procesable por el editor
'            If CH < 32 Or CH > 128 Then
'                Debug.Print "#" & CH
'            Else
'                Debug.Print Chr(CH)
'            End If
            edit.TelnetCar ch
        End Select
    End If
End Function

Private Sub term_escapeProcess(ch As Byte)

Dim c           As String
Dim yDiff       As Integer
Dim xDiff       As Integer
    c = Chr$(ch)
    If EscString = "" Then
        'No start character yet
        Select Case c
        Case "["
        Case "("
        Case ")"
        Case "#"
        'Verifica si es una secuencia de escape corta (de dos caracteres)
        Case Chr$(8)             ' embedded backspace
            edit.FijaCursorTel edit.curX - 1, edit.curY
            InEscape = False
        Case "7"                 ' save cursor
            edit.LeeCursorTel SavecurX, SavecurY
            InEscape = False
        Case "8"                 ' restore cursor
            edit.FijaCursorTel SavecurX, SavecurY
            InEscape = False
        Case "c"                 ' look at VSIreset()
        Case "D"                 ' cursor down
            edit.FijaCursorTel edit.curX, edit.curY + 1
            InEscape = False
        Case "E"                 ' next line
            edit.FijaCursorTel 0, edit.curY + 1
            InEscape = False
        Case "H"                 ' set tab
Debug.Print "Secuencia no soportada ESC-H"
            'RaiseEvent Receive(vbTab)
            InEscape = False
        Case "I"                 ' look at bp_ESC_I()
            InEscape = False
        Case "M"                 ' cursor up
            edit.FijaCursorTel edit.curX, edit.curY + 1
            InEscape = False
        Case "Z"                 ' send ident
            InEscape = False
        Case Else
              'Invalid start of escape sequence
            If Tracevt100 Then Debug.Print ch
            InEscape = False
            Exit Sub
        End Select
    End If

    EscString = EscString & c
    If IsCharAlpha(ch) = 0 Then
        'Not a character ...
'        If Len(EscString) > 15 Then
'            If Tracevt100 Then Debug.Print ch
'            InEscape = False
'        End If
        Exit Sub
    End If
    'Se complet la secuencia de escape.
'Debug.Print "Escape:" & EscString
    If EscString = "(B" Then
        'restaura condicin predeterminada (ISO 8859-1)
    Else    'Se asume que es "["
        Select Case c
        Case "A"    ' A ==> move cursor up
            EscString = Mid$(EscString, 2)
            yDiff = val(term_escapeParseArg(EscString))
            If yDiff = 0 Then
                yDiff = 1
            End If
            edit.FijaCursorTel edit.curX, edit.curY - yDiff
        Case "B"    ' B ==> move cursor down
            EscString = Mid$(EscString, 2)
            yDiff = val(term_escapeParseArg(EscString))
            If yDiff = 0 Then
                yDiff = 1
            End If
            edit.FijaCursorTel edit.curX, edit.curY + yDiff
        Case "C"    ' C ==> move cursor right
            EscString = Mid$(EscString, 2)
            xDiff = val(term_escapeParseArg(EscString))
            If xDiff = 0 Then
                xDiff = 1
            End If
            edit.FijaCursorTel edit.curX + xDiff, edit.curY
        Case "D"    ' D ==> move cursor left
            EscString = Mid$(EscString, 2)
    
            xDiff = val(term_escapeParseArg(EscString))
            If xDiff = 0 Then
                xDiff = 1
            End If
            edit.FijaCursorTel edit.curX - xDiff, edit.curY
        Case "H"    'Goto cursor position indicated by escape sequence
            EscString = Mid$(EscString, 2)
            curY = val(term_escapeParseArg(EscString)) - 1
            curX = val(EscString) - 1
            edit.FijaCursorTel curX, curY
        Case "J"    'Erase display
            Select Case val(Mid$(EscString, 2))
                Case 0
                    If curX = 0 And curY = 0 Then
                        edit.eraseSCREEN
                    Else    'Borrar hasta el final de la pantalla
                        edit.eraseEOS
                    End If
                Case 1  'Borra pantalla antes del cursor
                    edit.eraseBOS
                Case 2
                    edit.eraseSCREEN
            End Select
        Case "K"    'Erase line
            Select Case val(Mid$(EscString, 2))
            Case 0 'erase to end of line
                edit.eraseEOL
            Case 1 'borra hasta el cursor
                edit.eraseBOL
            Case 2
                edit.eraseLINE
            End Select
        Case "f"    'Goto cursor position indicated by escape sequence
            EscString = Mid$(EscString, 2)
            curY = val(term_escapeParseArg(EscString)) - 1
            curX = val(EscString) - 1
            edit.FijaCursorTel curX, curY
        Case "g"    ' clear tabs
            Dim tY As Integer
    Debug.Print "Secuencia no soportada ESC-g"
    '        For tY = 0 To 19
    '          tab_table(tY) = 0
    '        Next tY
        Case "h"    'restore cursor position
            edit.FijaCursorTel SavecurX, SavecurY
        Case "i"
            ' print though mode
        Case "l"        'Save cursor position
            edit.LeeCursorTel SavecurX, SavecurY
        Case "m"    'Change text attributes, screen colors
    Debug.Print "Secuencia no soportada ESC-m"
            EscString = Mid$(EscString, 2)
    '        Do
    '            Call term_setattr(Chr$(val(term_escapeParseArg(EscString))))
    '        Loop While EscString <> ""
        Case "r"
    Debug.Print "Secuencia no soportada ESC-r"
    '        'Set scrollable region
    '        EscString = Mid$(EscString, 2)
    '        lprcScroll.Top = (val(term_escapeParseArg(EscString)) - 1) * charheight
    '        lprcClip = lprcScroll
        Case "s"        'Save cursor position
            edit.LeeCursorTel SavecurX, SavecurY
        Case "u"        'restore cursor position
            edit.FijaCursorTel SavecurX, SavecurY
        Case Else
            If Tracevt100 Then Debug.Print EscString
        End Select
    End If
    InEscape = False
    EscString = ""
End Sub

Private Function term_escapeParseArg(s As String) As String
'   PopArg takes the next argument (digits up to a ;) and
'   returns it.  It also removes the arg and the ; from
'   the "s"
Dim i As Integer
    i = InStr(s, ";")
    If i = 0 Then
        term_escapeParseArg = s
        s = ""
    Else
        term_escapeParseArg = Left$(s, i - 1)
        s = Mid$(s, i + 1)
    End If
End Function

Public Sub LimpiarPantalla()
'Limpia la pantalla del Terminal
    edit.eraseSCREEN
    edit.Refrescar
End Sub

Public Sub LimpiaBuffer()
'Limpia la pantalla y el Buffer
    edit.Text = ""
    edit.y0 = 1     'reubica terminal
    edit.eraseSCREEN
    edit.Refrescar
End Sub

Private Sub edit_LlegoPrompt(nlin1 As Long, nlin2 As Long)
'Responde al evento de llegada del prompt.
'Debe estar activado el reconocimiento de prompt
    LlegoPrompt = True
    linPrompt1 = nlin1
    linPrompt2 = nlin2
End Sub

Public Function EnviaComando(com As String, _
    Optional nini As Integer = 1, _
    Optional nfin As Integer = 1) As String
'Funcin para enviar un comando por el Terminal.
'Espera hasta que aparezca del nuevo el "prompt" y devuelve el
'texto generado por el comando.
'Permite eliminar lneas iniciales y finales.
Const DEC_DESB = 600    'tiempo en mltiplos de 50mseg
Dim i As Integer
Dim n As Long
Dim tmp As String
    'Es necesario tener los datos nuevos en pantalla porque las
    'rutinas que leen el prompt usas la rutina que dibuja la lnea.
    Call edit.EnganCursorEdit
    'Lanzar comando.
    LlegoPrompt = False
    SendData com & Chr(13)
    'Espera hasta la aparicin del "prompt"
    n = 0
    While Not LlegoPrompt And n < DEC_DESB
        Sleep 50
        DoEvents    'procesa
        n = n + 1
    Wend
    If n >= DEC_DESB Then    'Hubo desborde
        MsgBox "Tiempo de espera agotado", vbExclamation
        Exit Function
    End If
    EnviaComando = edit.TextLineas(linPrompt1 + nini, linPrompt2 - nfin)
End Function

Public Function RemoteHost() As String
'Devuelve la IP actual
    RemoteHost = Winsock1.RemoteHost
End Function
