VERSION 5.00
Begin VB.UserControl ctlSelColor 
   ClientHeight    =   345
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   1545
   ScaleHeight     =   345
   ScaleWidth      =   1545
   Begin VB.CommandButton Command1 
      Height          =   330
      Left            =   120
      Style           =   1  'Graphical
      TabIndex        =   0
      Top             =   0
      Width           =   1215
   End
End
Attribute VB_Name = "ctlSelColor"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Public Event CambiaColor(col As Long)

' Funcin <b style="color:black;background-color:#ff9999">Api</b> CHOOSECOLOR
Private Declare Function CHOOSECOLOR Lib "comdlg32.dll" Alias "ChooseColorA" ( _
                                            pChoosecolor As CHOOSECOLOR) As Long
                                               
' Estructura CHOOSECOLOR para configurar el cuadro de dilogo
Private Type CHOOSECOLOR
    lStructSize As Long
    hwndOwner As Long
    hInstance As Long
    rgbResult As Long
    lpCustColors As String
    flags As Long
    lCustData As Long
    lpfnHook As Long
    lpTemplateName As String
End Type

Private mColor  As Long
Public habilitado As Boolean

Public Property Get BackColor() As Long
    BackColor = Command1.BackColor
End Property

Public Property Let BackColor(ByVal vNewValue As Long)
    If vNewValue < 0 Then Exit Property
    Command1.BackColor = vNewValue
End Property

Public Property Get color() As Long
    color = mColor
End Property

Public Property Let color(ByVal vNewValue As Long)
    If vNewValue < 0 Then Exit Property
    Command1.BackColor = vNewValue
    mColor = vNewValue
End Property

Private Sub Command1_Click()
    mColor = Abrir_CommonDialog_Color(Command1.BackColor)
    If mColor = -1 Then Exit Sub    'Si cancel devuelve -1
    
    'Actualiza apariencia y dispara evento
    Command1.BackColor = mColor
    RaiseEvent CambiaColor(mColor)
End Sub

Private Function Abrir_CommonDialog_Color(colini As Long) As Long
    ' Array de tipo Byte dinmico
    Dim CustomColors() As Byte
    ' Variable para utilizar la estructura
    Dim cc As CHOOSECOLOR
    'array de tipo Long
    Dim Custcolor(16) As Long
    'Variable de retorno
    Dim lReturn As Long
  
    'Establecemos el tamao de la extructura
    cc.lStructSize = Len(cc)
    'Le pasamos el hwnd del form a cc
    cc.hwndOwner = UserControl.hWnd
    'Establecemos la instancia de nuestra aplicacin a cc.Hinstance
    cc.hInstance = App.hInstance
    'Establecemos los <b style="color:black;background-color:#99ff99">colores</b> convertidos a Unicode
    cc.lpCustColors = StrConv(CustomColors, vbUnicode)
    'El flag a 0 dialogo normal, en 2 dialogo completo
    cc.flags = 2
cc.rgbResult = colini
    
    'Mostramos el Cuadro de dilogo
    If CHOOSECOLOR(cc) <> 0 Then
        'Retornamos a nuestra funcin el valor elegido
        Abrir_CommonDialog_Color = cc.rgbResult
        'Para los <b style="color:black;background-color:#99ff99">colores</b> personalizados
        CustomColors = StrConv(cc.lpCustColors, vbFromUnicode)
    Else
        Abrir_CommonDialog_Color = -1
    End If
End Function

Public Sub habilitar()
    habilitado = True
End Sub

Public Sub deshabilitar()
    habilitado = False
End Sub

Private Sub UserControl_Initialize()
    habilitado = True
End Sub

Private Sub UserControl_Resize()
    Command1.Left = 0
    Command1.Top = 0
    Command1.Width = UserControl.ScaleWidth
    Command1.Height = UserControl.ScaleHeight
End Sub
